<?php
/**
  Plugin Name: ARForms - Digital Download Add-on
  Description: Extension for Arforms plugin to for download digital products. ( This plugin will work with ARForms plugin only.)
  Version: 2.4
  Plugin URI: http://www.arformsplugin.com/
  Author: Repute InfoSystems
  Author URI: http://reputeinfosystems.com/
  Text Domain: ARForms-Digital-Product
 */

if ( ! defined( 'ARF_DIG_PRO_DIR' ) ) {
	define( 'ARF_DIG_PRO_DIR', WP_PLUGIN_DIR . '/arformsdigitalproduct' );
}

$arfsiteurl = home_url();
if ( is_ssl() && ( ! preg_match( '/^https:\/\/.*\..*$/', $arfsiteurl ) || ! preg_match( '/^https:\/\/.*\..*$/', WP_PLUGIN_URL ) ) ) {
	$arfsiteurl = str_replace( 'http://', 'https://', $arfsiteurl );
	define( 'ARF_DIG_PRO_URL', str_replace( 'http://', 'https://', WP_PLUGIN_URL . '/arformsdigitalproduct' ) );
} else {
	define( 'ARF_DIG_PRO_URL', WP_PLUGIN_URL . '/arformsdigitalproduct' );
}

load_plugin_textdomain( 'ARForms-Digital-Product', false, 'arformsdigitalproduct/languages/' );

if ( ! defined( 'ARF_DIG_PRO_CLASSES_DIR' ) ) {
	define( 'ARF_DIG_PRO_CLASSES_DIR', ARF_DIG_PRO_DIR . '/core/classes' );
}

if ( ! defined( 'ARF_DIG_PRO_CLASSES_URL' ) ) {
	define( 'ARF_DIG_PRO_CLASSES_URL', ARF_DIG_PRO_URL . '/core/classes' );
}

if ( ! defined( 'ARF_DIG_PRO_VIEWS_DIR' ) ) {
	define( 'ARF_DIG_PRO_VIEWS_DIR', ARF_DIG_PRO_DIR . '/core/views' );
}

if ( ! defined( 'ARF_PRODUCT_SLUG' ) ) {
	define( 'ARF_PRODUCT_SLUG', 'arf_product' );
}

if ( ! defined( 'FS_METHOD' ) ) {
	define( 'FS_METHOD', 'direct' );
}

global $arf_digital_product, $arfajaxurl;
$arf_digital_product = new ARF_Digital_Product();


global $arf_dig_pro_version;
$arf_dig_pro_version = '2.4';

global $arf_dig_pro_assets_version;
$arf_dig_pro_assets_version = $arf_dig_pro_version . '_' . rand( 1, 100 );

global $arformsdigitalproductshortname;
$arformsdigitalproductshortname = 'ARFDIGPRO';

global $arf_download_loaded;
$arf_download_loaded = array();

global $wpdb;
global $arf_digital_product_tbl,$arf_digital_product_download_tbl,$arf_digital_product_download_log_tbl;
$arf_digital_product_tbl              = $wpdb->prefix . 'arf_digital_product';
$arf_digital_product_download_tbl     = $wpdb->prefix . 'arf_digital_product_download';
$arf_digital_product_download_log_tbl = $wpdb->prefix . 'arf_digital_product_download_log';

if ( file_exists( ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_product.php' ) ) {
	require_once ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_product.php';
}


if ( file_exists( ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_user_product.php' ) ) {
	require_once ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_user_product.php';
}

if ( file_exists( ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_process_download.php' ) ) {
	require_once ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_process_download.php';
}


if ( file_exists( ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_editor_product.php' ) ) {
	require_once ARF_DIG_PRO_CLASSES_DIR . '/class.arf_dig_pro_editor_product.php';
}

if ( $arf_digital_product->check_arforms_support() ) {

	global $arf_dig_pro_products_class, $arf_dig_pro_user_products_class, $arf_dig_pro_download_process_class, $arf_dig_pro_editor_product_class;

	$arf_dig_pro_products_class         = new arf_dig_pro_products();
	$arf_dig_pro_user_products_class    = new arf_dig_pro_user_products();
	$arf_dig_pro_download_process_class = new arf_dig_pro_download_process();
	$arf_dig_pro_editor_product_class   = new arf_dig_pro_editor_product();


	global $arf_dig_pro_field_class_name, $arf_dig_pro_new_field_data, $arf_dig_pro_field_image_path;

	$arf_dig_pro_field_image_path = array( ARF_PRODUCT_SLUG => ARF_DIG_PRO_URL . '/images/arf_product_icon.png' );
	$arf_dig_pro_field_class_name = array( ARF_PRODUCT_SLUG => 'red' );
	$arf_dig_pro_new_field_data   = array( ARF_PRODUCT_SLUG => esc_html__( 'Download', 'ARForms-Digital-Product' ) );
	$arf_dig_pro_total_class      = array();
}

$wp_upload_dir   = wp_upload_dir();
$imageupload_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';

if ( ! is_dir( $imageupload_dir ) ) {
	wp_mkdir_p( $imageupload_dir );
}

class ARF_Digital_Product {

	function __construct() {

		global $arf_version;
		$arf_version = $this->get_arforms_version();

		register_activation_hook( __FILE__, array( 'ARF_Digital_Product', 'install' ) );

		register_activation_hook( __FILE__, array( 'ARF_Digital_Product', 'arf_dig_pro_check_network_activation' ) );

		register_uninstall_hook( __FILE__, array( 'ARF_Digital_Product', 'uninstall' ) );

		if( !function_exists('is_plugin_active') ){
			include_once ABSPATH . 'wp-admin/includes/plugin.php';
		}

		if( is_plugin_active( 'arforms/arforms.php') ){

			add_action( 'admin_menu', array( $this, 'arf_dig_pro_menu' ), 27 );

			add_action( 'admin_enqueue_scripts', array( $this, 'arf_set_js' ), 11 );

			add_action( 'admin_enqueue_scripts', array( $this, 'arf_set_css' ), 11 );

			add_action( 'wp_ajax_arf_dig_pro_delete_product', array( $this, 'arf_dig_pro_delete_product' ) );

			add_action( 'wp_ajax_arf_dig_pro_form_bulk_act', array( $this, 'arf_dig_pro_form_bulk_act' ) );

			add_action( 'admin_notices', array( $this, 'arf_dig_pro_admin_notices' ) );

			add_action( 'init', array( $this, 'arf_dig_pro_generate_htaccess' ) );

			add_action( 'admin_init', array( $this, 'upgrade_data' ) );

			add_filter( 'arf_wrap_input_field', array( $this, 'arf_wrap_input_field_digital_product' ), 10, 2 );

			add_action( 'wp_arf_footer', array( $this, 'arf_dig_pro_set_front_js_v3' ), 11, 1 );

			add_action( 'user_register', array( $this, 'arf_add_capabilities_to_new_user' ) );

			add_action( 'wp_ajax_arf_save_dig_pro_setting', array( $this, 'arf_save_dig_pro_setting_callback' ) );

			add_action( 'wp_ajax_arf_retrieve_dig_pro_product_data', array( $this, 'arf_retrieve_dig_pro_product_data' ) );

			add_action( 'wp_ajax_arf_retrieve_dig_pro_product_download_data', array( $this, 'arf_retrieve_dig_pro_product_download_data' ) );
		}

	}

	function arf_retrieve_dig_pro_product_download_data(){
			global $wpdb, $MdlDb, $arfform, $arf_version, $arf_digital_product_tbl, $arf_digital_product_download_tbl, $arf_dig_pro_user_products_class;

			$requested_data = arf_json_decode( stripslashes_deep( $_REQUEST['data'] ), true );

			$filtered_aoData  = $requested_data['aoData'];

			$return_data = array();

			$order_by = !empty( $filtered_aoData['iSortCol_0'] ) ? $filtered_aoData['iSortCol_0'] : 1;

			$order_by_str = 'ORDER BY';

			if( 1 == $order_by ){
	        $order_by_str .= ' D.id';
	    } else if( 2 == $order_by ){
	        $order_by_str .= ' D.product_id';
	    } else if( 3 == $order_by ){
	        $order_by_str .= ' D.form_id';
	    } else if( 4 == $order_by ){
	        $order_by_str .= ' D.entry_id';
	    } else if( 5 == $order_by ){
	        $order_by_str .= ' D.created_at';
	    } else {
	        $order_by_str .= ' D.id';
	    }
			
	    $order_by_str .=  ' ' . ( !empty( $filtered_aoData['sSortDir_0'] ) ? strtoupper($filtered_aoData['sSortDir_0']) : 'DESC' );
	    
	    $form_params = 'D.*,P.options';
	    //$group_by_param = 'GROUP BY dig_pro.id';

	    $offset = isset($filtered_aoData['iDisplayStart']) ? $filtered_aoData['iDisplayStart'] : 0;
	    $limit = isset($filtered_aoData['iDisplayLength']) ? $filtered_aoData['iDisplayLength'] : 10;

	    $limit_param = 'LIMIT '.$offset.', '.$limit;

	   	$where_clause = "WHERE D.id != '' " ;
	    $where_params = array();

	    if( !empty( $filtered_aoData['sSearch'] ) ){
	        $wild = '%';
	        $find = trim( $filtered_aoData['sSearch'] );
	        $like = $wild . $wpdb->esc_like( $find ) . $wild;
	        $where_clause .= ' AND ( D.id LIKE %s )  OR D.form_id LIKE %s OR D.product_id LIKE %s OR D.entry_id LIKE %s';
	        $where_params[0] = $like;
	        $where_params[1] = $like;
	        $where_params[2] = $like;
	        $where_params[3] = $like;
	    }

			$as___payment = array();

			if( version_compare( $arf_version, '4.3', '<' ) ){

				$downloads    = $wpdb->get_results( 'SELECT D.*,P.options FROM ' . $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id ORDER BY D.id DESC' );
			}else{
				$tblnm = $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id';
			/* 	$downloads = $arfform->arf_select_db_data( true, '', $tblnm, 'D.*,P.options', '', array(), '', 'ORDER BY D.id DESC'); */
				 $downloads = $arfform->arf_select_db_data( true, '', $tblnm, $form_params, $where_clause, $where_params, '', $order_by_str, $limit_param );
			}
			
			$total_records = $arfform->arf_select_db_data( true, '', $arf_digital_product_download_tbl . ' D' , 'COUNT( D.id )',$where_clause, $where_params, '', '', '', true );

			$data = array();
			if ( count( $downloads ) > 0 ) {
				
				$ai = 0;
		    foreach ( $downloads as $download ) {
		    	$options      = maybe_unserialize( $download->options );

					$as___payment = $arf_dig_pro_user_products_class->arf_dig_pro_get_user_payment_detail( $download->payment_options, $download->form_id, $download->entry_id, $download->id );

		
		   		$data[$ai][0] = "<div class='arf_custom_checkbox_div arf_digpro_row'>
															<div class='arf_custom_checkbox_wrapper'>
																<input id='cb-item-action-'".esc_html( $download->id )."' class='' type='checkbox' value=".esc_html( $download->id )." name='item-action[]'>
																<svg width='18px' height='18px'>".ARF_CUSTOM_UNCHECKED_ICON.ARF_CUSTOM_CHECKED_ICON."
																</svg>
															</div>
														</div>
														<label for='cb-item-action-'".esc_attr($download->id)."><span></span></label>";

					$data[$ai][1] = esc_html( $download->id );
					$data[$ai][2] = esc_html( $download->product_id );
					$data[$ai][3] = esc_html( $download->form_id ); 
					
							
					$data[$ai][4]  = esc_html( $download->entry_id );

					$data[$ai][5] = isset( $as___payment[ $download->id ]['txn_id'] ) ? esc_html( $as___payment[ $download->id ]['txn_id'] ) : '';

					$data[$ai][6] = "<a class='row-title' href=".esc_url( wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id={$download->product_id}" ) ).">".esc_attr( $options['arf_product_name'] )."</a>";

					$data[$ai][7] = isset( $as___payment[ $download->id ]['payment_type'] ) ? esc_html( $as___payment[ $download->id ]['payment_type'] ) : '';

					$data[$ai][8] = isset( $as___payment[ $download->id ]['payment_method'] ) ? esc_html( $as___payment[ $download->id ]['payment_method'] ) : '';

					$data[$ai][9] = isset( $as___payment[ $download->id ]['total_amount'] ) ? esc_html ( $as___payment[ $download->id ]['total_amount'] ) . '&nbsp;' . esc_html( $as___payment[ $download->id ]['currency'] ) : '';

					$data[$ai][10] = ( isset( $as___payment[ $download->id ]['payment_status'] ) && isset( $as___payment[ $download->id ]['currency'] ) ) ? esc_html( $as___payment[ $download->id ]['payment_status'] ) : '';

					$data[$ai][11] = date( get_option( 'date_format' ), strtotime( $download->created_at ) );

					$action_row_data = "<div class='arf-row-actions'>";

				  $action_row_data .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'View Entry', 'ARForms-Digital-Product' ) . "'><a href='javascript:void(0);' onclick='open_entry_thickbox({$download->id});'><svg width='30px' height='30px' viewBox='-3 -8 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M12.993,15.23c-7.191,0-11.504-7.234-11.504-7.234  S5.801,0.85,12.993,0.85c7.189,0,11.504,7.19,11.504,7.19S20.182,15.23,12.993,15.23z M12.993,2.827  c-5.703,0-8.799,5.214-8.799,5.214s3.096,5.213,8.799,5.213c5.701,0,8.797-5.213,8.797-5.213S18.694,2.827,12.993,2.827z   M12.993,11.572c-1.951,0-3.531-1.581-3.531-3.531s1.58-3.531,3.531-3.531c1.949,0,3.531,1.581,3.531,3.531  S14.942,11.572,12.993,11.572z'/></svg></a></div>";

				  $action_row_data .= "<div class='arfformicondiv arfhelptip arfdeleteentry_div_" . $download->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  data-id='" . $download->id . "' class='arfformentry_delete arf_digpro_cursor_pointer'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

				  $action_row_data .= "<div id='view_entry_detail_container_{$download->id}' class='arf_display_none'>" . $arf_dig_pro_user_products_class->arf_dig_pro_get_download_history_entries_list( $download, $as___payment ) . "</div><div class='arfmnarginbtm10 arf_digpro_clear_both'></div>";
				 

				  $action_row_data .= "</div>";
				  $data[$ai][12] = $action_row_data ;
          $ai++;
		   	}

		   	$sEcho = isset($filtered_aoData['sEcho']) ? intval($filtered_aoData['sEcho']) : intval(10);

	      $return_data = array(
					'sEcho' => $sEcho,
					'iTotalRecords' => (int)$total_records,
					'iTotalDisplayRecords' => (int)$total_records,
					'aaData' => $data,
	      );

		  } else {
		  	$sEcho = isset($filtered_aoData['sEcho']) ? intval($filtered_aoData['sEcho']) : intval(10);
				$return_data = array(
						'sEcho' => $sEcho,
						'iTotalRecords' => (int)$total_records,
						'iTotalDisplayRecords' => (int)$total_records,
						'aaData' => $data,
				);
		  }

		  echo json_encode( $return_data );
      die;
	}

	function arf_retrieve_dig_pro_product_data(){

			global $wpdb, $MdlDb, $arfform, $arf_version, $arf_digital_product_download_tbl;

			$requested_data = arf_json_decode( stripslashes_deep( $_REQUEST['data'] ), true );

			$filtered_aoData  = $requested_data['aoData'];

			$return_data = array();

			$order_by = !empty( $filtered_aoData['iSortCol_0'] ) ? $filtered_aoData['iSortCol_0'] : 1;

			$order_by_str = 'ORDER BY';

			if( 1 == $order_by ){
	        $order_by_str .= ' dig_pro.id';
	    } else if( 3 == $order_by ){
	        $order_by_str .= ' total_sales';
	    } else if( 4 == $order_by ){
	        $order_by_str .= ' dig_pro.status';
	    } else if( 5 == $order_by ){
	        $order_by_str .= ' dig_pro.created_at';
	    } else {
	        $order_by_str .= ' dig_pro.id';
	    }
			
	    $order_by_str .=  ' ' . ( !empty( $filtered_aoData['sSortDir_0'] ) ? strtoupper($filtered_aoData['sSortDir_0']) : 'DESC' );

	    //$form_params = 'arfrm.*,SUM(ord.mc_gross) as total_amount, COUNT(ord.form_id) as total_entries';
	    $form_params = 'dig_pro.*,COUNT(p_detail.product_id) AS total_sales';
	    $group_by_param = 'GROUP BY dig_pro.id';

	    $offset = isset($filtered_aoData['iDisplayStart']) ? $filtered_aoData['iDisplayStart'] : 0;
	    $limit = isset($filtered_aoData['iDisplayLength']) ? $filtered_aoData['iDisplayLength'] : 10;

	    $limit_param = 'LIMIT '.$offset.', '.$limit;

	   	$where_clause = "WHERE dig_pro.id != '' " ;
	    $where_params = array();

	    if( !empty( $filtered_aoData['sSearch'] ) ){
	        $wild = '%';
	        $find = trim( $filtered_aoData['sSearch'] );
	        $like = $wild . $wpdb->esc_like( $find ) . $wild;
	        $where_clause .= ' AND ( dig_pro.id LIKE %s )';
	        $where_params[0] = $like;

	        /*$get_all_inner_fields = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM `".$wpdb->prefix .' arf_digital_product'."` WHERE (options LIKE '%\"arf_product_name\":\"%s\"%') ", $find ), ARRAY_A );*/
	        //$products = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'arf_digital_product WHERE id=31' );
	    }
		

			if( version_compare( $arf_version, '4.3', '<' ) ){
				$products = $wpdb->get_results( 'SELECT * FROM ' . $wpdb->prefix . 'arf_digital_product ORDER BY id DESC' );
			}else{
				 /* $products = $arfform->arf_select_db_data( true, '', $wpdb->prefix . 'arf_digital_product dig_pro', 'dig_pro.*', '', array(), '', 'ORDER BY id DESC'); */
				 $product_table =  $wpdb->prefix . 'arf_digital_product dig_pro LEFT JOIN ' . $arf_digital_product_download_tbl . ' p_detail ON dig_pro.id = p_detail.product_id';
				 $products = $arfform->arf_select_db_data( true, '', $product_table , $form_params, $where_clause, $where_params,$group_by_param, $order_by_str, $limit_param);
			}

			
			$total_records = $arfform->arf_select_db_data( true, '', $wpdb->prefix . 'arf_digital_product'. ' dig_pro', 'COUNT( dig_pro.id )',$where_clause, $where_params, '', '', '', true );

			$data = array();
			if( count($products) > 0 ){
				
				$ai = 0;
		    foreach ( $products as $product ) {
		    	$options = maybe_unserialize( $product->options );
		
		   		$data[$ai][0] = "<div class='arf_custom_checkbox_div arf_digpro_row'>
														<div class='arf_custom_checkbox_wrapper'>
															<input id='cb-item-action-'".esc_attr( $product->id )."' class='' type='checkbox' value=".esc_attr( $product->id )." name='item-action[]'>
															<svg width='18px' height='18px'>".ARF_CUSTOM_UNCHECKED_ICON.ARF_CUSTOM_CHECKED_ICON."
															</svg>
														</div>
													</div>
													<label for='cb-item-action'".esc_attr( $product->id ) ."'><span></span></label>";

					$data[$ai][1] = esc_html( $product->id );
					$data[$ai][2] = "<a class='row-title' href=".esc_url( wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id=".$product->id ) ).">".esc_attr( $options['arf_product_name'] )."</a>";
					$data[$ai][3] = esc_html( $product->total_sales );
					
							
					$data[$ai][4]  = ( $product->status == 1 ) ? esc_html__( 'Enable', 'ARForms-Digital-Product' ) : esc_html__( 'Disable', 'ARForms-Digital-Product' );

					$data[$ai][5] = date( get_option( 'date_format' ), strtotime( $product->created_at ) );
					
					$edit_link = "?page=ARForms-DigitalProduct&arfaction=edit&id={$product->id}";

					$action_row_data = "<div class='arf-row-actions'>";

				  $action_row_data .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Product', 'ARForms-Digital-Product' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";

				  $action_row_data .= "<div class='arfformicondiv arfhelptip  arfdeleteform_div_" . $product->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  id='delete_product'  data-id='" . $product->id . "' class='arfdeleteproduct arf_digpro_cursor_pointer'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";
				 

				  $action_row_data .= "</div>";
				  $data[$ai][6] = $action_row_data ;
          $ai++;
		   	}

		   	$sEcho = isset($filtered_aoData['sEcho']) ? intval($filtered_aoData['sEcho']) : intval(10);

	      $return_data = array(
					'sEcho' => $sEcho,
					'iTotalRecords' => (int)$total_records,
					'iTotalDisplayRecords' => (int)$total_records,
					'aaData' => $data,
	      );

		  } else {
		  	$sEcho = isset($filtered_aoData['sEcho']) ? intval($filtered_aoData['sEcho']) : intval(10);
				$return_data = array(
						'sEcho' => $sEcho,
						'iTotalRecords' => (int)$total_records,
						'iTotalDisplayRecords' => (int)$total_records,
						'aaData' => $data,
				);
		  }

		  echo json_encode( $return_data );
      die;
	}

	public static function arf_dig_pro_check_network_activation( $network_wide ) {
		if ( ! $network_wide ) {
			return;
		}

		deactivate_plugins( plugin_basename( __FILE__ ), true, true );

		header( 'Location: ' . network_admin_url( 'plugins.php?deactivate=true' ) );
		exit;
	}

	function arf_add_capabilities_to_new_user( $user_id ) {
		if ( $user_id == '' ) {
			return;
		}

		if ( user_can( $user_id, 'administrator' ) ) {
			$arf_dig_pro_capabilities = array(
				'arf_dig_pro_configuration' => esc_html__( 'Configure Digital Product Download', 'ARForms-Digital-Product' ),
				'arf_dig_pro_download_log'  => esc_html__( 'View Digital Product Download Log', 'ARForms-Digital-Product' ),
			);

			$arfroles = $arf_dig_pro_capabilities;

			$userObj = new WP_User( $user_id );
			foreach ( $arfroles as $arfrole => $arfroledescription ) {
				$userObj->add_cap( $arfrole );
			}
			unset( $arfrole );
			unset( $arfroles );
			unset( $arfroledescription );
		}
	}

	function arf_dig_pro_set_front_js() {
		global $arf_digital_product, $arf_dig_pro_assets_version;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}

		global $arfforms_loaded, $arf_download_loaded;
		wp_register_script( 'arf_dig_pro_front_js', ARF_DIG_PRO_URL . '/js/arf_dig_pro_front.js', array(), $arf_dig_pro_assets_version );

		if ( ! is_admin() && ! empty( $arfforms_loaded ) && ! empty( $arf_download_loaded ) ) {
			wp_enqueue_script( 'arf_dig_pro_front_js' );
		}
	}
	function arf_dig_pro_set_front_js_v3( $loaded_field ) {
		global $arf_digital_product, $arf_dig_pro_assets_version;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}

		global $arfforms_loaded;
		if ( isset( $loaded_field ) && in_array( 'arf_product', $loaded_field ) ) {
			 wp_register_script( 'arf_dig_pro_front_js', ARF_DIG_PRO_URL . '/js/arf_dig_pro_front.js', array(), $arf_dig_pro_assets_version );

			wp_enqueue_script( 'arf_dig_pro_front_js' );
		}
	}

	public static function install() {
		global $arf_digital_product,$arf_digital_product_tbl,$arf_digital_product_download_tbl,$arf_digital_product_download_log_tbl;
		$arf_dig_pro_version = get_option( 'arf_dig_pro_version' );

		if ( ! isset( $arf_dig_pro_version ) || $arf_dig_pro_version == '' ) {

			global $wpdb, $arf_dig_pro_version;

			update_option( 'arf_dig_pro_version', $arf_dig_pro_version );

			$charset_collate = '';
			if ( ! empty( $wpdb->charset ) ) {
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
			}

			if ( ! empty( $wpdb->collate ) ) {
				$charset_collate .= " COLLATE $wpdb->collate";
			}

			if ( file_exists( ABSPATH . 'wp-admin/includes/upgrade.php' ) ) {
				require_once ABSPATH . 'wp-admin/includes/upgrade.php';
			}

			$table_name = $arf_digital_product_tbl;

			$sql = "CREATE TABLE {$table_name} (

					id int(11) NOT NULL auto_increment,

					form_id int(11) NOT NULL,

                    category_id int(11) NOT NULL,

					form_name varchar(255) default NULL,

					options longtext default NULL,

					status tinyint(1) default 0,

					created_at datetime NOT NULL,

					PRIMARY KEY (id)

				  ) {$charset_collate};";

			dbDelta( $sql );

			$download_table_name = $arf_digital_product_download_tbl;

			$download_sql = "CREATE TABLE {$download_table_name}(

					id int(11) NOT NULL auto_increment,

					product_id int(11) NOT NULL,

					form_id int(11) NOT NULL,

					entry_id int(11) NOT NULL,

					is_submit tinyint(1) default 0,

                    options longtext default NULL,

                    payment_options longtext default NULL,

					created_at datetime NOT NULL,

					PRIMARY KEY (id)

				  ) {$charset_collate};";

			dbDelta( $download_sql );
			$download_log_table_name = $arf_digital_product_download_log_tbl;

			$download_log_sql = "CREATE TABLE {$download_log_table_name}(

              id int(11) NOT NULL auto_increment,

              product_id int(11) NOT NULL,

              download_id int(11) NOT NULL,

              entry_id int(11) NOT NULL,

              token longtext default NULL,

              total_download varchar(255) default NULL,

              created_at datetime NOT NULL,

              PRIMARY KEY (id)

              ) {$charset_collate};";

			dbDelta( $download_log_sql );

			$arf_digital_product->getwpversion();
		}
		$args  = array(
			'role'   => 'administrator',
			'fields' => 'id',
		);
		$users = get_users( $args );
		if ( count( $users ) > 0 ) {
			foreach ( $users as $key => $user_id ) {

				$arf_dig_pro_capabilities = array(
					'arf_dig_pro_configuration' => esc_html__( 'Configure Digital Product Download', 'ARForms-Digital-Product' ),
					'arf_dig_pro_download_log'  => esc_html__( 'View Digital Product Download Log', 'ARForms-Digital-Product' ),
				);

				$arfroles = $arf_dig_pro_capabilities;

				$userObj = new WP_User( $user_id );
				foreach ( $arfroles as $arfrole => $arfroledescription ) {
					$userObj->add_cap( $arfrole );
				}
				unset( $arfrole );
				unset( $arfroles );
				unset( $arfroledescription );
			}
		}
	}
	public static function getwpversion() {
		global $arf_digital_product;
		$bloginformation = array();
		$str             = $arf_digital_product->get_rand_alphanumeric( 10 );

		$bloginformation[] = get_bloginfo( 'name' );
		$bloginformation[] = get_bloginfo( 'description' );
		$bloginformation[] = home_url();
		$bloginformation[] = get_bloginfo( 'admin_email' );
		$bloginformation[] = get_bloginfo( 'version' );
		$bloginformation[] = get_bloginfo( 'language' );
		$bloginformation[] = get_option( 'arf_dig_pro_version' );
		$bloginformation[] = $_SERVER['SERVER_ADDR'];
		$bloginformation[] = $str;

		update_option( 'wp_download_get_version', $str );

		$valstring  = implode( '||', $bloginformation );
		$encodedval = base64_encode( $valstring );

		$urltopost = 'http://reputeinfosystems.net/arforms/wpinfo_digital_product.php';
		$response  = wp_remote_post(
			$urltopost,
			array(
				'method'      => 'POST',
				'timeout'     => 45,
				'redirection' => 5,
				'httpversion' => '1.0',
				'blocking'    => true,
				'headers'     => array(),
				'body'        => array( 'wpversion' => $encodedval ),
				'cookies'     => array(),
			)
		);
	}
	function assign_rand_value( $num ) {
		switch ( $num ) {
			case '1':
				$rand_value = 'a';
				break;
			case '2':
				$rand_value = 'b';
				break;
			case '3':
				$rand_value = 'c';
				break;
			case '4':
				$rand_value = 'd';
				break;
			case '5':
				$rand_value = 'e';
				break;
			case '6':
				$rand_value = 'f';
				break;
			case '7':
				$rand_value = 'g';
				break;
			case '8':
				$rand_value = 'h';
				break;
			case '9':
				$rand_value = 'i';
				break;
			case '10':
				$rand_value = 'j';
				break;
			case '11':
				$rand_value = 'k';
				break;
			case '12':
				$rand_value = 'l';
				break;
			case '13':
				$rand_value = 'm';
				break;
			case '14':
				$rand_value = 'n';
				break;
			case '15':
				$rand_value = 'o';
				break;
			case '16':
				$rand_value = 'p';
				break;
			case '17':
				$rand_value = 'q';
				break;
			case '18':
				$rand_value = 'r';
				break;
			case '19':
				$rand_value = 's';
				break;
			case '20':
				$rand_value = 't';
				break;
			case '21':
				$rand_value = 'u';
				break;
			case '22':
				$rand_value = 'v';
				break;
			case '23':
				$rand_value = 'w';
				break;
			case '24':
				$rand_value = 'x';
				break;
			case '25':
				$rand_value = 'y';
				break;
			case '26':
				$rand_value = 'z';
				break;
			case '27':
				$rand_value = '0';
				break;
			case '28':
				$rand_value = '1';
				break;
			case '29':
				$rand_value = '2';
				break;
			case '30':
				$rand_value = '3';
				break;
			case '31':
				$rand_value = '4';
				break;
			case '32':
				$rand_value = '5';
				break;
			case '33':
				$rand_value = '6';
				break;
			case '34':
				$rand_value = '7';
				break;
			case '35':
				$rand_value = '8';
				break;
			case '36':
				$rand_value = '9';
				break;
		}
		return $rand_value;
	}

	function get_rand_alphanumeric( $length ) {
		global $arf_digital_product;
		if ( $length > 0 ) {
			$rand_id = '';
			for ( $i = 1; $i <= $length; $i++ ) {
				mt_srand( (float) microtime() * 1000000 );
				$num      = mt_rand( 1, 36 );
				$rand_id .= $arf_digital_product->assign_rand_value( $num );
			}
		}
		return $rand_id;
	}
	public static function uninstall() {
		global $wpdb,$arf_digital_product_download_log_tbl,$arf_digital_product_download_tbl,$arf_digital_product_tbl;
		if ( is_multisite() ) {
			$blogs = $wpdb->get_results( "SELECT blog_id FROM {$wpdb->blogs}", ARRAY_A );
			if ( $blogs ) {
				foreach ( $blogs as $blog ) {
					switch_to_blog( $blog['blog_id'] );
					delete_option( 'arf_dig_pro_version' );
					$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_tbl );
					$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_download_tbl );
					$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_download_log_tbl );
				}
				restore_current_blog();
			}
		} else {
			delete_option( 'arf_dig_pro_version' );
			$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_tbl );
			$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_download_tbl );
			$wpdb->query( 'DROP TABLE IF EXISTS ' . $arf_digital_product_download_log_tbl );
		}
	}
	function route() {
		global $arf_digital_product;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}
		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] == 'ARForms-DigitalProduct' && isset( $_REQUEST['arfaction'] ) && ( $_REQUEST['arfaction'] == 'new' || $_REQUEST['arfaction'] == 'edit' ) ) {
			return $arf_digital_product->edit_product_v3();
		} elseif ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] == 'ARForms-ProductDownload' ) {
			return $arf_digital_product->download_product();
		} else {
			return $arf_digital_product->list_products();
		}
	}
	function arf_dig_pro_menu() {
		global $arf_digital_product;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}
		global $arfsettings;
		add_submenu_page( 'ARForms', 'ARForms | ' . esc_html__( 'Manage Products', 'ARForms-Digital-Product' ), esc_html__( 'Manage Products', 'ARForms-Digital-Product' ), 'arf_dig_pro_configuration', 'ARForms-DigitalProduct', array( $this, 'route' ) );

		add_submenu_page( 'ARForms', 'ARForms | ' . esc_html__( 'Download History', 'ARForms-Digital-Product' ), esc_html__( 'Download History', 'ARForms-Digital-Product' ), 'arf_dig_pro_download_log', 'ARForms-ProductDownload', array( $this, 'route' ) );
	}
	function arf_set_js() {
		global $arf_digital_product,$arf_dig_pro_assets_version;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}

		wp_register_script( 'arf-dig-pro-js', ARF_DIG_PRO_URL . '/js/arf_dig_pro.js', array( 'jquery' ), $arf_dig_pro_assets_version );

		if( version_compare( $this->get_arforms_version(), '5.6', '<' ) ){
			wp_register_script( 'bootstrap', ARFURL . '/bootstrap/js/bootstrap.min.js', array( 'jquery' ), $arf_dig_pro_assets_version );
			wp_register_script( 'bootstrap-select', ARFURL . '/bootstrap/js/bootstrap-select.js', array('jquery'), $arf_dig_pro_assets_version );
		}

		wp_register_script( 'tipso', ARFURL . '/js/tipso.min.js', array( 'jquery' ), $arf_dig_pro_assets_version );
	
		if( version_compare( $this->get_arforms_version(), '4.2', '<' ) ){
			wp_register_script( 'dataTable', ARFURL . '/datatables/media/js/jquery.dataTables.js', array(), $arf_dig_pro_assets_version );

			wp_register_script( 'ColVis', ARFURL . '/datatables/media/js/ColVis.js', array(), $arf_dig_pro_assets_version );

			wp_register_script( 'FixedColumns', ARFURL . '/datatables/media/js/FixedColumns.js', array(), $arf_dig_pro_assets_version );
		}

		wp_register_script( 'arf-dig-editor-js', ARF_DIG_PRO_URL . '/js/arf_dig_editor.js', array( 'jquery' ), $arf_dig_pro_assets_version );

		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && ( $_REQUEST['page'] == 'ARForms-DigitalProduct' || $_REQUEST['page'] == 'ARForms-ProductDownload' ) ) {
			wp_enqueue_script( 'jquery' );

			wp_enqueue_script( 'arf-dig-pro-js' );

			if( version_compare( $this->get_arforms_version(), '5.6', '<' ) ){

				wp_enqueue_script( 'bootstrap' );

				wp_enqueue_script( 'bootstrap-select' );
			}


			if( version_compare( $this->get_arforms_version(), '4.2', '<' ) ){

				wp_enqueue_script( 'dataTable' );
				wp_enqueue_script( 'ColVis' );
				wp_enqueue_script( 'FixedColumns' );

			} else {

				wp_enqueue_script( 'datatables' );
                wp_enqueue_script( 'buttons-colvis' );
                wp_enqueue_style( 'datatables' );

			}

			wp_enqueue_script( 'tipso' );

			wp_enqueue_script( 'jquery-ui-datepicker' );

			$script_data  = "__ARF_DELETE_ENTRY_CONF_MSG='" . sprintf( esc_html__( 'Are you sure you want to %s delete this user product?', 'ARForms-Digital-Product' ), '<br/>' ) . "';";
			$script_data .= "__ARF_DELETE_BUTTON_TEXT='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "';";
			$script_data .= "__ARF_CANCEL_BUTTON_TEXT='" . esc_html__( 'Cancel', 'ARForms-Digital-Product' ) . "';";
			$script_data .= "__ARF_VALID_ACTION_DIG_PRO='" . esc_html__( 'Please select valid action', 'ARForms-Digital-Product' ) . "';";
			$script_data .= "__ARF_SELECT_RECORD='" . esc_html__( 'Please select one or more record to perform action', 'ARForms-Digital-Product' ) . "';";

			$script_data .= "__ARF_NO_FILES_SELECTED='" . esc_html__( 'No file Selected', 'ARForms-Digital-Product' ) . "';";
			$script_data .= "__ARF_SEARCH_PLACEHOLDER='" . esc_html__( 'Search', 'ARForms-Digital-Product' ) . "';";

			$script_data .= "__ARF_DB_VERSION= parseFloat( '" . $this->get_arforms_version() . "'); ";
					
			wp_add_inline_script( 'arf-dig-pro-js', $script_data, 'after' );
		}

		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && ( $_REQUEST['page'] == 'ARForms' ) && ( isset( $_REQUEST['arfaction'] ) && ( $_REQUEST['arfaction'] == 'edit' || $_REQUEST['arfaction'] == 'new' || $_REQUEST['arfaction'] == 'duplicate' ) ) ) {
			wp_enqueue_script( 'wp-hooks' );
			wp_enqueue_script( 'arf-dig-editor-js' );

			$script_data = "__ARF_DB_VERSION= parseFloat( '" . $this->get_arforms_version() . "');";
			wp_add_inline_script( 'arf-dig-editor-js', $script_data, 'after' );
		}		
	}
	function arf_set_css( $hook ) {
		global $arf_digital_product,$arf_dig_pro_assets_version;
		if ( ! $arf_digital_product->check_arforms_support() ) {
			return;
		}
		wp_register_style( 'arf-dig-pro-admin-css', ARF_DIG_PRO_URL . '/css/arf_dig_pro_admin.css', array(), $arf_dig_pro_assets_version );

		if( version_compare( $this->get_arforms_version(), '5.6', '<' ) ){
			wp_register_style( 'bootstrap', ARFURL . '/bootstrap/css/bootstrap.css', array(), $arf_dig_pro_assets_version );
			wp_register_style( 'bootstrap-select', ARFURL . '/bootstrap/css/bootstrap-select.css', array(), $arf_dig_pro_assets_version );
		}

		if( version_compare( $this->get_arforms_version(), '4.2', '<' ) ){
			wp_enqueue_style( 'demo_page', ARFURL . '/datatables/media/css/demo_page.css', array(), $arf_dig_pro_version );
			wp_enqueue_style( 'demo_table_jui', ARFURL . '/datatables/media/css/demo_table_jui.css', array(), $arf_dig_pro_version );
			wp_enqueue_style( 'jquery-ui-1.8.4.custom', ARFURL . '/datatables/media/css/jquery-ui-1.8.4.custom.css', array(), $arf_dig_pro_version );
			wp_enqueue_style( 'ColVis', ARFURL . '/datatables/media/css/ColVis.css', array(), $arf_dig_pro_version );
		}

		if ( ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] == 'ARForms' && isset( $_REQUEST['arfaction'] ) && ( $_REQUEST['arfaction'] == 'edit' || $_REQUEST['arfaction'] == 'new' || $_REQUEST['arfaction'] == 'duplicate' || $_REQUEST['arfaction'] == 'update' ) ) ) || ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] == 'ARForms-ProductDownload' ) ) {
			wp_enqueue_style( 'arf-dig-pro-admin-css' );

			if( version_compare( $this->get_arforms_version(), '5.6', '<' ) ){
				
				wp_enqueue_style( 'bootstrap' );

				wp_enqueue_style( 'bootstrap-select' );
			}
		}
		if ( isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' && ( $_REQUEST['page'] == 'ARForms-DigitalProduct' || $_REQUEST['page'] == 'ARForms-ProductDownload' ) ) {

			wp_register_style( 'arf-dig-pro-css', ARF_DIG_PRO_URL . '/css/arf_dig_pro.css', array(), $arf_dig_pro_assets_version );
			wp_enqueue_style( 'arf-dig-pro-css' );

			if( version_compare( $this->get_arforms_version(), '5.6', '<' ) ){
				wp_enqueue_style( 'bootstrap' );
			}
			
			wp_register_style( 'tipso', ARFURL . '/css/tipso.min.css', array(), $arf_dig_pro_assets_version );
			wp_enqueue_style( 'tipso' );
		}

		if( isset( $hook ) && 'plugins.php' == $hook ){
			global $wp_version;

			if( version_compare($wp_version, '4.5', '<') ){
				wp_print_styles( 'arf-dig-pro-css' );
				deactivate_plugins( plugin_basename( __FILE__ ), true, false );
				$redirect_url = network_admin_url( 'plugins.php?deactivate=true' );
				wp_die( '<div class="arf_dig_pro_wp_notice"><p class="arf_dig_pro_wp_notice_text" >Please meet the minimum requirement of WordPress version 4.5 to activate ARForms - Digital Download Add-on<p class="arf_dig_pro_wp_notice_continue">Please <a href="javascript:void(0)" onclick="window.location.href=\'' . $redirect_url . '\'">Click Here</a> to continue.</p></div>' );
			}
		}
	}
	function list_products( $message = '' ) {
		require ARF_DIG_PRO_VIEWS_DIR . '/list_products_3.0.php';
	}
	function download_product() {
		require_once ARF_DIG_PRO_VIEWS_DIR . '/arf_dig_pro_download_product_3.0.php';
	}


	function arf_save_dig_pro_setting_callback() {
		global $wpdb, $arfform, $arf_digital_product_tbl,$arf_dig_pro_products_class, $arf_version;

		$return_json = array();

		$wp_upload_dir = wp_upload_dir();

		$upload_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
		$output_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
		$upload_url = $wp_upload_dir['baseurl'] . '/arforms/arfdw/';
		$output_url = $wp_upload_dir['baseurl'] . '/arforms/arfdw/';
		$id 				= isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : '';

		if ( ! is_dir( $output_dir ) ) {
			wp_mkdir_p( $output_dir );
		}

		$check_cap = $this->arf_dig_pro_check_user_cap( 'arf_dig_pro_configuration', true );

		if ( 'success' != $check_cap ) {
			$cap_error              = json_decode( $check_cap, true );
			$return_json['error']   = true;
			$return_json['message'] = $cap_error['msg'];
			echo json_encode( $return_json );
			die;
		}

		if( version_compare( $arf_version, '4.4', '<') ){
			$arf_product_file_url = '';
			$extensions           = array();
			/* $id                   = isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : ''; */
			$act                  = isset( $_REQUEST['arfaction'] ) ? $_REQUEST['arfaction'] : '';
			$file_ext             = '';

			if ( isset( $_FILES['arf_product_file_url']['name'] ) && $_FILES['arf_product_file_url']['name'] != '' ) {
				$file_ext   = explode( '.', $_FILES['arf_product_file_url']['name'] );
				$file_ext   = end( $file_ext );
			}

			$invalid_ext  = array( "php", "php3", "php4", "php5", "pl", "py", "jsp", "asp", "exe", "cgi" );

			$compression_ext = apply_filters( 'arf_compressed_file_ext', array( 'tar', 'zip', 'gz', 'gzip', 'rar', '7z' ) );

			if( !empty( $file_ext ) && in_array( $file_ext, $invalid_ext ) ){
				$return_json['error']	= true;
				$return_json['message']	= esc_html__( 'This file could not be uploaded due to security reasons.', 'ARForms-Digital-Product' );
				echo json_encode( $return_json );
				die;
			}

			if( !empty( $file_ext ) && ! in_array( $file_ext, $compression_ext ) ){
				$file_bytes = $_FILES['arf_product_file_url']['size'];

	            $file_size = number_format($file_bytes / 1048576, 2);

	            if( $file_size <= 10 ){
	            	if( !function_exists('WP_Filesystem' ) ){
		            	require_once(ABSPATH . 'wp-admin/includes/file.php');
			        }
	                WP_Filesystem();
	                global $wp_filesystem, $maincontroller;
	                $file_content = $wp_filesystem->get_contents($_FILES['arf_product_file_url']['tmp_name']);

	                $isValidFile = $maincontroller->arf_check_valid_file($file_content);
	                if( false == $isValidFile ){
	                	$return_json['error']   = true;
						$return_json['message'] = esc_html__('The file could not be uploaded due to security reasons as it contains malicious code', 'ARForms-Digital-Product');
	                    echo json_encode( $return_json );
						die;
	                }
	            }
			}

			$errors      = false;
			$errors_data = '';

			if ( ! empty( $_FILES['arf_product_file_url']['tmp_name'] ) && ! is_uploaded_file( $_FILES['arf_product_file_url']['tmp_name'] ) && esc_attr( $_REQUEST['arf_dig_pro_download_type'] ) != 'external'  ) {
				$errors      = true;
				$errors_data = esc_html__( 'Please select valid file.', 'ARForms-Digital-Product' );
			}

			if ( ! empty( $_FILES['arf_product_file_url']['tmp_name'] ) && isset( $_FILES['arf_product_file_url']['error'] ) && ! empty( $_FILES['arf_product_file_url']['error'] ) && esc_attr( $_REQUEST['arf_dig_pro_download_type'] ) != 'external' ) {
				$errors      = true;
				$errors_data = $_FILES['arf_product_file_url']['error'];
			}

			if ( true == $errors ) {
				$return_json['error']   = true;
				$return_json['message'] = $errors_data;
				echo json_encode( $return_json );
				die;
			}

			$t = time();

			if ( isset( $_FILES['arf_product_file_url']['name'] ) && ! empty( $_FILES['arf_product_file_url']['name'] ) && ! empty( $output_dir ) ) {
				if( !function_exists('WP_Filesystem' ) ){
		            require_once(ABSPATH . 'wp-admin/includes/file.php');
		        }
		        WP_Filesystem();
		        global $wp_filesystem;

				if ( $wp_filesystem->put_contents( $output_dir . $t . '_' . $_FILES['arf_product_file_url']['name'], $wp_filesystem->get_contents($_FILES['arf_product_file_url']['tmp_name']) , 0777 ) ) {
					$arf_product_file_url = $output_url . $t . '_' . $_FILES['arf_product_file_url']['name'];
				}
			} else {
				if ( isset( $id ) && '' != $id && 'edit' == $_POST['arfaction'] ) {
					$arf_product_file_url = esc_attr( $_REQUEST['arf_product_file_hidden'] );
				}
			}

		} else {
			if( !isset( $_FILES['arf_product_file_url'] ) && esc_attr( $_REQUEST['arf_dig_pro_download_type'] != 'external' ) ){
				$res = array(
					'error' => true,
					'message' => esc_html__( 'No file selected.', 'ARForms-Digital-Product' )
				);

				echo json_encode( $res );
				die;
			} else if( !class_exists('arfilecontroller') ){
				$res = array(
					'error' => true,
					'message' => esc_html__( 'Something went wrong. Please try again later.', 'ARForms-Digital-Product' )
				);

				echo json_encode( $res );
				die;
			}

			$file = $_FILES['arf_product_file_url'];

			$arfilecontroller = new arfilecontroller( $file, false );

			if( !$arfilecontroller ) {
				$res = array(
					'error' => true,
					'message' => $arfilecontroller->error_message
				);

				echo json_encode( $res );
				die;
			}

			$wp_upload_dir = wp_upload_dir();

			$upload_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
			$output_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
			$upload_url = $wp_upload_dir['baseurl'] . '/arforms/arfdw/';
			$output_url = $wp_upload_dir['baseurl'] . '/arforms/arfdw/';

			if ( ! is_dir( $output_dir ) ) {
				wp_mkdir_p( $output_dir );
			}

			$arfilecontroller->check_cap = true;
			$arfilecontroller->capabilities = array( 'arf_dig_pro_configuration' );

			$arfilecontroller->check_nonce = true;
			$arfilecontroller->nonce_data = isset( $_POST['_wpnonce_arfdigpro'] ) ? $_POST['_wpnonce_arfdigpro'] : '';

			$arfilecontroller->nonce_action = 'arf_digital_product';
			$arfilecontroller->check_only_image = true;

			$arfilecontroller->check_specific_ext = false;
	        $arfilecontroller->allowed_ext = array();

	        $t = time();

	        if ( isset( $_FILES['arf_product_file_url']['name'] ) && ! empty( $_FILES['arf_product_file_url']['name'] ) && ! empty( $output_dir ) ) {

	        	$file_name = $t . '_' . $file['name'];

	        	$destination = $output_dir . $file_name;

	        	$upload_file = $arfilecontroller->arf_process_upload( $destination );

	        	if( false == $upload_file ){
		        	$res = array(
		        		'error' => true,
		        		'message' => $arfilecontroller->error_message
		        	);
		        	echo json_encode( $res );
		        	die;
		        } else {
		        	$arf_product_file_url = $output_url . $file_name;
		        }

			} else {
				if ( isset( $id ) && '' != $id && 'edit' == $_POST['arfaction'] ) {
					$arf_product_file_url = esc_attr( $_REQUEST['arf_product_file_hidden'] );
				}
			}
		}

		if ( isset( $id ) && '' != $id && 'edit' == $_POST['arfaction'] ) {
			$options['arf_product_name'] = esc_attr( $_REQUEST['arf_product_name'] );

			$options['arf_product_description'] = esc_attr( $_REQUEST['arf_product_description'] );

			$options['arf_product_file_url'] = esc_attr( $arf_product_file_url );

			$options['arf_download_url']    = esc_attr( $_REQUEST['arf_download_url'] );
			$_REQUEST['arf_download_limit'] = isset( $_REQUEST['arf_download_limit'] ) ? $_REQUEST['arf_download_limit'] : '';
			$options['arf_download_limit']  = esc_attr( $_REQUEST['arf_download_limit'] );

			$options['arf_download_note'] = esc_attr( $_REQUEST['arf_download_note'] );

			$options['arf_dig_pro_download_type'] = esc_attr( $_REQUEST['arf_dig_pro_download_type'] );
			$_REQUEST['category_id']              = isset( $_REQUEST['category_id'] ) ? $_REQUEST['category_id'] : '';
			$new_values['category_id']            = esc_attr( $_REQUEST['category_id'] );
			$_REQUEST['arf_dig_pro_form']         = isset( $_REQUEST['arf_dig_pro_form'] ) ? $_REQUEST['arf_dig_pro_form'] : '';
			$new_values['form_id']                = esc_attr( $_REQUEST['arf_dig_pro_form'] );

			$new_values['status'] = esc_attr( $_REQUEST['arf_product_status'] );

			$options = apply_filters( 'arf_trim_values', $options );

			$new_values['options'] = maybe_serialize( $options );

			$res    = $wpdb->update( $arf_digital_product_tbl, $new_values, array( 'id' => $id ) );
			$values = array();

			$values                      = $new_values;
			$_REQUEST['success_action']  = isset( $_REQUEST['success_action'] ) ? $_REQUEST['success_action'] : '';
			$values['success_action']    = esc_attr( $_REQUEST['success_action'] );
			$_REQUEST['success_msg']     = isset( $_REQUEST['success_msg'] ) ? $_REQUEST['success_msg'] : '';
			$values['success_msg']       = esc_attr( $_REQUEST['success_msg'] );
			$_REQUEST['success_url']     = isset( $_REQUEST['success_url'] ) ? $_REQUEST['success_url'] : '';
			$values['success_url']       = esc_attr( $_REQUEST['success_url'] );
			$_REQUEST['success_page_id'] = isset( $_REQUEST['success_page_id'] ) ? $_REQUEST['success_page_id'] : '';
			$values['success_page_id']   = esc_attr( $_REQUEST['success_page_id'] );

			$values['id'] = $id;

			$values['arf_dig_pro_form'] = esc_attr( $_REQUEST['arf_dig_pro_form'] );

			$values['arf_product_status'] = esc_attr( $_REQUEST['arf_product_status'] );

			unset( $values['options'] );

			foreach ( $options as $option_key => $option_val ) {
				$values[ $option_key ] = $option_val;
			}

			$download_type = sanitize_text_field( $options['arf_dig_pro_download_type'] );

			$arfaction = 'edit';

			$return_json['error']         = false;
			$return_json['message']       = esc_html__( 'Product has been successfully updated', 'ARForms-Digital-Product' );
			$return_json['action']        = 'edit';
			$return_json['id']            = $id;
			$return_json['download_type'] = $download_type;

			$return_json['arf_product_file_url'] = '<small class="arf_dig_pro_download_url"> <a href="' . $arf_dig_pro_products_class->arf_dig_pro_create_download_link_for_admin( $values['id'] ) . '">' . esc_html__( 'View Download', 'ARForms-Digital-Product' ) . '</a> (' . basename( $values['arf_product_file_url'] ) . ')</small>';
			$return_json['file_msg']             = esc_html__( 'No file selected', 'ARForms-Digital-Product' );
			echo json_encode( $return_json );
			die;
		} else {
			$options['arf_product_name'] = esc_attr( $_REQUEST['arf_product_name'] );

			$options['arf_product_description'] = esc_attr( $_REQUEST['arf_product_description'] );

			$options['arf_product_file_url'] = $arf_product_file_url;

			$options['arf_download_url']    = esc_attr( $_REQUEST['arf_download_url'] );
			$_REQUEST['arf_download_limit'] = isset( $_REQUEST['arf_download_limit'] ) ? $_REQUEST['arf_download_limit'] : '';
			$options['arf_download_limit']  = esc_attr( $_REQUEST['arf_download_limit'] );

			$options['arf_download_note'] = esc_attr( $_REQUEST['arf_download_note'] );

			$options['arf_dig_pro_download_type'] = esc_attr( $_REQUEST['arf_dig_pro_download_type'] );

			$_REQUEST['arf_dig_pro_form'] = isset( $_REQUEST['arf_dig_pro_form'] ) ? $_REQUEST['arf_dig_pro_form'] : '';
			$new_values['form_id']        = esc_attr( $_REQUEST['arf_dig_pro_form'] );

			$new_values['status'] = esc_attr( $_REQUEST['arf_product_status'] );

			$options               = apply_filters( 'arf_trim_values', $options );
			$new_values['options'] = maybe_serialize( $options );
			

			$new_values['created_at'] = current_time( 'mysql' );

			$id = $wpdb->insert( $arf_digital_product_tbl, $new_values );

			$id = $wpdb->insert_id;

			$values = array();

			$values                      = $new_values;
			$_REQUEST['success_action']  = isset( $_REQUEST['success_action'] ) ? $_REQUEST['success_action'] : '';
			$values['success_action']    = esc_attr( $_REQUEST['success_action'] );
			$_REQUEST['success_msg']     = isset( $_REQUEST['success_msg'] ) ? $_REQUEST['success_msg'] : '';
			$values['success_msg']       = esc_attr( $_REQUEST['success_msg'] );
			$_REQUEST['success_url']     = isset( $_REQUEST['success_url'] ) ? $_REQUEST['success_url'] : '';
			$values['success_url']       = esc_attr( $_REQUEST['success_url'] );
			$_REQUEST['success_page_id'] = isset( $_REQUEST['success_page_id'] ) ? $_REQUEST['success_page_id'] : '';
			$values['success_page_id']   = esc_attr( $_REQUEST['success_page_id'] );

			$values['id'] = $id;

			$values['arf_dig_pro_form'] = esc_attr( $_REQUEST['arf_dig_pro_form'] );

			$values['arf_product_status'] = esc_attr( $_REQUEST['arf_product_status'] );

			unset( $values['options'] );

			foreach ( $options as $option_key => $option_val ) {
				$values[ $option_key ] = $option_val;
			}
			$arfaction = 'edit';

			$download_type = $options['arf_dig_pro_download_type'];

			$shortcode          = '<tr class="tdclass">';
				$shortcode     .= '<td valign="top" colspan="2" class="lbltitle titleclass">';
					$shortcode .= '<br/>';
					$shortcode .= esc_html__( 'Download Link Shortcode', 'ARForms-Digital-Product' );
				$shortcode     .= '</td>';
			$shortcode         .= '</tr>';

			$shortcode             .= '<tr class="tdclass">';
				$shortcode         .= '<td width="18%" class="tdclass" valign="top">';
					$shortcode     .= '<label class="lblsubtitle arf_digpro_shortcode_label">';
						$shortcode .= esc_html__( 'Shortcode', 'ARForms-Digital-Product' );
					$shortcode     .= '</label>';
				$shortcode         .= '</td>';
				$shortcode         .= '<td>';
					$shortcode     .= '<div class="arf_dig_pro_shortcode_sec">';
						$shortcode .= '<span>[ARF_download_link product_id=\'' . $id . '\' desc=\'Download\' type=\'link\']</span>';
						$shortcode .= '<p class="howto clear">' . esc_html__( 'Note', 'ARForms-Digital-Product' ) . ': ' . sprintf( esc_html__( 'Possible value for type argument %1$s %2$s', 'ARForms-Digital-Product' ), '1) type=\'link\'', '2) type=\'button\'' );
					$shortcode     .= '</div>';
				$shortcode         .= '</td>';
			$shortcode             .= '</tr>';

			$return_json['error']                 = false;
			$return_json['message']               = esc_html__( 'Product has been successfully added', 'ARForms-Digital-Product' );
			$return_json['action']                = 'new';
			$return_json['id']                    = $id;
			$return_json['file_msg']              = '&nbsp;' . esc_html__( 'No file selected', 'ARForms-Digital-Product' );
			$return_json['arf_product_file_url']  = '<small class="arf_dig_pro_download_url"> <a href="' . $arf_dig_pro_products_class->arf_dig_pro_create_download_link_for_admin( $values['id'] ) . '">' . esc_html__( 'View Download', 'ARForms-Digital-Product' ) . '</a> (' . basename( $values['arf_product_file_url'] ) . ')</small>';
			$return_json['arf_product_shortcode'] = $shortcode;
			$return_json['download_type']         = $download_type;

			echo json_encode( $return_json );
		}
		die;
	}

	function edit_product_v3() {
		global $wpdb, $arfform,$arf_digital_product_tbl,$arf_version,$arfform;

		if ( isset( $_REQUEST['save_arf_dig_pro'] ) ) {

			$wp_upload_dir = wp_upload_dir();

			$upload_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
			$output_dir = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
			$output_url = $wp_upload_dir['baseurl'] . '/arforms/arfdw/';

			if ( ! is_dir( $output_dir ) ) {
				wp_mkdir_p( $output_dir );
			}

			$arf_product_file_url = '';
			$extensions           = array();
			$id                   = isset( $_REQUEST['id'] ) ? $_REQUEST['id'] : '';
			$act                  = isset( $_REQUEST['arfaction'] ) ? $_REQUEST['arfaction'] : '';
			$file_ext             = '';
			if ( isset( $_FILES['arf_product_file_url']['name'] ) && $_FILES['arf_product_file_url']['name'] != '' ) {
				$file_ext   = explode( '.', $_FILES['arf_product_file_url']['name'] );
				$file_ext   = end( $file_ext );
			}

			$invalid_ext  = array( "php", "php3", "php4", "php5", "pl", "py", "jsp", "asp", "exe", "cgi" );

			if( !empty( $file_ext ) && in_array( $invalid_ext ) ){
				$return_json['error']	= true;
				$return_json['message']	= esc_html__( 'This file could not be uploaded due to security reasons.', 'ARForms-Digital-Product' );
				echo json_encode( $return_json );
				die;
			}

			$compression_ext = apply_filters( 'arf_compressed_file_ext', array( 'tar', 'zip', 'gz', 'gzip', 'rar', '7z' ) );

			if( !empty( $file_ext ) && !in_array( $file_ext, $compression_ext ) ){
				$file_bytes = $_FILES['arf_product_file_url']['size'];

	            $file_size = number_format($file_bytes / 1048576, 2);

	            if( $file_size <= 10 ){
	            	if( !function_exists('WP_Filesystem' ) ){
		            	require_once(ABSPATH . 'wp-admin/includes/file.php');
			        }
	                WP_Filesystem();
	                global $wp_filesystem, $maincontroller;
	                $file_content = $wp_filesystem->get_contents($_FILES['arf_product_file_url']['tmp_name']);

	                $isValidFile = $maincontroller->arf_check_valid_file($file_content);
	                if( false == $isValidFile ){
	                	$return_json['error']   = true;
						$return_json['message'] = esc_html__('The file could not be uploaded due to security reasons as it contains malicious code', 'ARForms-Digital-Product');
	                    echo json_encode( $return_json );
						die;
	                }
	            }
			}

			$errors      = false;
			$errors_data = '';

			if ( ! empty( $_FILES['arf_product_file_url']['tmp_name'] ) && ! is_uploaded_file( $_FILES['arf_product_file_url']['tmp_name'] ) ) {
				$errors      = true;
				$errors_data = esc_html__( 'Please select valid file.', 'ARForms-Digital-Product' );
			}

			if ( ! empty( $_FILES['arf_product_file_url']['tmp_name'] ) && isset( $_FILES['arf_product_file_url']['error'] ) && ! empty( $_FILES['arf_product_file_url']['error'] ) ) {
				$errors      = true;
				$errors_data = $_FILES['arf_product_file_url']['error'];
			}

			$t = time();

			if ( isset( $_FILES['arf_product_file_url']['name'] ) && ! empty( $_FILES['arf_product_file_url']['name'] ) && ! empty( $output_dir ) ) {

				if( !function_exists('WP_Filesystem' ) ){
	            	require_once(ABSPATH . 'wp-admin/includes/file.php');
		        }
		        WP_Filesystem();
		        global $wp_filesystem;

		        if ( $wp_filesystem->put_contents( $output_dir . $t . '_' . $_FILES['arf_product_file_url']['name'], $wp_filesystem->get_contents( $_FILES['arf_product_file_url']['tmp_name'] ), 0777 ) ) {
					$arf_product_file_url = $output_url . $t . '_' . $_FILES['arf_product_file_url']['name'];
				}
			} else {
				if ( isset( $id ) && $id != '' && $_POST['arfaction'] == 'edit' ) {
					$arf_product_file_url = esc_attr( $_REQUEST['arf_product_file_hidden'] );
				}
			}
			if ( isset( $id ) && $id != '' && $_POST['arfaction'] == 'edit' ) {

				$options['arf_product_name'] = esc_attr( $_REQUEST['arf_product_name'] );

				$options['arf_product_description'] = esc_attr( $_REQUEST['arf_product_description'] );

				$options['arf_product_file_url'] = $arf_product_file_url;

				$options['arf_download_url']    = esc_attr( $_REQUEST['arf_download_url'] );
				$_REQUEST['arf_download_limit'] = isset( $_REQUEST['arf_download_limit'] ) ? $_REQUEST['arf_download_limit'] : '';
				$options['arf_download_limit']  = esc_attr( $_REQUEST['arf_download_limit'] );

				$options['arf_download_note'] = esc_attr( $_REQUEST['arf_download_note'] );

				$options['arf_dig_pro_download_type'] = esc_attr( $_REQUEST['arf_dig_pro_download_type'] );
				$_REQUEST['category_id']              = isset( $_REQUEST['category_id'] ) ? $_REQUEST['category_id'] : '';
				$new_values['category_id']            = esc_attr( $_REQUEST['category_id'] );
				$_REQUEST['arf_dig_pro_form']         = isset( $_REQUEST['arf_dig_pro_form'] ) ? $_REQUEST['arf_dig_pro_form'] : '';
				$new_values['form_id']                = esc_attr( $_REQUEST['arf_dig_pro_form'] );

				$new_values['status'] = esc_attr( $_REQUEST['arf_product_status'] );

				$options = apply_filters( 'arf_trim_values', $options );

				$new_values['options'] = maybe_serialize( $options );

				$res    = $wpdb->update( $arf_digital_product_tbl, $new_values, array( 'id' => $id ) );
				$values = array();

				$values                      = $new_values;
				$_REQUEST['success_action']  = isset( $_REQUEST['success_action'] ) ? $_REQUEST['success_action'] : '';
				$values['success_action']    = esc_attr( $_REQUEST['success_action'] );
				$_REQUEST['success_msg']     = isset( $_REQUEST['success_msg'] ) ? $_REQUEST['success_msg'] : '';
				$values['success_msg']       = esc_attr( $_REQUEST['success_msg'] );
				$_REQUEST['success_url']     = isset( $_REQUEST['success_url'] ) ? $_REQUEST['success_url'] : '';
				$values['success_url']       = esc_attr( $_REQUEST['success_url'] );
				$_REQUEST['success_page_id'] = isset( $_REQUEST['success_page_id'] ) ? $_REQUEST['success_page_id'] : '';
				$values['success_page_id']   = esc_attr( $_REQUEST['success_page_id'] );

				$values['id'] = $id;

				$values['arf_dig_pro_form'] = esc_attr( $_REQUEST['arf_dig_pro_form'] );

				$values['arf_product_status'] = esc_attr( $_REQUEST['arf_product_status'] );

				unset( $values['options'] );

				foreach ( $options as $option_key => $option_val ) {
					$values[ $option_key ] = $option_val;
				}

				$arfaction = 'edit';

				$message = esc_html__( 'Product has been successfully updated.', 'ARForms-Digital-Product' );
				if ( isset( $message ) && '' != $message ) {
					wp_add_inline_script( 'arf-dig-pro-js', 'alert("test");', 'after' );
				}

				require ARF_DIG_PRO_VIEWS_DIR . '/edit_product_3.0.php';
			} else {
				$options['arf_product_name'] = esc_attr( $_REQUEST['arf_product_name'] );

				$options['arf_product_description'] = esc_attr( $_REQUEST['arf_product_description'] );

				$options['arf_product_file_url'] = $arf_product_file_url;

				$options['arf_download_url']    = esc_attr( $_REQUEST['arf_download_url'] );
				$_REQUEST['arf_download_limit'] = isset( $_REQUEST['arf_download_limit'] ) ? $_REQUEST['arf_download_limit'] : '';
				$options['arf_download_limit']  = esc_attr( $_REQUEST['arf_download_limit'] );

				$options['arf_download_note'] = esc_attr( $_REQUEST['arf_download_note'] );

				$options['arf_dig_pro_download_type'] = esc_attr( $_REQUEST['arf_dig_pro_download_type'] );

				$_REQUEST['arf_dig_pro_form'] = isset( $_REQUEST['arf_dig_pro_form'] ) ? $_REQUEST['arf_dig_pro_form'] : '';
				$new_values['form_id']        = esc_attr( $_REQUEST['arf_dig_pro_form'] );

				$new_values['status'] = esc_attr( $_REQUEST['arf_product_status'] );

				$options               = apply_filters( 'arf_trim_values', $options );
				$new_values['options'] = maybe_serialize( $options );

				$new_values['created_at'] = current_time( 'mysql' );

				$id = $wpdb->insert( $arf_digital_product_tbl, $new_values );

				$id = $wpdb->insert_id;

				$values = array();

				$values                      = $new_values;
				$_REQUEST['success_action']  = isset( $_REQUEST['success_action'] ) ? $_REQUEST['success_action'] : '';
				$values['success_action']    = esc_attr( $_REQUEST['success_action'] );
				$_REQUEST['success_msg']     = isset( $_REQUEST['success_msg'] ) ? $_REQUEST['success_msg'] : '';
				$values['success_msg']       = esc_attr( $_REQUEST['success_msg'] );
				$_REQUEST['success_url']     = isset( $_REQUEST['success_url'] ) ? $_REQUEST['success_url'] : '';
				$values['success_url']       = esc_attr( $_REQUEST['success_url'] );
				$_REQUEST['success_page_id'] = isset( $_REQUEST['success_page_id'] ) ? $_REQUEST['success_page_id'] : '';
				$values['success_page_id']   = esc_attr( $_REQUEST['success_page_id'] );

				$values['id'] = $id;

				$values['arf_dig_pro_form'] = esc_attr( $_REQUEST['arf_dig_pro_form'] );

				$values['arf_product_status'] = esc_attr( $_REQUEST['arf_product_status'] );

				unset( $values['options'] );

				foreach ( $options as $option_key => $option_val ) {
					$values[ $option_key ] = $option_val;
				}
				$arfaction = 'edit';

				$message = esc_html__( 'Product has been successfully added.', 'ARForms-Digital-Product' );

				require ARF_DIG_PRO_VIEWS_DIR . '/edit_product_3.0.php';
			}
		} else {

			if ( $_REQUEST['arfaction'] == 'edit' && isset( $_REQUEST['id'] ) && $_REQUEST['id'] != '' ) {

				if( version_compare( $arf_version, '4.3', '<' ) ){

					$product_data = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_digital_product_tbl . ' WHERE id = %d', $_REQUEST['id'] ) );

				}else{

					$product_data = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', 'WHERE id = %d', array($_REQUEST['id']));

				}

				if ( count( $product_data ) > 0 ) {
					$product_data = $product_data[0];

					$options = maybe_unserialize( $product_data->options );

					$values                       = array();
					$values['id']                 = $product_data->id;
					$values['arf_product_status'] = $product_data->status;
					$values['arf_dig_pro_form']   = $product_data->form_id;
					$values['category_id']        = $product_data->category_id;

					if ( count( $options ) > 0 ) {
						foreach ( $options as $option_key => $option_val ) {
							$values[ $option_key ] = $option_val;
						}
					}
					$arfaction = 'edit';

					require ARF_DIG_PRO_VIEWS_DIR . '/edit_product_3.0.php';

				} else {
					echo "<input type='hidden' id='arp_dig_pro_redirect' value='" . admin_url( 'admin.php?page=ARForms-DigitalProduct' ) . "' />";
				}
			} else {

				$values['id']                      = '';
				$values['arf_dig_pro_form']        = '';
				$values['category_id']             = '';
				$values['arf_product_name']        = '';
				$values['arf_product_description'] = '';
				$values['arf_download_limit']      = '';
				$values['arf_product_status']      = '1';

				$values['arf_product_amount'] = '';

				$values['arf_product_file_url'] = '';
				$values['arf_download_url']     = '';
				$values['arf_download_note']    = '';

				$values['arf_dig_pro_download_type'] = 'internal';
				$arfaction                           = 'new';

				require ARF_DIG_PRO_VIEWS_DIR . '/edit_product_3.0.php';
			}
		}
	}

	function arf_dig_pro_delete_product() {
		
		global $arf_digital_product,$arf_version;
		$id     = $_POST['id'];
		$action = $_POST['act'];
		$errors = array();

		if ( $action == 'delete' && $id ) {
			$res = $arf_digital_product->delete_product( $id );

			if ( ! $res ) {
				$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
				array_push( $errors, $err );
			} else {
				$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
			}
		} else {
			$err = esc_html__( 'Record is not deleted', 'ARForms-Digital-Product' );
			array_push( $errors, $err );
		}
		
		if ( version_compare( $arf_version, '5.0', '>' ) ) {
			global $wpdb, $MdlDb, $arformcontroller;
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
				)
			);
		} else {
			$product_data = $this->arf_get_product_data();
			echo json_encode(
				array(
					'errors'   => $errors,
					'message'  => $message,
					'gridData' => $product_data,
				)
			);
		}
		die();
	}

	function delete_product( $id = 0 ) {
		if ( $id == 0 ) {
			return false;
		}

		if ( $id ) {
			global $wpdb,$arf_digital_product_tbl,$arfform,$arf_version;

			if( version_compare( $arf_version, '4.3', '<' ) ){

				$as_product_data = $wpdb->get_row( $wpdb->prepare( 'SELECT id,options FROM  ' . $arf_digital_product_tbl . ' WHERE id = %d', $id ) );

			}else{

				$as_product_data = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, 'id,options', 'WHERE id = %d', array($id), '', '', '', false, true);
			}

			if ( $as_product_data->id ) {
				$product_option = maybe_unserialize( $as_product_data->options );
				if ( $product_option['arf_dig_pro_download_type'] == 'internal' ) {

					$requested_file = $product_option['arf_product_file_url'];
					if ( $requested_file ) {
						$arf_download_site_url = site_url() . '/';

						if ( is_ssl() && ( ! preg_match( '/^https:\/\/.*\..*$/', $arf_download_site_url ) ) ) {
							$arf_download_site_url = str_replace( 'http://', 'https://', $arf_download_site_url );
						}

						$file_path = str_replace( $arf_download_site_url, '', $requested_file );
						$file_path = realpath( ABSPATH . $file_path );

						if ( ! empty( $file_path ) ) {
							if ( file_exists( $file_path ) ) {
								unlink( $file_path );
							}
						}
					}
				}
			}
			$res = $wpdb->query( $wpdb->prepare( 'DELETE FROM ' . $arf_digital_product_tbl . ' WHERE id = %d', $id ) );
			return $res;
		}
	}

	function arf_dig_pro_form_bulk_act() {
		if ( ! isset( $_POST ) ) {
			return;
		}

		global $arfform,$arf_digital_product,$armainhelper, $arf_version;

		$bulkaction = $armainhelper->get_param( 'action1' );

		$message = '';

		$errors = array();

		if ( $bulkaction == -1 ) {
			$bulkaction = $armainhelper->get_param( 'action2' );
		}

		if ( ! empty( $bulkaction ) && strpos( $bulkaction, 'bulk_' ) === 0 ) {

			if ( isset( $_GET ) && isset( $_GET['action1'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action1'], '', $_SERVER['REQUEST_URI'] );
			}

			if ( isset( $_GET ) && isset( $_GET['action2'] ) ) {
				$_SERVER['REQUEST_URI'] = str_replace( '&action=' . $_GET['action2'], '', $_SERVER['REQUEST_URI'] );
			}

			$bulkaction = str_replace( 'bulk_', '', $bulkaction );
		} else {

			$bulkaction = '-1';

			if ( isset( $_POST['bulkaction'] ) && $_POST['bulkaction1'] != '-1' ) {
				$bulkaction = $_POST['bulkaction1'];

			} elseif ( isset( $_POST['bulkaction2'] ) && $_POST['bulkaction2'] != '-1' ) {
				$bulkaction = $_POST['bulkaction2'];
			}
		}

		$ids = $armainhelper->get_param( 'item-action', '' );

		if ( empty( $ids ) ) {
			$errors[] = esc_html__( 'Please select one or more records.', 'ARForms-Digital-Product' );
		} else {
			if ( ! is_array( $ids ) ) {
				$ids = explode( ',', $ids );
			}

			if ( is_array( $ids ) ) {
				if ( $bulkaction == 'delete' ) {

					foreach ( $ids as $fid ) {
						$res_var = $arf_digital_product->delete_product( $fid );
					}

					if ( $res_var ) {
						$message = esc_html__( 'Record is deleted successfully.', 'ARForms-Digital-Product' );
					}
				}
			}
		}

		if ( version_compare( $arf_version, '5.0', '>' ) ) {
				global $wpdb, $MdlDb, $arformcontroller;
				echo json_encode(
					array(
						'errors'   => $errors,
						'message'  => $message,
					)
				);
			} else {
				$arf_dig_pro_data = $this->arf_get_product_data();
				echo json_encode(
					array(
						'errors'   => $errors,
						'message'  => $message,
						'gridData' => $arf_dig_pro_data,
					)
				);
			}
		die;

	}

	function arf_get_product_data() {
		global $wpdb, $arf_digital_product_tbl,$arf_digital_product_download_tbl,$arf_version,$arfform;

		if( version_compare( $arf_version, '4.3', '<' ) ){
	
			$products = $wpdb->get_results( 'SELECT * FROM ' . $arf_digital_product_tbl . ' ORDER BY id DESC' );
		
		}else{

			$products = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', '', array(), '', 'ORDER BY id DESC');
		}

		$product_data = array();

		if ( count( $products ) > 0 ) {
			$n = 0;
			foreach ( $products as $product ) {
				$options = maybe_unserialize( $product->options );

				if( version_compare( $arf_version, '4.3', '<' ) ){

					$product_sales = $wpdb->get_var( $wpdb->prepare( 'SELECT count(product_id) AS total_sales FROM  ' . $arf_digital_product_download_tbl . ' WHERE product_id = %d', $product->id ) );
				}else{

					$product_sales = $arfform->arf_select_db_data( true, '', $arf_digital_product_download_tbl, 'count(product_id) AS total_sales', 'WHERE product_id = %d', array($product->id), '', '', '', true);
				}


				if ( ! isset( $product_data[ $n ] ) ) {
					$product_data[ $n ] = array();
				}

				$product_data[ $n ][] = '<div class="arf_custom_checkbox_div"><div class="arf_custom_checkbox_wrapper"> <input id="cb-item-action-' . $product->id . '" class="" type="checkbox" value="' . $product->id . '" name="item-action[]"> <svg width="18px" height="18px">' . ARF_CUSTOM_UNCHECKED_ICON . ARF_CUSTOM_CHECKED_ICON . ' </svg> </div></div><label for="cb-item-action-' . $product->id . '"><span></span></label>';

				$product_data[ $n ][] = $product->id;

				$product_data[ $n ][] = '<a class="row-title" href="' . wp_nonce_url( '?page=ARForms-DigitalProduct&arfaction=edit&id=' . $product->id ) . '">' . $options['arf_product_name'] . '</a>';

				$product_data[ $n ][] = $product_sales;

				$product_data[ $n ][] = ( $product->status == 1 ) ? esc_html__( 'Enable', 'ARForms-Digital-Product' ) : esc_html__( 'Disable', 'ARForms-Digital-Product' );

				$product_data[ $n ][] = date( get_option( 'date_format' ), strtotime( $product->created_at ) );

				$edit_link = '?page=ARForms-DigitalProduct&arfaction=edit&id=' . $product->id;

				$arf_action_div = '<div class="arf-row-actions" >';

				$arf_action_div .= "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Configuration', 'ARForms-Digital-Product' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";

				$arf_action_div .= "<div class='arfformicondiv arfhelptip  arfdeleteform_div_" . $product->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  id='delete_product'  data-id='" . $product->id . "' class='arfdeleteproduct'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

				$arf_action_div .= '</div>';

				$product_data[ $n ][] = $arf_action_div;

				$n++;
			}
		}

		return $product_data;
	}

	function arf_dig_pro_generate_htaccess() {

		$wp_upload_dir = wp_upload_dir();
		$dest_dir      = $wp_upload_dir['basedir'] . '/arforms/arfdw/';
		$htaccess_file = $dest_dir . '.htaccess';

		if ( file_exists( ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php' ) ) {
			require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-base.php';
		}
		if ( file_exists( ABSPATH . 'wp-admin/includes/class-wp-filesystem-direct.php' ) ) {
			require_once ABSPATH . 'wp-admin/includes/class-wp-filesystem-direct.php';
		}

		$wp_filesystem1 = new WP_Filesystem_Direct( array() );

		$htaccess = '<Files ~ ".*\..*">
                Order Allow,Deny
                Deny from all
                </Files>';

		$wp_filesystem1->put_contents( $htaccess_file, $htaccess, 0777 );
	}

	function arf_dig_pro_admin_notices() {
		global $arf_digital_product,$wp_version;

		if ( version_compare( $wp_version, '4.5.0', '<' ) ) {
			deactivate_plugins( plugin_basename( __FILE__ ), true, false );
			echo "<div class='error arf_error'><p>Please meet the minimum requirement of WordPress version 4.5 to activate ARForms - Digital Download Add-on</p></div>";
		}

		if ( ! $arf_digital_product->is_arforms_support() ) {
			echo "<div class='updated'><p>" . esc_html__( 'ARForms - Digital Download Add-on requires ARForms plugin installed and active.', 'ARForms-Digital-Product' ) . '</p></div>';

		} elseif ( ! version_compare( $this->get_arforms_version(), '3.0', '>=' ) ) {
			echo "<div class='updated'><p>" . esc_html__( 'ARForms - Digital Download Add-on requires ARForms installed with version 3.0 or higher.', 'ARForms-Digital-Product' ) . '</p></div>';
		}
	}

	function is_arforms_support() {
		if ( file_exists( ABSPATH . 'wp-admin/includes/plugin.php' ) ) {
			include_once ABSPATH . 'wp-admin/includes/plugin.php';
		}
		return is_plugin_active( 'arforms/arforms.php' );
	}

	function get_arforms_version() {

		$arf_db_version = get_option( 'arf_db_version' );

		return ( isset( $arf_db_version ) ) ? $arf_db_version : 0;
	}

	function check_arforms_support() {
		global $arf_digital_product;
		if ( ! version_compare( $arf_digital_product->get_arforms_version(), '3.0', '>=' ) ) {
			return false;
		} else {
			return true;
		}
	}

	function upgrade_data() {

		global $newarfdigversion;

		if ( ! isset( $newarfdigversion ) || $newarfdigversion == '' ) {
			$newarfdigversion = get_option( 'arf_dig_pro_version' );
		}

		if ( version_compare( $newarfdigversion, '2.4', '<' ) ) {
			$path = ARF_DIG_PRO_VIEWS_DIR . '/upgrade_dig_download_latest_data.php';
			if ( file_exists( $path ) ) {
				include $path;
			}
		}
	}

	function arf_wrap_input_field_digital_product( $return, $field_type ) {
		if ( $field_type == 'arf_product' ) {

			return false;
		} else {
			return true;
		}

	}

	function is_arforms_version() {
		if ( version_compare( self::get_arforms_version(), '3.0', '>=' ) ) {
			return true;
		} else {
			return false;
		}
	}

	function arf_dig_pro_check_user_cap( $capability = '', $is_ajax_call = false ) {
		$errors = array();

		if ( true == $is_ajax_call ) {
			if ( ! current_user_can( $capability ) ) {
				$errors['msg'] = esc_html__( 'Sorry, you do not have permission to perform this action', 'ARForms-Digital-Product' );
				return json_encode( $errors );
				die;
			}
		}

		$nonce = isset( $_REQUEST['_wpnonce_arfdigpro'] ) ? $_REQUEST['_wpnonce_arfdigpro'] : '';
		if ( '' == $nonce ) {
			$nonce = isset( $_POST['_wpnonce_arfdigpro'] ) ? $_POST['_wpnonce_arfdigpro'] : '';
		}

		$arf_dig_pro_nonce_flag = false;

		$arf_dig_pro_nonce_flag = wp_verify_nonce( $nonce, 'arf_digital_product' );

		if ( ! $arf_dig_pro_nonce_flag ) {
			$errors['msg'] = esc_html__( 'Sorry, your request cannot be processed due to security reasons', 'ARForms-Digital-Product' );
			return json_encode( $errors );
			die;
		}

		return 'success';
	}

	function arf_dig_pro_getapiurl(){
		$api_url = 'https://www.arpluginshop.com/';
		return $api_url;
	}

	function arf_dig_pro_get_remote_post_params( $plugin_info = '' ){
		global $wpdb, $arfversion;

		$action = '';
		$action = $plugin_info;

		if ( ! function_exists( 'get_plugins' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}

		$plugin_list = get_plugins();
		$site_url    = home_url();
		$plugins     = array();

		$active_plugins = get_option( 'active_plugins' );

		foreach ( $plugin_list as $key => $plugin ) {
			$is_active = in_array( $key, $active_plugins );

			if ( strpos( strtolower( $plugin['Title'] ), 'arformsdigitalproduct' ) !== false ) {
				$name      = substr( $key, 0, strpos( $key, '/' ) );
				$plugins[] = array(
					'name'      => $name,
					'version'   => $plugin['Version'],
					'is_active' => $is_active,
				);
			}
		}

		$plugins = json_encode( $plugins );

		$theme            = wp_get_theme();
		$theme_name       = $theme->get( 'Name' );
		$theme_uri        = $theme->get( 'ThemeURI' );
		$theme_version    = $theme->get( 'Version' );
		$theme_author     = $theme->get( 'Author' );
		$theme_author_uri = $theme->get( 'AuthorURI' );


		$im        = is_multisite();
		$sortorder = get_option( 'arfSortOrder' );

		$post = array(
			'wp'        => get_bloginfo( 'version' ),
			'php'       => phpversion(),
			'mysql'     => $wpdb->db_version(),
			'plugins'   => $plugins,
			'tn'        => $theme_name,
			'tu'        => $theme_uri,
			'tv'        => $theme_version,
			'ta'        => $theme_author,
			'tau'       => $theme_author_uri,
			'im'        => $im,
			'sortorder' => $sortorder,
		);

		return $post;

	}

}

global $arf_dig_pro_api_url, $arf_dig_pro_plugin_slug;

$arf_dig_pro_api_url = $arf_digital_product->arf_dig_pro_getapiurl();
$arf_dig_pro_plugin_slug = basename( dirname( __FILE__ ) );

add_filter( 'pre_set_site_transient_update_plugins', 'arf_dig_pro_check_for_plugin_update' );

function arf_dig_pro_check_for_plugin_update( $checked_data ) {
	global $arf_dig_pro_api_url, $arf_dig_pro_plugin_slug, $wp_version, $arf_digital_product, $arf_dig_pro_version,$arf_version;

	if ( empty( $checked_data->checked ) ) {
		return $checked_data;
	}

	$args = array(
		'slug'            => $arf_dig_pro_plugin_slug,
		'version'         => $arf_dig_pro_version,
		'arf_version' 		=> $arf_version,
		'other_variables' => $arf_digital_product->arf_dig_pro_get_remote_post_params(),
	);

	$request_string = array(
		'body'       => array(
			'action'  => 'basic_check',
			'request' => serialize( $args ),
			'api-key' => md5( home_url() ),
		),
		'user-agent' => 'ARFDIGPRO-WordPress/' . $wp_version . '; ' . home_url(),
	);

	$raw_response = wp_remote_post( $arf_dig_pro_api_url, $request_string );

	if ( ! is_wp_error( $raw_response ) && ( 200 == $raw_response['response']['code'] ) ) {
		$response = maybe_unserialize( $raw_response['body'] );
	}

	if ( isset( $response ) && ! empty( $response ) && isset( $response->token ) && '' != $response->token ) {
		update_option( 'arfdigpro_update_token', $response->token );
	}

	if ( isset( $response ) && is_object( $response ) && is_object( $checked_data ) && ! empty( $response ) ) {
		$checked_data->response[ $arf_dig_pro_plugin_slug . '/' . $arf_dig_pro_plugin_slug . '.php' ] = $response;
	}

	return $checked_data;
}

add_filter( 'plugins_api', 'arf_dig_pro_plugin_api_call', 11, 3 );

function arf_dig_pro_plugin_api_call( $def, $action, $args ) {
	global $arf_dig_pro_plugin_slug, $arf_dig_pro_api_url, $wp_version,$arf_version;

	if ( ! isset( $args->slug ) || ( $args->slug != $arf_dig_pro_plugin_slug ) ) {
		return false;
	}

	$plugin_info     = get_site_transient( 'update_plugins' );
	$current_version = $plugin_info->checked[ $arf_dig_pro_plugin_slug . '/' . $arf_dig_pro_plugin_slug . '.php' ];
	$args->version   = $current_version;

	$request_string = array(
		'body'       => array(
			'action'       => $action,
			'update_token' => get_site_option( 'arfdigpro_update_token' ),
			'request'      => serialize( $args ),
			'arf_version' => $arf_version,
			'api-key'      => md5( home_url() ),
		),
		'user-agent' => 'ARFDIGPRO-WordPress/' . $wp_version . '; ' . home_url(),
	);

	$request = wp_remote_post( $arf_dig_pro_api_url, $request_string );

	if ( is_wp_error( $request ) ) {
		$res = new WP_Error( 'plugins_api_failed', 'An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>', $request->get_error_message() );
	} else {
		$res = maybe_unserialize( $request['body'] );

		if ( false === $res ) {
			$res = new WP_Error( 'plugins_api_failed', 'An unknown error occurred', $request['body'] );
		}
	}

	return $res;
}