<?php

class arf_dig_pro_editor_product {

	function __construct() {
		global $as__products,$arf_digital_product;

		add_action( 'arfafterbasicfieldlisting', array( $this, 'arf_add_product_filed' ), 11, 2 );

		if( version_compare( $arf_digital_product->get_arforms_version(), '4.0', '>=') ){

			add_action( 'arfaavailablefields', array( $this, 'arf_add_product_field_in_editor') );

			add_filter( 'arf_manage_field_element_order_outside', array( $this, 'arf_add_product_field_in_order') );
			
			add_filter( 'arform_other_fields', array( $this, 'arf_add_product_field_in_order') );
		}

		add_filter( 'arf_all_field_css_class_for_editor', array( $this, 'arf_get_product_field_class' ), 11, 3 );

		add_filter( 'arfavailablefieldsbasicoptions', array( $this, 'add_availablefieldsbasicoptions' ), 10, 3 );

		add_filter( 'form_fields', array( $this, 'add_product_field_to_frontend_v3' ), 11, 11 );
		
		add_filter( 'arf_controls_added_class_outside_materialize', array( $this, 'add_controls_added_class_outside_materialize' ), 10, 2 );

		add_filter( 'arf_disply_required_field_outside', array( $this, 'arf_dig_pro_hide_required_product_field_icon' ), 10, 2 );
		
		add_filter( 'arf_disply_multicolumn_fieldolumn_field_outside', array( $this, 'arf_disply_multicolumn_fieldolumn_field_outside_fun' ), 10, 2 );
		
		add_filter( 'arf_disply_multicolumn_field_outside', array( $this, 'arf_dig_pro_hide_required_product_field_icon' ), 10, 2 );
		
		add_action( 'arf_field_option_model_outside', array( $this, 'arf_add_more_product_field_v3' ) );
		
		add_action( 'arfdisplayaddedfields', array( $this, 'add_product_field_to_editor_v3' ), 11, 2 );

		add_filter( 'arf_before_createfield', array( $this, 'arf_product_createfield' ), 10, 2 );

		add_filter( 'arfcustomhtml', array( $this, 'arf_product_lable_hide' ), 10, 2 );

		add_filter( 'arf_save_more_field_from_out_side', array( $this, 'arf_save_product_field' ), 10, 2 );

		add_filter( 'arf_set_field_width_in_outside', array( $this, 'arf_dig_pro_set_product_field_width' ), 10, 3 );

		add_filter( 'arf_add_more_field_options_outside', array( $this, 'arf_dig_pro_add_product_options' ), 10, 2 );

		add_filter( 'arf_positioned_field_options_icon', array( $this, 'arf_positioned_field_options_icon_for_dig_product' ), 10, 2 );

		add_filter( 'arf_new_field_array_filter_outside', array( $this, 'arf_new_field_array_filter_outside' ), 10, 4 );

		add_filter( 'arf_new_field_array_materialize_filter_outside', array( $this, 'arf_new_field_array_filter_outside_material' ), 10, 4 );

		add_filter( 'arf_new_field_array_materialize_outlined_filter_outside', array( $this, 'arf_new_field_array_filter_outside_material_outlined' ), 10, 4 );

		add_filter( 'arf_change_json_default_data_ouside', array( $this, 'arf_new_field_json_filter_outside' ), 10, 1 );

		add_filter( 'arf_default_value_array_field_type_from_itemmeta', array( $this, 'arf_set_default_value_array_for_digital_download' ), 10 );

	}

	function arf_set_default_value_array_for_digital_download( $field_types ){
		array_push( $field_types, ARF_PRODUCT_SLUG );
		return $field_types;
	}

	function arf_positioned_field_options_icon_for_dig_product( $positioned_field_icons, $field_icons ) {
		$positioned_field_icons[ ARF_PRODUCT_SLUG ] = str_replace( '{arf_field_type}', ARF_PRODUCT_SLUG, $field_icons['arf_field_duplicate_icon'] ) . $field_icons['field_delete_icon'] . str_replace( '{arf_field_type}', ARF_PRODUCT_SLUG, $field_icons['field_option_icon'] ) . $field_icons['arf_field_move_icon'];
		return $positioned_field_icons;
	}
	function arf_disply_multicolumn_fieldolumn_field_outside_fun( $arf_disply_multicolumn_field, $field ) {
		if ( $field['type'] == ARF_PRODUCT_SLUG ) {
			$arf_disply_multicolumn_field = false;
		}
		return $arf_disply_multicolumn_field;

	}
	function add_field_to_array_product( $arf_input_style_label_position, $arfinputstyle, $type ) {
		if ( $arfinputstyle == 'material' ) {
			if ( $type == ARF_PRODUCT_SLUG ) {
				array_push( $arf_input_style_label_position, ARF_PRODUCT_SLUG );
			}
		}
		return $arf_input_style_label_position;
	}
	function add_label_materialize_outside_editor( $field ) {
		if ( $field['type'] == 'arf_product' ) { ?>
			<label class="arf_main_label" id="field_<?php echo esc_html( $field['id'] ); ?>">
				<span class="arfeditorfieldopt_label arf_edit_in_place">
					<input type="text" class="arf_edit_in_place_input inplace_field" data-ajax="false" data-field-opt-change="true" data-field-opt-key='name' value="<?php echo esc_attr( $field['name'] ); ?>" data-field-id="<?php echo esc_html( $field['id'] ); ?>" />
				</span>
			</label>
			<?php
		}
	}
	function add_controls_added_class_outside_materialize( $class, $field_type ) {
		$return_class = $class;
		if ( $field_type == ARF_PRODUCT_SLUG ) {
			$return_class .= 'sltstandard_front';
		}
		return $return_class;

	}
	function arf_new_field_json_filter_outside( $field_json ) {

		if( !function_exists('WP_Filesystem' ) ){
        	require_once(ABSPATH . 'wp-admin/includes/file.php');
        }
        WP_Filesystem();
        global $wp_filesystem;

		$field_data                              = $wp_filesystem->get_contents( ARF_DIG_PRO_VIEWS_DIR . '/arf_download_field_data.json' );
		$field_data_array                        = json_decode( $field_data, true );
		$field_data_obj_arf_product              = $field_data_array['field_data']['arf_product'];
		$field_json['field_data']['arf_product'] = $field_data_obj_arf_product;
		return $field_json;
	}
	function arf_new_field_array_filter_outside_material( $field_options_new, $field_icons, $field_data_array, $positioned_field_icons ) {

		global $wpdb,$arf_digital_product_tbl,$as__products,$arfieldcontroller,$arf_version,$arfform,$maincontroller;

		if( !function_exists('WP_Filesystem' ) ){
        	require_once(ABSPATH . 'wp-admin/includes/file.php');
        }
        WP_Filesystem();
        global $wp_filesystem;

		$field_data                 = $wp_filesystem->get_contents( ARF_DIG_PRO_VIEWS_DIR . '/arf_download_field_data.json' );
		$field_data_array           = json_decode( $field_data );
		$field_data_obj_arf_product = $field_data_array->field_data->arf_product;
		$field_opt_arr              = array(
			ARF_PRODUCT_SLUG => array(
				'labelname'                 => 1,
				'attachfiletoemail'         => 2,
				'arf_product_exp_time'      => 3,
				'arf_download_show_link'    => 4,
				'arf_download_link_content' => 5,
			),
		);
		$field_order_arf_product    = isset( $field_opt_arr[ ARF_PRODUCT_SLUG ] ) ? $field_opt_arr[ ARF_PRODUCT_SLUG ] : '';
		if ( empty( $as__products ) ) {
			

			if( version_compare( $arf_version, '4.3', '<' ) ){

				$as__products = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_digital_product_tbl . ' WHERE status = %d ORDER BY id DESC ', 1 ) );

			}else{

				$as__products = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', 'WHERE status = %d', array(1), '', 'ORDER BY id DESC');

			}
		}

		$arf_digital_product_field_attr = array(
            'onchange' => 'arf_dig_pro_changeitemmeta(this.value,{arf_field_id});'
        );

        $arf_digital_product_field_opt_arr = array('-1' => addslashes (esc_html__('Please Select Product','ARForms-Digital-Product')));

		$selectbox_html  = '';

		/*$selectbox_html .= "<select name='item_meta[{arf_field_id}]' id=field_{arf_unique_key} onchange='arf_dig_pro_changeitemmeta(this.value,{arf_field_id});'><option value=''>".esc_html__('Please Select Product','ARForms-Digital-Product')."</option>";*/

		if ( ! empty( $as__products ) ) {

			$field['value'] = isset( $field['value'] ) ? $field['value'] : '';
			foreach ( $as__products as $key => $product ) {
				$options         = maybe_unserialize( $product->options );
				/*$selectbox_html .= "<option value='" . esc_html( $product->id ) . "'>" . $options['arf_product_name'] . '</option>';*/

				$arf_digital_product_field_opt_arr[esc_html( $product->id )] = $options['arf_product_name'];
			}
		} 

		/*$selectbox_html .= '</select>';*/
		
		$selectbox_html  .= $maincontroller->arf_selectpicker_dom( 'item_meta[{arf_field_id}]', 'field_{arf_unique_key}', 'arf_form_field_picker ', '', '', $arf_digital_product_field_attr, $arf_digital_product_field_opt_arr, false, array(), false, array(), false, array(), false, '', '', false );

		$arf_product_html = array(
			'arf_product' => "<div class='arf_inner_wrapper_sortable arfmainformfield edit_form_item arffieldbox ui-state-default 1  arf1columns single_column_wrapper' data-id='arf_editor_main_row_{arf_editor_index_row}'><div class='sortable_inner_wrapper edit_field_type_arf_product' inner_class='arf_1col' id='arfmainfieldid_{arf_field_id}'><div id='arf_field_{arf_field_id}' class='arfformfield control-group arfmainformfield top_container  arfformfield  arf_field_{arf_field_id}'><div class='fieldname-row' ><div class='fieldname'><label class='arf_main_label' id='field_{arf_field_id}'><span class='arfeditorfieldopt_label arf_edit_in_place'><input type='text' class='arf_edit_in_place_input inplace_field' data-ajax='false' data-field-opt-change='true' data-field-opt-key='name' value='Product' data-field-id='{arf_field_id}' /></span></label></div></div><div class='arf_fieldiconbox' data-field_id='{arf_field_id}'>" . $positioned_field_icons[ ARF_PRODUCT_SLUG ] . "</div><div class='controls sltstandard_front'>" . $selectbox_html . "<div class='help-block'></div><input type='hidden' name='arf_field_data_{arf_field_id}' id='arf_field_data_{arf_field_id}' value='" . htmlspecialchars( json_encode( $field_data_obj_arf_product ) ) . "' data-field_options='" . json_encode( $field_order_arf_product ) . "' /><div class='arf_field_option_model arf_field_option_model_cloned' data-field_id='{arf_field_id}'><div class='arf_field_option_model_header'>".esc_html__('Field Options','ARForms-Digital-Product')."</div><div class='arf_field_option_model_container'><div class='arf_field_option_content_row'></div></div><div class='arf_field_option_model_footer'><button type='button' class='arf_field_option_close_button' onClick='arf_close_field_option_popup();'>".esc_html__('Cancel','ARForms-Digital-Product')."</button><button type='button' class='arf_field_option_submit_button' data-field_id='{arf_field_id}'>".esc_html__('OK','ARForms-Digital-Product')."</button></div></div></div></div></div></div>",
		);
		return array_merge( $field_options_new, $arf_product_html );
	}
	function arf_new_field_array_filter_outside_material_outlined( $field_options_new, $field_icons, $field_data_array, $positioned_field_icons ) {

		global $wpdb,$arf_digital_product_tbl,$as__products,$arfieldcontroller,$arf_version,$arfform,$maincontroller;

		if( !function_exists('WP_Filesystem' ) ){
        	require_once(ABSPATH . 'wp-admin/includes/file.php');
        }
        WP_Filesystem();
        global $wp_filesystem;

		$field_data                 = $wp_filesystem->get_contents( ARF_DIG_PRO_VIEWS_DIR . '/arf_download_field_data.json' );
		$field_data_array           = json_decode( $field_data );
		$field_data_obj_arf_product = $field_data_array->field_data->arf_product;
		$field_opt_arr              = array(
			ARF_PRODUCT_SLUG => array(
				'labelname'                 => 1,
				'attachfiletoemail'         => 2,
				'arf_product_exp_time'      => 3,
				'arf_download_show_link'    => 4,
				'arf_download_link_content' => 5,
			),
		);
		$field_order_arf_product    = isset( $field_opt_arr[ ARF_PRODUCT_SLUG ] ) ? $field_opt_arr[ ARF_PRODUCT_SLUG ] : '';
		if ( empty( $as__products ) ) {	
			if( version_compare( $arf_version, '4.3', '<' ) ){

				$as__products = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_digital_product_tbl . ' WHERE status = %d ORDER BY id DESC ', 1 ) );

			}else{

				$as__products = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', 'WHERE status = %d', array(1), '', 'ORDER BY id DESC');

			}
		} 
		$selectbox_html  = '';
		
		$arf_main_label = '<label class="arf_main_label'.( ( isset( $field['default_value'] ) && "" != $field['default_value'] ) ? 'active' : '' ).'" id="field_{arf_field_id}"><span class="arfeditorfieldopt_label arf_edit_in_place">';
		$arf_main_label .= '<input type="text" class="arf_edit_in_place_input inplace_field" data-ajax="false" data-field-opt-change="true" data-field-opt-key="name" value="Product" data-field-id="{arf_field_id}" />';
        $arf_main_label .='</span></label>';

        $mo_active_container_cls = '';

        if( isset( $field['default_value'] ) && "" != $field['default_value'] ){
        	$mo_active_container_cls = 'arf_material_active_container_open';
        }

		$selectbox_html .= "<div class='arf_material_outline_container ".$mo_active_container_cls."'>";

		$arf_digital_product_mo_field_attr = array(
            'onchange' 	=> 'arf_dig_pro_changeitemmeta(this.value,{arf_field_id});',
            'data-placeholder' => 'Product'
        );

		if( isset( $field['default_value'] ) && "" != $field['default_value'] ){
			$arf_digital_product_mo_field_attr['class'] = 'arf_material_active';
		}

        $arf_digital_product_mo_field_opt_arr = array('' => addslashes(esc_html__('Please Select Product','ARForms-Digital-Product')));

		if ( ! empty( $as__products ) ) {
			$field['value'] = isset( $field['value'] ) ? $field['value'] : '';
			foreach ( $as__products as $key => $product ) {
				$options         = maybe_unserialize( $product->options );
				$arf_digital_product_mo_field_opt_arr[esc_html( $product->id )] = addslashes($options['arf_product_name']);

				/*$selectbox_html .= "<option value='" . esc_html( $product->id ) . "'>" . $options['arf_product_name'] . '</option>';*/
			}
		}

		$selectbox_html  .= $maincontroller->arf_selectpicker_dom( 'item_meta[{arf_field_id}]', 'field_{arf_unique_key}', 'arf_form_field_picker ', '', '', $arf_digital_product_mo_field_attr, $arf_digital_product_mo_field_opt_arr, false, array( '' => 'arf_material_outline_sel_data_label'), false, array(), false, array(), false, '', '', true );


		/*$selectbox_html .= '</select>';*/

			$arf_material_outliner_cls = '';

			$selectbox_html .= "<div class='arf_material_outliner'>";
			$selectbox_html .= "<div class='arf_material_outliner_prefix'></div>";
		    $selectbox_html .= "<div class='arf_material_outliner_notch ".$arf_material_outliner_cls."'>".$arf_main_label."</div>";
		    $selectbox_html .= "<div class='arf_material_outliner_suffix'></div>";
		    $selectbox_html .= "</div>";

		$selectbox_html .= '</div>';

		$arf_product_html = array(
			'arf_product' => "<div  class='arf_inner_wrapper_sortable arfmainformfield edit_form_item arffieldbox ui-state-default 1  arf1columns single_column_wrapper' data-id='arf_editor_main_row_{arf_editor_index_row}'><div class='sortable_inner_wrapper edit_field_type_arf_product' id='arfmainfieldid_{arf_field_id}' inner_class='arf_1col'><div id='arf_field_{arf_field_id}' class='arfformfield control-group arfmainformfield top_container arf_field_{arf_field_id}'><div class='arf_fieldiconbox' data-field_id='{arf_field_id}' data-field_id='{arf_field_id}'>" . $positioned_field_icons[ ARF_PRODUCT_SLUG ] . "</div><div class='controls sltstandard_front'>" . $selectbox_html . "<div class='help-block'></div></div><input type='hidden' name='arf_field_data_{arf_field_id}' id='arf_field_data_{arf_field_id}' value='" . htmlspecialchars( json_encode( $field_data_obj_arf_product ) ) . "' data-field_options='" . json_encode( $field_order_arf_product ) . "' /><div class='arf_field_option_model arf_field_option_model_cloned' data-field_id='{arf_field_id}'><div class='arf_field_option_model_header'>".esc_html__('Field Options','ARForms-Digital-Product')."</div><div class='arf_field_option_model_container'><div class='arf_field_option_content_row'></div></div><div class='arf_field_option_model_footer'><button type='button' class='arf_field_option_close_button' onClick='arf_close_field_option_popup();'>".esc_html__('Cancel','ARForms-Digital-Product')."</button><button type='button' class='arf_field_option_submit_button' data-field_id='{arf_field_id}'>".esc_html__('OK','ARForms-Digital-Product')."</button></div></div></div></div>",
		);
		return array_merge( $field_options_new, $arf_product_html );
	}
	function arf_new_field_array_filter_outside( $field_options_new, $field_icons, $field_data_array, $positioned_field_icons ) {

		global $wpdb,$arf_digital_product_tbl,$as__products,$arfieldcontroller,$arf_version,$arfform, $maincontroller;

		if( !function_exists('WP_Filesystem' ) ){
        	require_once(ABSPATH . 'wp-admin/includes/file.php');
        }
        WP_Filesystem();
        global $wp_filesystem;

		$field_data                 = $wp_filesystem->get_contents( ARF_DIG_PRO_VIEWS_DIR . '/arf_download_field_data.json' );
		$field_data_array           = json_decode( $field_data );
		$field_data_obj_arf_product = $field_data_array->field_data->arf_product;
		$field_opt_arr              = array(
			ARF_PRODUCT_SLUG => array(
				'labelname'                 => 1,
				'attachfiletoemail'         => 2,
				'arf_product_exp_time'      => 3,
				'arf_download_show_link'    => 4,
				'arf_download_link_content' => 5,
			),
		);
		$field_order_arf_product    = isset( $field_opt_arr[ ARF_PRODUCT_SLUG ] ) ? $field_opt_arr[ ARF_PRODUCT_SLUG ] : '';
		if ( empty( $as__products ) ) {

			if( version_compare( $arf_version, '4.3', '<' ) ){

				$as__products = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_digital_product_tbl . ' WHERE status = %d ORDER BY id  DESC ', 1 ) );
			}else{

				$as__products = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', 'WHERE status = %d', array(1), '', 'ORDER BY id  DESC');
			}
		}


		$arf_digital_product_field_attr = array(
            'onchange' => 'arf_dig_pro_changeitemmeta(this.value,{arf_field_id});'
        );

        $arf_digital_product_field_opt_arr = array('-1' => addslashes (esc_html__('Please Select Product','ARForms-Digital-Product')));

		$selectbox_html  = '';

		if ( ! empty( $as__products ) ) {

			$field['value'] = isset( $field['value'] ) ? $field['value'] : '';
			foreach ( $as__products as $key => $product ) {
				$options = maybe_unserialize( $product->options );

				/*echo "<pre>product->id => ";
				print_r($product->id);
				echo "</pre>";*/

				/*echo "<pre>arf_product_name =>";
				print_r($options['arf_product_name']);
				echo "</pre>";*/

				$arf_digital_product_field_opt_arr[$product->id] = $options['arf_product_name'];

				/*echo " arf_digital_product_field_opt_arr => ";
				echo "<pre>";
				print_r($arf_digital_product_field_opt_arr);
				echo "</pre>";*/
			}
		}
		
		$selectbox_html .= $maincontroller->arf_selectpicker_dom( 'item_meta[{arf_field_id}]', 'field_{arf_unique_key}', 'arf_form_field_picker ', '', '', $arf_digital_product_field_attr, $arf_digital_product_field_opt_arr, false, array(), false, array(), false, array(), false, '', '', false );


		/*$selectbox_html  = '';
		$selectbox_html .= "<select name='item_meta[{arf_field_id}]' id=field_{arf_unique_key} onchange='arf_dig_pro_changeitemmeta(this.value,{arf_field_id});'><option value=''>".esc_html__('Please select product','ARForms-Digital-Product')."</option>";
		if ( ! empty( $as__products ) ) {
			$field['value'] = isset( $field['value'] ) ? $field['value'] : '';
			foreach ( $as__products as $key => $product ) {
				$options         = maybe_unserialize( $product->options );
				$selectbox_html .= "<option value='" . esc_html( $product->id ) . "'>" . $options['arf_product_name'] . '</option>';
			}
		}
		$selectbox_html .= '</select>';*/

		$arf_product_html = array(
			'arf_product' => "<div  class='arf_inner_wrapper_sortable arfmainformfield edit_form_item arffieldbox ui-state-default 1  arf1columns single_column_wrapper' data-id='arf_editor_main_row_{arf_editor_index_row}'><div class='sortable_inner_wrapper edit_field_type_arf_product' id='arfmainfieldid_{arf_field_id}' inner_class='arf_1col'><div id='arf_field_{arf_field_id}' class='arfformfield control-group arfmainformfield top_container arf_field_{arf_field_id}'><div class='fieldname-row'><div class='fieldname'><label class='arf_main_label' id='field_{arf_field_id}'><span class='arfeditorfieldopt_label arf_edit_in_place'><input type='text' class='arf_edit_in_place_input inplace_field' data-ajax='false' data-field-opt-change='true' data-field-opt-key='name' value='Product' data-field-id='{arf_field_id}' /></span></label></div></div><div class='arf_fieldiconbox' data-field_id='{arf_field_id}' data-field_id='{arf_field_id}'>" . $positioned_field_icons[ ARF_PRODUCT_SLUG ] . "</div><div class='controls sltstandard_front'>" . $selectbox_html . "<div class='help-block'></div></div><input type='hidden' name='arf_field_data_{arf_field_id}' id='arf_field_data_{arf_field_id}' value='" . htmlspecialchars( json_encode( $field_data_obj_arf_product ) ) . "' data-field_options='" . json_encode( $field_order_arf_product ) . "' /><div class='arf_field_option_model arf_field_option_model_cloned' data-field_id='{arf_field_id}'><div class='arf_field_option_model_header'>".esc_html__('Field Options','ARForms-Digital-Product')."</div><div class='arf_field_option_model_container'><div class='arf_field_option_content_row'></div></div><div class='arf_field_option_model_footer'><button type='button' class='arf_field_option_close_button' onClick='arf_close_field_option_popup();'>".esc_html__('Cancel','ARForms-Digital-Product')."</button><button type='button' class='arf_field_option_submit_button' data-field_id='{arf_field_id}'>".esc_html__('OK','ARForms-Digital-Product')."</button></div></div></div></div>",
		);
		return array_merge( $field_options_new, $arf_product_html );
	}

	function arf_add_product_field_in_editor( $fields ){

		$fields[ARF_PRODUCT_SLUG] = array(
			'icon' => '<svg viewBox="0 0 30 30"><g id="arfdigitaldownload"><path fill-rule="evenodd" clip-rule="evenodd" fill="#4E5462" d="M27.142,18.242h1.999v7.997h-1.999V18.242z M16.377,21.783L16.377,21.783c-0.16,0.25-0.428,0.426-0.746,0.426c-0.32,0-0.588-0.176-0.748-0.427l0,0l-9-9.366c-0.346-0.358-0.337-0.93,0.021-1.276c0.359-0.345,0.929-0.336,1.275,0.022l7.55,7.859V1.105c0-0.498,0.404-0.902,0.902-0.902c0.124,0,0.242,0.025,0.351,0.071c0.323,0.137,0.552,0.457,0.552,0.831v17.916l7.549-7.859c0.178-0.184,0.412-0.275,0.648-0.275c0.226,0,0.451,0.084,0.627,0.254c0.357,0.347,0.368,0.917,0.021,1.276L16.377,21.783z M1.142,18.242h2v7.997h-2V18.242zM29.124,28.222H1.146l-0.031-1.938h28.04L29.124,28.222z"/></g></svg>',
			'label' => addslashes( esc_html__('Download','ARForms-Digital-Product') )
		);

		return $fields;
	}

	function arf_add_product_field_in_order( $ordered_list ){

		array_push( $ordered_list, ARF_PRODUCT_SLUG );

		return $ordered_list;
	}

	function arf_add_product_filed( $id = '', $is_ref_form = '', $values = '' ) {
		global $arf_dig_pro_field_class_name, $arf_dig_pro_new_field_data, $arf_dig_pro_field_image_path, $arf_dig_pro_total_class;

		if ( is_rtl() ) {
			$floating_style = 'float:right;';
		} else {
			$floating_style = 'float:left;';
		}

		foreach ( $arf_dig_pro_new_field_data as $field_key => $field_type ) {
			?>
		<li class="arf_form_element_item frmbutton frm_t<?php echo esc_html( $field_key ); ?>" id="<?php echo esc_html( $field_key ); ?>" data-type="<?php echo esc_html( $field_key ); ?>" data-field-id="<?php echo esc_html( $id ); ?>">
		<div class="arf_form_element_item_inner_container">
			<div class="arf_form_element_item_icon">
			<svg viewBox="0 0 30 30"><g id="arfdigitaldownload"><path fill-rule="evenodd" clip-rule="evenodd" fill="#4E5462" d="M27.142,18.242h1.999v7.997h-1.999V18.242z M16.377,21.783L16.377,21.783c-0.16,0.25-0.428,0.426-0.746,0.426c-0.32,0-0.588-0.176-0.748-0.427l0,0l-9-9.366c-0.346-0.358-0.337-0.93,0.021-1.276c0.359-0.345,0.929-0.336,1.275,0.022l7.55,7.859V1.105c0-0.498,0.404-0.902,0.902-0.902c0.124,0,0.242,0.025,0.351,0.071c0.323,0.137,0.552,0.457,0.552,0.831v17.916l7.549-7.859c0.178-0.184,0.412-0.275,0.648-0.275c0.226,0,0.451,0.084,0.627,0.254c0.357,0.347,0.368,0.917,0.021,1.276L16.377,21.783z M1.142,18.242h2v7.997h-2V18.242zM29.124,28.222H1.146l-0.031-1.938h28.04L29.124,28.222z"/></g>
			</svg>
			</div>
			<label class="arf_form_element_item_text"><?php echo esc_html( $field_type ); ?></label>
		</div>
		</li>
				<?php
		}
	}

	function arf_get_product_field_class( $class ) {
		global $arf_dig_pro_field_class_name, $arf_dig_pro_total_class;
		$as_class                = array_merge( $class, $arf_dig_pro_field_class_name );
		$arf_dig_pro_total_class = count( $as_class );
		return $as_class;
	}

	function add_availablefieldsbasicoptions( $basic_option ) {

		$signature_filed_option = array(
			ARF_PRODUCT_SLUG => array(
				'labelname'                 => 1,
				'attachfiletoemail'         => 2,
				'arf_product_exp_time'      => 3,
				'arf_download_show_link'    => 4,
				'arf_download_link_content' => 5,
			),
		);

		return array_merge( $basic_option, $signature_filed_option );
	}

	function arf_product_createfield( $field_data ) {

		if ( $field_data['type'] == ARF_PRODUCT_SLUG ) {
			$field_data['name'] = esc_html__( 'Products', 'ARForms-Digital-Product' );
		}

		return $field_data;
	}

	function add_product_field_to_editor_v3( $field, $inputStyle ) {

		/*echo "<pre>field Arr from here => ";
		print_r($field);
		echo "</pre>";*/

		global $arfajaxurl, $wpdb;
		$field_name = 'item_meta[' . $field['id'] . ']';
		require ARF_DIG_PRO_VIEWS_DIR . '/displayfield_in_editor_3.0.php';
	}

	function add_product_field_to_frontend_v3( $return_string, $form, $field_name, $arf_data_uniq_id, $field, $field_tootip, $field_description, $OFData, $inputStyle, $arf_main_label, $arf_on_change_function ) {
		global $style_settings, $arfsettings, $arfeditingentry, $arffield, $wpdb, $arf_digital_product_tbl, $arf_version, $arfform;
		$entry_id = $arfeditingentry;

		if ( $field['type'] == 'arf_product' ) {

			if ( $field['type'] == 'form' and $field['form_select'] ) {
				$dup_fields = $arffield->getAll( "fi.form_id='" . $field['form_select'] . "' and fi.type not in ('break', 'captcha')" );
			}
			if ( apply_filters( 'arf_check_for_draw_outside', false, $field ) ) {

				$return_string = apply_filters( 'arf_drawthisfieldfromoutside', $return_string, $field );
			} else {
				$field_va = isset( $field['default_value'] ) ? $field['default_value'] : '';
				
				if ( $field_va != '' ) {

					if( version_compare( $arf_version, '4.3', '<' ) ){
						
						$as__products = $wpdb->get_results( $wpdb->prepare( 'SELECT * FROM ' . $arf_digital_product_tbl . ' WHERE id = %d AND status = %d ORDER BY id DESC ', $field_va, 1 ) );

					}else{

						$as__products = $arfform->arf_select_db_data( true, '', $arf_digital_product_tbl, '*', 'WHERE id = %d AND status = %d', array($field_va, 1), '', 'ORDER BY id  DESC');
					}

					if ( $as__products ) {
						$return_string .= '<input type="hidden" name="' . $field_name . '" value="' . esc_attr( $field_va ) . '" />';
					}
				}
			}
		}
		return $return_string;
	}

	function arf_product_lable_hide( $default_html, $type ) {
		if ( $type == ARF_PRODUCT_SLUG ) {
			$default_html = '[input]';
			return $default_html;
		} else {
			return $default_html;
		}
	}

	function arf_add_more_product_field_v3() {

		?>
		<div class="arf_field_option_content_cell" id="arf_product_exp_time">
			<label class="arf_field_option_content_cell_label"><?php esc_html_e( 'Download Link Expiration:', 'ARForms-Digital-Product' ); ?></label>
			<div class="arf_field_option_content_cell_input">
				<input type="text" class="arf_field_option_input_text" name="arf_product_exp_time_val" value="" id="frm_custom_width_field_{arf_field_id}_div"/>
			</div>
			<p class="howto clear"><?php esc_html_e( 'How long should download links be valid for? Enter a time in hours', 'ARForms-Digital-Product' ); ?></p>
		</div>
		<div class="arf_field_option_content_cell" id="arf_download_show_link">
			<label class="arf_field_option_content_cell_label"><?php esc_html_e( 'Show download link after form submitted :', 'ARForms-Digital-Product' ); ?></label>
			<div class="arf_field_option_content_cell_input">
				<label class="arf_js_switch_label">
					<span><?php esc_html_e( 'NO', 'ARForms-Digital-Product' ); ?>&nbsp;</span>
				</label>
				<span class="arf_js_switch_wrapper arf_no_transition">
					<input type="checkbox" class="js-switch arf_download_show_link_{arf_field_id}" name="arf_download_show_link" id="field_options[arf_download_show_link_{arf_field_id}]" value="1" />
					<span class="arf_js_switch"></span>
				</span>
				<label class="arf_js_switch_label">
					<span>&nbsp;<?php esc_html_e( 'YES', 'ARForms-Digital-Product' ); ?></span>
				</label>
			</div>
		</div>
		<div class="arf_field_option_content_cell arf_clear arf_digpro_full_width" id="arf_download_link_content">
			<label class="arf_field_option_content_cell_label"><?php esc_html_e( 'Download Link Content', 'ARForms-Digital-Product' ); ?></label>
			<div class="arf_field_option_content_cell_input">
				<textarea id="arf_download_link_content_{arf_field_id}" name="arf_download_link_content" class="arf_field_option_input_textarea arf_digital_product_content_textarea"></textarea>
			</div>
		</div>
		<?php
	}
	function arf_save_product_field( $field_array ) {

		return array_merge( $field_array, array( 'arf_product_exp_time', 'arf_download_link_content', 'arf_download_show_link' ) );
	}

	function arf_dig_pro_set_product_field_width( $mainwidth, $fieldname, $field ) {

		if ( $field['type'] == ARF_PRODUCT_SLUG ) {
			if ( $fieldname == 'arf_download_link_content' ) {
				$mainwidth = '100%';
			}
			if ( $fieldname == 'arf_download_show_link' ) {
				$mainwidth = '39%';
			}
		}
		return $mainwidth;
	}

	function arf_dig_pro_add_product_options( $field_options, $type ) {
		return array_merge(
			$field_options,
			array(
				'arf_product_exp_time'      => '24',
				'arf_download_link_content' => sprintf(esc_html__( 'Please download your product by clicking below link %s', 'ARForms-Digital-Product' ),'[ARF_download_link  product_id="0" desc="Download"  type="link"]'),
				'arf_download_show_link'    => true,
			)
		);
	}

	function arf_dig_pro_hide_required_product_field_icon( $arf_disply_required_field, $field ) {
		if ( $field['type'] == ARF_PRODUCT_SLUG ) {
			$arf_disply_required_field = false;
		}
		return $arf_disply_required_field;
	}

}
?>