<?php
	$two = '1';
?>
<div class="alignleft actions">
	<div class="arf_list_bulk_action_wrapper">
		<input id="arf_bulk_action_one" name="action<?php echo esc_html( $two ); ?>" value="-1" type="hidden">
		<dl class="arf_selectbox" data-name="action<?php echo esc_html( $two ); ?>" data-id="arf_bulk_action_one">
			<dt>
				<span><?php echo esc_html__( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></span>
				<svg viewBox="0 0 2000 1000" width="15px" height="15px">
					<g fill="#000">
						<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
					</g>
				</svg>
			</dt>
			<dd>
				<ul data-id="arf_bulk_action_one">
					<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></li>
					<?php
					foreach ( $actions as $name => $title ) {
						$class = ('edit' == $name) ? ' class="hide-if-no-js" ' : '';
						?>
					<li <?php echo $class; ?> data-value='<?php echo esc_attr( $name ); ?>' data-label='<?php echo esc_attr( $title ); ?>'><?php echo esc_html( $title ); ?></li>
					<?php } ?>
				</ul>
			</dd>
		</dl>
	</div>
	<input type="submit" id="doaction<?php echo esc_html( $two ); ?>" class="arf_bulk_action_btn rounded_button btn_green" value="<?php echo esc_html__( 'Apply', 'ARForms-Digital-Product' ); ?>" />
</div>
<table cellpadding="0" cellspacing="0" border="0" class="display table_grid" id="example">
	<thead>
		<tr>
			<th class="center cb-select-all-checkbox">
				<div class="cb-select-all-checkbox-wrapper">
					<div class="arf_custom_checkbox_div">
						<div class="arf_custom_checkbox_wrapper">
							<input id="cb-select-all-1" type="checkbox" class="">
							<svg width="18px" height="18px">
								<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
								<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
							</svg>
						</div>
					</div>
					<label for="cb-select-all-1"  class="cb-select-all"><span></span></label>
				</div>
			</th>
			<th class=""><?php esc_html_e( 'Download ID', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Product ID', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Form ID', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Entry ID', 'ARForms-Digital-Product' ); ?></th>

			<th class=""><?php esc_html_e( 'Transaction ID / Subscription ID', 'ARForms-Digital-Product' ); ?></th>

			<th class=""><?php esc_html_e( 'Product Name', 'ARForms-Digital-Product' ); ?></th>


			<th class=""><?php esc_html_e( 'Payment Type', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Payment Method', 'ARForms-Digital-Product' ); ?></th>

			<th class=""><?php esc_html_e( 'Amount', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Payment Status', 'ARForms-Digital-Product' ); ?></th>
			<th class=""><?php esc_html_e( 'Created Date', 'ARForms-Digital-Product' ); ?></th>
			<th class="arf_col_action arf_action_cell"><?php esc_html_e( 'Action', 'ARForms-Digital-Product' ); ?></th>
		</tr>
	</thead>
</tbody>
<?php
global $arf_digital_product_download_tbl, $arf_digital_product_tbl, $arf_version, $arfform;
if ( version_compare( $arf_version, '5.0', '>' ) ) {
	global $wpdb, $MdlDb, $arformcontroller;
} else {
$as___payment = array();

if( version_compare( $arf_version, '4.3', '<' ) ){

	$downloads    = $wpdb->get_results( 'SELECT D.*,P.options FROM ' . $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id ORDER BY D.id DESC' );
}else{
	$tblnm = $arf_digital_product_download_tbl . ' AS D LEFT JOIN  ' . $arf_digital_product_tbl . ' AS P ON D.product_id = P.id';
	$downloads = $arfform->arf_select_db_data( true, '', $tblnm, 'D.*,P.options', '', array(), '', 'ORDER BY D.id DESC');
}

if ( count( $downloads ) > 0 ) {
	foreach ( $downloads as $download ) {
		
		$options      = maybe_unserialize( $download->options );
		$as___payment = $arf_dig_pro_user_products_class->arf_dig_pro_get_user_payment_detail( $download->payment_options, $download->form_id, $download->entry_id, $download->id );
		?>
		<tr class="arf_digpro_row">
			<td class="center">
			<div class="arf_custom_checkbox_div">
				<div class="arf_custom_checkbox_wrapper">
					<input id="cb-item-action-<?php echo esc_html( $download->id ); ?>" class="" type="checkbox" value="<?php echo esc_html( $download->id ); ?>" name="item-action[]">
					<svg width="18px" height="18px">
					<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
					<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
					</svg>
				</div>
			</div>
			<label for="cb-item-action-<?php echo esc_attr($download->id); ?>"><span></span></label>
			</td>
			<td class="center"><?php echo esc_html( $download->id ); ?></td>
			<td><?php echo esc_html( $download->product_id ); ?></td>
			<td><?php echo esc_html( $download->form_id ); ?></td>
			<td><?php echo esc_html( $download->entry_id ); ?></td>

			<td><?php echo isset( $as___payment[ $download->id ]['txn_id'] ) ? esc_html( $as___payment[ $download->id ]['txn_id'] ) : ''; ?></td>

			<td class="form_name"><a class="row-title" href="<?php echo esc_url( wp_nonce_url( "?page=ARForms-DigitalProduct&arfaction=edit&id={$download->product_id}" ) ); ?>"><?php echo esc_attr( $options['arf_product_name'] ); ?></a></td>

			<td><?php echo isset( $as___payment[ $download->id ]['payment_type'] ) ? esc_html( $as___payment[ $download->id ]['payment_type'] ) : ''; ?></td>
			<td><?php echo isset( $as___payment[ $download->id ]['payment_method'] ) ? esc_html( $as___payment[ $download->id ]['payment_method'] ) : ''; ?></td>
			<td><?php echo isset( $as___payment[ $download->id ]['total_amount'] ) ? esc_html ( $as___payment[ $download->id ]['total_amount'] ) . '&nbsp;' . esc_html( $as___payment[ $download->id ]['currency'] ) : ''; ?></td>
			<td><?php echo ( isset( $as___payment[ $download->id ]['payment_status'] ) && isset( $as___payment[ $download->id ]['currency'] ) ) ? esc_html( $as___payment[ $download->id ]['payment_status'] ) : ''; ?></td>
			<td class="center"><?php echo date( get_option( 'date_format' ), strtotime( $download->created_at ) ); ?></td>
			<td class="arf_action_cell arf_digpro_action_cell">
			<div class="arf-row-actions arf_digpr_no_top_padding">
			<?php
				echo "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'View Entry', 'ARForms-Digital-Product' ) . "'><a href='javascript:void(0);' onclick='open_entry_thickbox({$download->id});'><svg width='30px' height='30px' viewBox='-3 -8 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M12.993,15.23c-7.191,0-11.504-7.234-11.504-7.234  S5.801,0.85,12.993,0.85c7.189,0,11.504,7.19,11.504,7.19S20.182,15.23,12.993,15.23z M12.993,2.827  c-5.703,0-8.799,5.214-8.799,5.214s3.096,5.213,8.799,5.213c5.701,0,8.797-5.213,8.797-5.213S18.694,2.827,12.993,2.827z   M12.993,11.572c-1.951,0-3.531-1.581-3.531-3.531s1.58-3.531,3.531-3.531c1.949,0,3.531,1.581,3.531,3.531  S14.942,11.572,12.993,11.572z'/></svg></a></div>";
				echo "<div class='arfformicondiv arfhelptip arfdeleteentry_div_" . $download->id . "' title='" . esc_html__( 'Delete', 'ARForms-Digital-Product' ) . "'><a  data-id='" . $download->id . "' class='arfformentry_delete arf_digpro_cursor_pointer'><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

				echo "<div id='view_entry_detail_container_{$download->id}' class='arf_display_none'>" . $arf_dig_pro_user_products_class->arf_dig_pro_get_download_history_entries_list( $download, $as___payment ) . "</div><div class='arfmnarginbtm10 arf_digpro_clear_both'></div>";

			?>
			</div>
			</td>
		</tr>
		<?php
	}
}
}
?>
</tbody>
</table>

<div class="clear"></div>
<input type="hidden" name="show_hide_columns" id="show_hide_columns" value="<?php esc_html_e( 'Show / Hide columns', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="search_grid" id="search_grid" value="<?php esc_html_e( 'Search', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="entries_grid" id="entries_grid" value="<?php esc_html_e( 'entries', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="show_grid" id="show_grid" value="<?php esc_html_e( 'Show', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="showing_grid" id="showing_grid" value="<?php esc_html_e( 'Showing', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="to_grid" id="to_grid" value="<?php esc_html_e( 'to', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="of_grid" id="of_grid" value="<?php esc_html_e( 'of', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="no_match_record_grid" id="no_match_record_grid" value="<?php esc_html_e( 'No matching records found', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="no_record_grid" id="no_record_grid" value="<?php esc_html_e( 'No data available in table', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="filter_grid" id="filter_grid" value="<?php esc_html_e( 'filtered from', 'ARForms-Digital-Product' ); ?>"/>
<input type="hidden" name="totalwd_grid" id="totalwd_grid" value="<?php esc_html_e( 'total', 'ARForms-Digital-Product' ); ?>"/>

<div class="alignleft actions2">
	<?php
	$two = '3';
	?>
	<div class="arf_list_bulk_action_wrapper">
			<input id="arf_bulk_action_one" name="action<?php echo esc_attr( $two ); ?>" value="-1" type="hidden">
			<dl class="arf_selectbox" data-name="action<?php echo esc_attr( $two ); ?>" data-id="arf_bulk_action_one">
			<dt><span><?php echo esc_html__( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></span>
			<svg viewBox="0 0 2000 1000" width="15px" height="15px">
			<g fill="#000">
				<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
			</g>
			</svg>
			</dt>
			<dd>
			<ul data-id="arf_bulk_action_one">
				<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-Digital-Product' ); ?></li>
				<?php
				foreach ( $actions as $name => $title ) {
					$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
					?>
				<li <?php echo $class; ?> data-value='<?php echo esc_attr($name); ?>' data-label='<?php echo esc_attr($title); ?>'><?php echo esc_attr($title); ?></li>
				<?php } ?>
			</ul>
			</dd>
			</dl>
	</div>
		<input type="submit" id="doaction<?php echo esc_html( $two ); ?>" class="arf_bulk_action_btn rounded_button btn_green" value="<?php echo esc_html__( 'Apply', 'ARForms-Digital-Product' ); ?>" />
</div>

<div class="footer_grid"></div>