"use strict";

function arf_ChangeID(id) {
    document.getElementById('delete_entry_id').value = id;
    arfchangedeletemodalwidth('arfdeletemodabox');
}

function arfmymailformactionfunc(act, id) {
    if (act == 'delete') {
        id = document.getElementById('delete_entry_id').value;
    }
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        beforeSend: function() {
            jQuery(".arf_loader_icon_wrapper").show();
        },
        dataType:'json',
        data: "action=arf_mymail_delete_form&act=" + act + "&id=" + id,
        success: function(msg) {
            jQuery(".arf_loader_icon_wrapper").hide();

            if( msg.errors.length > 0 ){
                jQuery( "#error_msg_text" ).html( msg.errors[0] );
                error_msg();
            } else {
                jQuery( '#success_msg_text' ).html( msg.message );
                success_msg();
            }

            var mailster_table = jQuery( "form#arf_mymail_forms #example" ).DataTable();

            if(__ARF_DB_VERSION < 4.2){
                mailster_table.fnClearTable();
                mailster_table.fnDestroy();
            } else {
                mailster_table.clear();
                mailster_table.destroy();
            }

            var mailster_table = jQuery( 'form#arf_mymail_forms #example' );
          
            var msg_for_blank_table = __NO_FORM_FOUND_MSG;
            var dtobj = {
                "oLanguage": {
                    "sProcessing": "",
                    "sEmptyTable": msg_for_blank_table,
                    "sZeroRecords": msg_for_blank_table
                },
                "sDom": '<"H"lfr>t<"footer"ip>',
                "sPaginationType": "four_button",
                "bJQueryUI": true,
                "bPaginate": true,
                "bAutoWidth": false,
                "language":{
                    "searchPlaceholder": __SEARCH_MSG,
                    "search":"",
                },
                "ordering": true,
                "order":[[1,'desc']],
                "oColVis": {
                    "aiExclude": [0, 5]
                },
            }; 

            if(__ARF_DB_VERSION > 4.1){
                dtobj.language = {
                    "searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
                    "search":"",
                };
            }
            

            if( __ARF_DB_VERSION > 5.0 ){
                dtobj.bProcessing = true;
                dtobj.bServerSide = true;
                dtobj.sAjaxSource = ajaxurl;
                dtobj.sServerMethod = "POST";
                dtobj.fnServerParams = function (aoData) {
                    aoData.push(
                        {'name': 'action', 'value': 'arf_retrieve_mailster_config_data'},
                    );
                };
                dtobj.fnPreDrawCallback = function () {
                    jQuery("#arf_full_width_loader").show();
                };
                dtobj.fnDrawCallback = function (oSettings) {
                    jQuery(".arf_loader_icon_wrapper").hide();
                    if (jQuery.isFunction(jQuery().tooltipster)) {
                        jQuery('#arf_authorize_forms .arfhelptip').tipso('destroy');
                        if (jQuery.isFunction(jQuery().tipso)) {
                            jQuery('#arf_authorize_forms .arfhelptip').tipso({
                                position: 'top',
                                width: 'auto',
                                maxWidth: '400',
                                useTitle: true,
                                background: '#444444',
                                color: '#ffffff'
                            });
                        }
                    }
                };
                dtobj.aoColumnDefs = [
                    {"bSortable": false, "aTargets": [0, 5]},
                    {"sClass": "cbox","aTargets":[0]}, 
                    {"sClass": "","aTargets":[1]}, 
                    {"sClass": "","aTargets":[2]}, 
                    {"sClass": "","aTargets":[3]}, 
                    {"sClass": "","aTargets":[4]}, 
                    {"sClass": "arf_action_cell","aTargets":[5]} 
                ];
                mailster_table.dataTable(dtobj);
            } else {
                dtobj.aoColumnDefs = [
                    {"bSortable": false, "aTargets": [0, 5]},
                    {"sClass": "cbox","aTargets":[0]}, 
                    {"sClass": "","aTargets":[1]}, 
                    {"sClass": "","aTargets":[2]}, 
                    {"sClass": "","aTargets":[3]}, 
                    {"sClass": "","aTargets":[4]}, 
                    {"sClass": "arf_action_cell","aTargets":[5]} 
                ];
                mailster_table.dataTable(dtobj);
                if(msg.gridData.length > 0){
                    mailster_table.fnAddData( msg.gridData );
                }

                jQuery('#arf_mymail_forms .arfhelptip').tipso({
                    position: 'top',
                    maxWidth: '400',
                    useTitle: true,
                    background: '#444444',
                    color: '#ffffff'
                });
            }
        },
        error:function (){
            jQuery(".arf_loader_icon_wrapper").hide();
        }
    });
    if (act == 'delete') {
        jQuery('[data-dismiss="arfmodal"]').trigger("click");
    }
    return false;
}

function arf_mymail_form_bulk_act() {
    var str = jQuery('#arf_mymail_forms').serialize();
    var action1 = jQuery("#arf_bulk_action_one").val();
    var action2 = jQuery("#arf_bulk_action_two").val();
    var chk_count = jQuery("input[name='item-action[]']:checked").length;
    var final_action = action1 != '' ? action1 : action2;
    if (final_action == '' || final_action == '-1' || final_action == '-2') {
        jQuery("#error_msg_text").html(__NO_VALID_ACTION_MSG);
        error_msg();
        return false;
    } else if (final_action == 'bulk_delete') {
        if( chk_count == 0 ){
            jQuery("#error_msg_text").html(__SELECT_ONE_OR_MORE_FILE_MSG);
            error_msg();
            return false;
        } else {
            jQuery("#delete_bulk_mailster_form_message").addClass('arfactive');
            jQuery("#delete_bulk_mailster_form_message").parent('.arf_modal_overlay').addClass('arfactive');
        }
    } else {

        jQuery.ajax({
            type: "POST",
            url: ajaxurl,

            beforeSend: function() {
                jQuery(".arf_loader_icon_wrapper").show();
            },
            dataType:'json',
            data: "action=arf_mymail_form_bulk_act&" + str,
            success: function(msg) {
                jQuery(".arf_loader_icon_wrapper").hide();

                if( msg.errors.length > 0 ){
                    jQuery( "#error_msg_text" ).html( msg.errors[0] );
                    error_msg();
                } else {
                    jQuery( '#success_msg_text' ).html( msg.message );
                }

                var mailster_table = jQuery( "form#arf_mymail_forms #example" ).DataTable();

                if( __ARF_DB_VERSION < 4.2){
                    mailster_table.fnClearTable();
                    mailster_table.fnDestroy();
                }else{
                    mailster_table.clear();
                    mailster_table.destroy();
                }

                var mailster_table = jQuery( 'form#arf_mymail_forms #example' );
                var msg_for_blank_table = __NO_FORM_FOUND_MSG;

                var dtobj = {
                    "oLanguage": {
                        "sProcessing": "",
                        "sEmptyTable": msg_for_blank_table,
                        "sZeroRecords": msg_for_blank_table
                    },
                    "sDom": '<"H"lfr>t<"footer"ip>',
                    "sPaginationType": "four_button",
                    "bJQueryUI": true,
                    "bPaginate": true,
                    "bAutoWidth": false,
                    "language":{
                        "searchPlaceholder": __SEARCH_MSG,
                        "search":"",
                    },
                    "ordering": true,
                    "order":[[1,'desc']],
                    "oColVis": {
                        "aiExclude": [0, 5]
                    },
                }; 

                if(__ARF_DB_VERSION > 4.1){
                    dtobj.language = {
                        "searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
                        "search":"",
                    };
                }

                if( __ARF_DB_VERSION > 5.0 ){
                    dtobj.bProcessing = true;
                    dtobj.bServerSide = true;
                    dtobj.sAjaxSource = ajaxurl;
                    dtobj.sServerMethod = "POST";
                    dtobj.fnServerParams = function (aoData) {
                        aoData.push(
                            {'name': 'action', 'value': 'arf_retrieve_mailster_config_data'},
                        );
                    };
                    dtobj.fnPreDrawCallback = function () {
                        jQuery("#arf_full_width_loader").show();
                    };
                    dtobj.fnDrawCallback = function (oSettings) {
                        jQuery(".arf_loader_icon_wrapper").hide();
                        
                        if (jQuery.isFunction(jQuery().tooltipster)) {
                            jQuery('#arf_authorize_forms .arfhelptip').tipso('destroy');
                            if (jQuery.isFunction(jQuery().tipso)) {
                                jQuery('#arf_authorize_forms .arfhelptip').tipso({
                                    position: 'top',
                                    width: 'auto',
                                    maxWidth: '400',
                                    useTitle: true,
                                    background: '#444444',
                                    color: '#ffffff'
                                });
                            }
                        }
                    };
                    dtobj.aoColumnDefs = [
                        {"bSortable": false, "aTargets": [0, 5]},
                        {"sClass": "cbox","aTargets":[0]}, 
                        {"sClass": "","aTargets":[1]}, 
                        {"sClass": "","aTargets":[2]}, 
                        {"sClass": "","aTargets":[3]}, 
                        {"sClass": "","aTargets":[4]}, 
                        {"sClass": "arf_action_cell","aTargets":[5]} 
                    ];
                    mailster_table.dataTable(dtobj);
                } else {
                    mailster_table.dataTable(dt_obj);

                    if(msg.gridData.length > 0){
                        mailster_table.fnAddData( msg.gridData );
                    }

                    jQuery('#arf_mymail_forms .arfhelptip').tipso({
                        position: 'top',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });    
                }

                
            },
            error:function (){
                jQuery(".arf_loader_icon_wrapper").hide();
            }
        });
    }
    return false;
}

function arf_mymail_save() {
    var req = 0;
    if (jQuery('#arf_mymail_form').val() == '' && (jQuery('#arfaction').val() == 'new' || jQuery("#arfaction").val() == 'edit')) {
        jQuery('.arf_mymail_form .arfbtn.dropdown-toggle').css('border-color', '#FF0000');
        jQuery('.arf_mymail_form .arfdropdown-menu.open').css('border-color', '#FF0000');
        jQuery('#arf_mymail_form_msg').css('display', 'block');
        req++;
    } else {
        jQuery('.arf_mymail_form .arfbtn.dropdown-toggle').css('border-color', '');
        jQuery('.arf_mymail_form .arfdropdown-menu.open').css('border-color', '');
        jQuery('#arf_mymail_form_msg').css('display', 'none');
    }
    if (jQuery('#arf_mymail_arform_form').val() == '' && (jQuery('#arfaction').val() == 'new' || jQuery("#arfaction").val() == 'edit')) {
        jQuery('.arf_mymail_arform_form .arfbtn.dropdown-toggle').css('border-color', '#FF0000');
        jQuery('.arf_mymail_arform_form .arfdropdown-menu.open').css('border-color', '#FF0000');
        jQuery('#arf_mymail_arform_form_msg').css('display', 'block');
        req++;
    } else {
        jQuery('.arf_mymail_arform_form .arfbtn.dropdown-toggle').css('border-color', '');
        jQuery('.arf_mymail_arform_form .arfdropdown-menu.open').css('border-color', '');
        jQuery('#arf_mymail_arform_form_msg').css('display', 'none');
    }
    if (jQuery('#arf_mymail_list').val() == '' && jQuery("input[name='arf_mymaillist_checkbox[]']:checked").length == 0) {
        jQuery('#arf_mymail_list_msg').css('display', 'block');
        req++;
    } else {
        jQuery('.arf_mymail_list .arfbtn.dropdown-toggle').css('border-color', '');
        jQuery('.arf_mymail_list .arfdropdown-menu.open').css('border-color', '');
        jQuery('#arf_mymail_list_msg').css('display', 'none');
    }
    if (req > 0) {
        jQuery(window.opera ? 'html' : 'html, body').animate({
            scrollTop: jQuery('#poststuff').offset().top - 250
        }, 'slow');
        return false;
    }
    jQuery(".arfmymailrequiredfield").each(function() {
        if (jQuery("#" + this.id).find('.sltstandard select').val() == "") {
            jQuery("#" + this.id).find('.sltstandard select').css('border-color', '#FF0000');
            jQuery("#" + this.id).find('.arf_mymail_custom_fields .btn.dropdown-toggle').css('border-color', '#FF0000');
            jQuery("#" + this.id).find('.arf_mymail_custom_fields .arfdropdown-menu.open').css('border-color', '#FF0000');
            jQuery('#' + this.id + '_msg').css('display', 'block');
            req++;
        } else {
            jQuery("#" + this.id).find('.sltstandard select').css('border-color', '');
            jQuery("#" + this.id).find('.arf_mymail_custom_fields .btn.dropdown-toggle').css('border-color', '');
            jQuery("#" + this.id).find('.arf_mymail_custom_fields .arfdropdown-menu.open').css('border-color', '');
            jQuery('#' + this.id + '_msg').css('display', 'none');
        }
    });
    if (req > 0) {
        jQuery(window.opera ? 'html' : 'html, body').animate({
            scrollTop: jQuery('#mymail_fields_content').offset().top - 50
        }, 'slow');
        return false;
    } else {
        var ajaxurl = jQuery('#ajax_url').val();
        var form = jQuery("form#arf_mymail_setting").serialize();
        jQuery.ajax({
            url: ajaxurl,
            type: 'POST',
            dataType:'json',
            data:'action=arf_save_mailster_form_data&'+form,
            beforeSend:function(){
                jQuery('.arf_mailster_save_loader').addClass('active');
            },
            success: function( response ){
                jQuery('.arf_mailster_save_loader').removeClass('active');
                if( false == response.success && 'url' != response.message ){
                    jQuery("#error_msg_text").html( response.message );
                    error_msg();
                } else if( false == response.success && 'url' == response.message ) {
                    window.location.href = response.location;
                } else {
                    if( 'new' == response.arfaction ){
                        var pageurl = removeVariableFromURL( document.URL,'arfaction' );
                        pageurl    += '&arfaction=edit&id=' + response.new_id;

                        window.history.pushState( {path: pageurl}, '', pageurl );
                        jQuery("#arfaction").val('edit');
                        jQuery('#id').val( response.new_id );
                        jQuery('#form_id').val( response.form_id );
                    }
                    jQuery("#success_msg_text").html( response.message );
                    success_msg();
                }
            }
        });
    }

    return false;
}

function arf_arforms_form_change() {
    var form_id = jQuery('#arf_mymail_arform_form').val();
    jQuery("#custom_fields").html('');
    jQuery("#custom_fields_edit_mode").html('');
    jQuery("#add_new_custom_field_edit_mode").show(0);
    jQuery("#add_new_custom_field").show(0);
    jQuery("#total_custom_fields").val(0);
    jQuery("#last_custom_field_no").val(0);
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=arf_mymail_field_dropdown&form_id=" + form_id,
        success: function(msg) {
            jQuery('.arf_mymail_fields').each(function() {
                var id = jQuery(this).attr('id');
                if (id != 'undefined' || id != '') {
                    jQuery('#' + id).html(msg);
                    
                }
            });
        }
    });
    jQuery.ajax({
        type: 'POST',
        url: ajaxurl,
        data: 'action=arf_mymail_fill_list_fields&form_id=' + form_id,
        success: function(msg) {
            jQuery('#basic_mymail_lists #arf_mymail_front_list').each(function() {
                jQuery(this).next('dl').children('dd').children('ul').html(msg);
                if (jQuery(this).attr('type') == null) {
                    jQuery(this).html(msg);
                }
                
            });
        }
    });
}

function arf_mymail_form_change() {
    var mymail_form_id = jQuery('#arf_mymail_form').val();
    var form_id = jQuery('#arf_mymail_arform_form').val();
    if (form_id != 'undefined' && form_id != '') {
        form_id = jQuery('#form_id').val();
    }
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=arf_get_mymail_form_fields&mymail_form_id=" + mymail_form_id + "&form_id=" + form_id,
        success: function(msg) {
            jQuery('#mymail_fields_content').hide(0);
            jQuery('#mymail_fields_content').html(msg);
            jQuery('#mymail_fields_content').show(500);
            jQuery('.arf_mymail_fields').each(function() {
                var id = jQuery(this).attr('id');
                if (id != 'undefined' && id != '') {
                    
                }
            });
        }
    });
}

function removeVariableFromURL(url_string, variable_name) {
    var URL = String(url_string);
    var regex = new RegExp("\\?" + variable_name + "=[^&]*&?", "gi");
    URL = URL.replace(regex, '?');
    regex = new RegExp("\\&" + variable_name + "=[^&]*&?", "gi");
    URL = URL.replace(regex, '&');
    URL = URL.replace(/(\?|&)$/, '');
    regex = null;
    return URL;
}

function arf_delete_close_popup(id) {
    jQuery('.delete_form_message_' + id).hide();
    if (jQuery('.arfdeleteform_div_' + id).parents('.arf_action_cell').find('.delete_form_message_' + id).length > 0) {
        jQuery('.arfdeleteform_div_' + id).parents('.arf_action_cell').find('.delete_form_message_' + id).remove();
    }
}
// jQuery('.arf_mailster_delete').on('click', function(event) {
function arf_delete_mailster_entry(obj) {
    var id = jQuery(obj).attr('data-id');
    if (id == null || id == 'undefined') {
        return;
    }
    var delete_popup_html = '';
    delete_popup_html += '<div class="delete_popup arfactive delete_form_message_' + id + '" id="delete_form_message">';
    delete_popup_html += '<input type="hidden" value="' + id + '" id="delete_entry_id"/>';
    delete_popup_html += '<div class="delete_column_arrow" style="position:absolute;"></div>';
    delete_popup_html += '<div class="delete_title"><div class="delete_confirm_message">'+__DEL_CONF_MSG+'</div>';
    delete_popup_html += '<div class="delete_popup_footer">';
    delete_popup_html += '<button type="button" class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arfmymailformactionfunc(\'delete\',' + id + ');">'+__ARF_DELETE_TEXT+'</button>&nbsp;&nbsp;';
    delete_popup_html += '<button type="button" class="rounded_button delete_button arfdelete_color_gray" onclick="arf_delete_close_popup(' + id + ');">'+__ARF_CANCEL_TEXT+'</button>';
    delete_popup_html += '</div>';
    delete_popup_html += '</div>';
    delete_popup_html += '</div>';
    var select_content = jQuery(obj).parent().parent('.arf-row-actions');
    jQuery(delete_popup_html).insertAfter(select_content);
    jQuery('.delete_form_message_' + id).show();
}

function arf_modify_ajax_actions(actions_list){
    var arf_mymail_action_list = ['arf_retrieve_mailster_config_data'];
    actions_list = actions_list.concat(arf_mymail_action_list);
    return actions_list;
}

jQuery(document).ready(function() {
    wp.hooks.addFilter( 'arf_modify_datatable_action_outside', 'arfmymail', arf_modify_ajax_actions, 10 );
    if (jQuery("#arf_mymail_author").is(':checked')) {
        jQuery("#arf_mymail_author_list").attr('disabled', true);
        jQuery(".arf_mymail_author .dropdown-toggle").addClass('disabled');
    } else {
        jQuery("#arf_mymail_author_list").attr('disabled', false);
        jQuery(".arf_mymail_author .dropdown-toggle").removeClass('disabled');
    }
    if (jQuery("#arf_mymail_date").is(':checked')) {
        jQuery('#arf_mymail_date_list').attr('disabled', true);
        jQuery('.arf_mymail_date .dropdown-toggle').addClass('disabled');
    } else {
        jQuery('#arf_mymail_date_list').attr('disabled', false);
        jQuery('.arf_mymail_date .dropdown-toggle').removeClass('disabled');
    }
    if (jQuery("#arfaction").val() != "") {
        if (jQuery("#arfaction").val() == 'edit') {
            if (jQuery.trim(jQuery("#custom_fields_edit_mode").html()) != "") {
                jQuery("button#add_new_custom_field_edit_mode").css('display', 'none');
            } else {
                jQuery("button#add_new_custom_field_edit_mode").css('display', 'block');
            }
        } else if (jQuery("#arfaction").val() == 'new') {
            if (jQuery.trim(jQuery("#custom_fields").html()) != "") {
                jQuery("button#add_new_custom_field").css('display', 'none');
            } else {
                jQuery("button#add_new_custom_field").css('display', 'block');
            }
        }
    }
    jQuery("td").on('click', '#add_new_custom_field', function() {
        add_post_meta_row(1)
    });
    jQuery("td").on('click', '#add_new_custom_field_edit_mode', function() {
        edit_post_meta_row(1);
    });
    if (jQuery.isFunction(jQuery().tipso)) {
        setTimeout(function() {
            jQuery('.arfhelptip').tipso({
                position: 'top',
                maxWidth: '400',
                useTitle: true,
                background: '#444444',
                color: '#ffffff'
            });
        }, 10);
    }

    setTimeout(function(){
        jQuery("#arf_full_width_loader").hide();
    },500);
    jQuery("#cb-select-all-1").click(function () {
          jQuery('input[name="item-action[]"]').prop('checked', this.checked);
    });
    jQuery('input[name="item-action[]"]').click(function(){
        if(jQuery('input[name="item-action[]"]').length == jQuery('input[name="item-action[]"]:checked').length) {
            jQuery("#cb-select-all-1").prop("checked", true);
        } else {
            jQuery("#cb-select-all-1").prop("checked", false);
        }
    });

    if (jQuery("form#arf_mymail_forms").length > 0) {
        arf_init_mymail_list_forms();
    }
});

function add_post_meta_row(is_blank_meta) {
    if (document.getElementById("arf_mymail_form")) {
        var form_id = jQuery('#arf_mymail_form').val();
    } else {
        var form_id = jQuery('#form_id').val();
    }
    var fields = jQuery("#total_custom_fields").val();
    var arfaction = jQuery("#arfaction").val();
    var last_field = jQuery("#last_custom_field_no").val();
    var curr_post_type = "basic";
    var custom_post_type = "";
    if (jQuery("#arf_post_type_custom").attr('checked') == 'checked') {
        curr_post_type = "custom";
        custom_post_type = jQuery("#arf_mymail_custom_post").val();
    }
    if (jQuery("#arf_post_type_page").attr('checked') == 'checked') {
        curr_post_type = "page";
    }
    jQuery.ajax({
        type: 'POST',
        url: ajaxurl,
        data: 'action=add_custom_field&form_id=' + form_id + "&field_no=" + last_field + "&frm_action=" + arfaction + "&is_blank_meta=" + is_blank_meta + "&curr_post_type=" + curr_post_type + "&custom_post_type=" + custom_post_type,
        success: function(res) {
            if (res == '' || res == 0) {
                jQuery('#arf_mymail_custom_field_msg').css('display', 'block');
                return false;
            } else {
                jQuery("#custom_fields").append(res);
                jQuery('#arf_mymail_custom_field_msg').css('display', 'none');
                
                jQuery("#total_custom_fields").val(parseInt(fields) + 1);
                jQuery("#last_custom_field_no").val(parseInt(last_field) + 1);
                if (arfaction == 'new') {
                    if (jQuery("#custom_fields").html().trim() != "") {
                        jQuery("button#add_new_custom_field").css('display', 'none');
                    } else {
                        jQuery("button#add_new_custom_field").css('display', 'block');
                    }
                } else {
                    if (jQuery("#custom_fields_edit_mode").html().trim() == "") {
                        jQuery("#buttom#add_new_custom_field_edit_mode").css('display', 'block');
                    } else {
                        jQuery("#buttom#add_new_custom_field_edit_mode").css('display', 'none');
                    }
                }
            }
        }
    });
}

function edit_post_meta_row(is_blank_meta) {
    var form_id = jQuery("#form_id").val();
    var fields = jQuery("#total_custom_fields").val();
    var last_field = jQuery("#last_custom_field_no").val();
    var arfaction = jQuery("#arfaction").val();
    var curr_post_type = "basic";
    var custom_post_type = "";
    if (jQuery("#arf_post_type_custom").attr('checked') == 'checked') {
        curr_post_type = "custom";
        custom_post_type = jQuery("#arf_mymail_custom_post").val();
    }
    if (jQuery("#arf_post_type_page").attr('checked') == 'checked') {
        curr_post_type = "page";
    }
    var action = "";
    jQuery.ajax({
        type: 'POST',
        url: ajaxurl,
        data: 'action=add_custom_field&form_id=' + form_id + "&field_no=" + last_field + "&frm_action=" + arfaction + "&is_blank_meta=" + is_blank_meta + "&curr_post_type=" + curr_post_type + "&custom_post_type=" + custom_post_type,
        success: function(res) {
            if (res == '' || res == 0) {
                jQuery('#arf_mymail_custom_field_msg').css('display', 'block');
                return false;
            } else {
                jQuery("#custom_fields_edit_mode").append(res);
                jQuery('#arf_mymail_custom_field_msg').css('display', 'none');
                
                jQuery("#total_custom_fields").val(parseInt(fields) + 1);
                jQuery("#last_custom_field_no").val(parseInt(last_field) + 1);
                if (arfaction == 'new') {
                    if (jQuery("#custom_fields").html().trim() != "") {
                        jQuery("button#add_new_custom_field").css('display', 'none');
                    } else {
                        jQuery("button#add_new_custom_field").css('display', 'block');
                    }
                } else {
                    if (jQuery("#custom_fields_edit_mode").html().trim() != "") {
                        jQuery("button#add_new_custom_field_edit_mode").css('display', 'none');
                    } else {
                        jQuery("button#add_new_custom_field_edit_mode").css('display', 'block');
                    }
                }
            }
        }
    });
}

function remove_meta_row(tag, id) {
    jQuery(tag).remove();
    var fields = jQuery("#total_custom_fields").val();
    jQuery("#total_custom_fields").val(parseInt(fields) - 1);
    var total = jQuery("#total_custom_fields").val();
    var arfaction = jQuery("#arfaction").val();
    var pre_id = parseInt(id) - 1;
    if (arfaction == 'new') {
        if (jQuery("#custom_fields").html().trim() == "") {
            jQuery("button#add_new_custom_field").css('display', 'block');
        }
    } else {
        if (jQuery("#custom_fields_edit_mode").html().trim() == "" && arfaction == 'edit') {
            jQuery("button#add_new_custom_field_edit_mode").css('display', 'block');
        }
    }
}

function is_checked(id, status) {
    var form_id = jQuery("#form_id").val();
    jQuery("#custom_fields").html('');
    jQuery("#custom_fields_edit_mode").html('');
    jQuery("#add_new_custom_field_edit_mode").show(0);
    jQuery("#add_new_custom_field").show(0);
    jQuery("#arf_mymail_category").parent().css('display', 'table-row');
    jQuery("#arf_mymail_format").parent().css('display', 'table-row');
    jQuery("#arf_mymail_tags").css('display', 'table-row');
    jQuery("#arf_mymail_excerpt_main").css('display', 'table-row');
    if (id == 'arf_post_type_custom' && status == true) {
        jQuery.ajax({
            type: 'POST',
            url: ajaxurl,
            data: 'action=arf_mymail_custom_post_field',
            success: function(msg) {
                if (jQuery("#arf_post_type_custom").is(':checked') == true) {
                    jQuery('.arf_mymail_custom_post').each(function() {
                        var id = jQuery(this).attr('id');
                        if (id != 'undefined' && id != '') {
                            jQuery('#' + id).html(msg);
                            
                        }
                        jQuery("#custom_post_type_list").css('display', 'table-row');
                        jQuery("#custom_post_fields").css('display', 'table-row');
                        jQuery("#arf_mymail_tags").css('display', 'none');
                    });
                }
            }
        });
    } else if (id == 'arf_post_type_page' && status == true) {
        jQuery("#custom_post_type_list").css('display', 'none');
        jQuery("#custom_post_fields").css('display', 'none');
        jQuery("#arf_mymail_category").parent().css('display', 'none');
        jQuery("#arf_mymail_format").parent().css('display', 'none');
        jQuery("#arf_mymail_tags").css('display', 'none');
        jQuery("#arf_mymail_excerpt_main").css('display', 'none');
    } else {
        jQuery("#custom_post_type_list").css('display', 'none');
        jQuery("#custom_post_fields").css('display', 'none');
        jQuery("#arf_mymail_tags").css('display', 'table-row');
        var details = ['basic', form_id];
        get_custom_post_categories(details);
    }
}

function is_mymaillist_selected(value, parent_id) {
    var main_id = "#" + parent_id;
    if (value != "") {
        jQuery(main_id).find('.radiobutton').each(function() {
            jQuery(this).find('input').attr('disabled', 'disabled');
        });
    } else {
        jQuery(main_id).find('.radiobutton').each(function() {
            jQuery(this).find('input').removeAttr('disabled');
        });
    }
}

function is_mymail_condition() {
    if (jQuery('#arf_mymail_condition').is(':checked')) {
        jQuery('#conditional_logic_div_mymail').show();
    } else {
        jQuery('#conditional_logic_div_mymail').hide();
    }
}

function arf_add_new_law_mymail() {
    jQuery('.bulk_add').attr('disabled', true);
    var form_id = jQuery('#arf_mymail_arform_form').val();
    var metas = [];
    jQuery('input[name^="rule_array_mymail"]').each(function() {
        metas.push(this.value);
    });
    if (metas.length > 0) {
        var maxValueInArray = Math.max.apply(Math, metas);
        var next_meta_id = parseInt(maxValueInArray) + parseInt(1);
    } else {
        var next_meta_id = 1;
    }
    if (form_id == '' || form_id == 'undefined') {
        form_id = '0';
    }
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=add_new_rule_mymail&form_id=" + form_id + "&next_rule_id=" + next_meta_id,
        success: function(msg) {
            jQuery('#arf_new_law_mymail').hide();
            jQuery('#conditional_logic_if_cond_mymail').attr('disabled', false);
            
            try {
                jQuery('#conditional_logic_if_cond_mymail').parents('.sltstandard').first().tipso('destroy');
                jQuery('#conditional_logic_if_cond_mymail').parents('.sltstandard').first().removeAttr('title');
            } catch (e) {}
            jQuery('#logic_rules_div_mymail').show();
            jQuery('#logic_rules_div_mymail').append('<div id="arf_cl_rule_mymail_' + next_meta_id + '" class="cl_rules">' + msg + '</div>');
            jQuery('.bulk_add').attr('disabled', false);
            
        }
    });
}

function delete_rule_mymail(field) {
    if (jQuery('.logic_rules_div .cl_rules').length > 1) {
        jQuery(field).parents('.cl_rules').first().remove();
    } else {
        jQuery(field).parents('.cl_rules').first().remove();
        jQuery('#conditional_logic_if_cond_mymail').attr('disabled', true);
        
        jQuery('#arf_new_law_mymail').show();
        if (typeof(__ARFADDRULE) != 'undefined') {
            var atitle = __ARFADDRULE;
        } else {
            var atitle = 'Please add one or more rules';
        }
        jQuery('#conditional_logic_if_cond_mymail').parents('.sltstandard').first().tipso({
            position: 'top',
            maxWidth: '400',
            useTitle: true,
            background: '#444444',
            color: '#ffffff'
        });
    }
}

function arf_init_mymail_list_forms() {
    jQuery.fn.dataTableExt.oPagination.four_button = {
        "fnInit": function(oSettings, nPaging, fnCallbackDraw) {
            nFirst = document.createElement('span');
            nPrevious = document.createElement('span');
            var nInput = document.createElement('input');
            var nPage = document.createElement('span');
            var nOf = document.createElement('span');
            nOf.className = "paginate_of";
            nInput.className = "current_page_no";
            nPage.className = "paginate_page";
            nInput.type = "text";
            nInput.style.width = "40px";
            nInput.style.height = "26px";
            nInput.style.display = "inline";
            nPaging.appendChild(nPage);
            jQuery(nInput).keyup(function(e) {
                if (e.which == 38 || e.which == 39) {
                    this.value++;
                } else if ((e.which == 37 || e.which == 40) && this.value > 1) {
                    this.value--;
                }
                if (this.value == "" || this.value.match(/[^0-9]/)) {
                    return;
                }
                var iNewStart = oSettings._iDisplayLength * (this.value - 1);
                if (iNewStart > oSettings.fnRecordsDisplay()) {
                    oSettings._iDisplayStart = (Math.ceil((oSettings.fnRecordsDisplay() - 1) / oSettings._iDisplayLength) - 1) * oSettings._iDisplayLength;
                    fnCallbackDraw(oSettings);
                    return;
                }
                oSettings._iDisplayStart = iNewStart;
                fnCallbackDraw(oSettings);
            });
            var nNext = document.createElement('span');
            var nLast = document.createElement('span');
            var nFirst = document.createElement('span');
            var nPrevious = document.createElement('span');
            var nPage = document.createElement('span');
            var nOf = document.createElement('span');
            nNext.style.backgroundRepeat = "no-repeat";
            nNext.style.backgroundPosition = "center";
            nNext.title = "Next";
            nLast.style.backgroundRepeat = "no-repeat";
            nLast.style.backgroundPosition = "center";
            nLast.title = "Last";
            nFirst.style.backgroundRepeat = "no-repeat";
            nFirst.style.backgroundPosition = "center";
            nFirst.title = "First";
            nPrevious.style.backgroundRepeat = "no-repeat";
            nPrevious.style.backgroundPosition = "center";
            nPrevious.title = "Previous";
            nFirst.appendChild(document.createTextNode(' '));
            nPrevious.appendChild(document.createTextNode(' '));
            nLast.appendChild(document.createTextNode(' '));
            nNext.appendChild(document.createTextNode(' '));
            nOf.className = "paginate_button nof";
            nPaging.appendChild(nFirst);
            nPaging.appendChild(nPrevious);
            nPaging.appendChild(nInput);
            nPaging.appendChild(nOf);
            nPaging.appendChild(nNext);
            nPaging.appendChild(nLast);
            jQuery(nFirst).click(function() {
                oSettings.oApi._fnPageChange(oSettings, "first");
                fnCallbackDraw(oSettings);
            });
            jQuery(nPrevious).click(function() {
                oSettings.oApi._fnPageChange(oSettings, "previous");
                fnCallbackDraw(oSettings);
            });
            jQuery(nNext).click(function() {
                oSettings.oApi._fnPageChange(oSettings, "next");
                fnCallbackDraw(oSettings);
            });
            jQuery(nLast).click(function() {
                oSettings.oApi._fnPageChange(oSettings, "last");
                fnCallbackDraw(oSettings);
            });
            jQuery(nFirst).bind('selectstart', function() {
                return false;
            });
            jQuery(nPrevious).bind('selectstart', function() {
                return false;
            });
            jQuery('span', nPaging).bind('mousedown', function() {
                return false;
            });
            jQuery('span', nPaging).bind('selectstart', function() {
                return false;
            });
            jQuery(nNext).bind('selectstart', function() {
                return false;
            });
            jQuery(nLast).bind('selectstart', function() {
                return false;
            });
        },
        "fnUpdate": function(oSettings, fnCallbackDraw) {
            if (!oSettings.aanFeatures.p) {
                return;
            }
            var an = oSettings.aanFeatures.p;
            for (var i = 0, iLen = an.length; i < iLen; i++) {
                var buttons = an[i].getElementsByTagName('span');
                if (oSettings._iDisplayStart === 0) {
                    buttons[1].className = "paginate_disabled_first arfhelptip";
                    buttons[2].className = "paginate_disabled_previous arfhelptip";
                } else {
                    buttons[1].className = "paginate_enabled_first arfhelptip";
                    buttons[2].className = "paginate_enabled_previous arfhelptip";
                }
                if (oSettings.fnDisplayEnd() == oSettings.fnRecordsDisplay()) {
                    buttons[4].className = "paginate_disabled_next arfhelptip";
                    buttons[5].className = "paginate_disabled_last arfhelptip";
                } else {
                    buttons[4].className = "paginate_enabled_next arfhelptip";
                    buttons[5].className = "paginate_enabled_last arfhelptip";
                }
                if (!oSettings.aanFeatures.p) {
                    return;
                }
                var iPages = Math.ceil((oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength);
                var iCurrentPage = Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength) + 1;
                if (document.getElementById('of_grid')){
                    var of_grid = document.getElementById('of_grid').value;
                } else { 
                    var of_grid = 'of';
                }
                var an = oSettings.aanFeatures.p;
                for (var i = 0, iLen = an.length; i < iLen; i++) {
                    var spans = an[i].getElementsByTagName('span');
                    var inputs = an[i].getElementsByTagName('input');
                    spans[spans.length - 3].innerHTML = " " + of_grid + " " + iPages
                    inputs[0].value = iCurrentPage;
                }
            }
        }
    }

    var msg_for_blank_table = __NO_FORM_FOUND_MSG;
   
     var dtobj = {
        "oLanguage": {
            "sProcessing": "",
            "sEmptyTable": msg_for_blank_table,
            "sZeroRecords": msg_for_blank_table
        },
        "sDom": '<"H"lfr>t<"footer"ip>',
        "sPaginationType": "four_button",
        "bJQueryUI": true,
        "bPaginate": true,
        "bAutoWidth": false,
        "language":{
            "searchPlaceholder": __SEARCH_MSG,
            "search":"",
        },
        "ordering": true,
        "order":[[1,'desc']],
        "oColVis": {
            "aiExclude": [0, 5]
        },
    }; 


    if( __ARF_DB_VERSION > 5.0 ){
        dtobj.bProcessing = true;
        dtobj.bServerSide = true;
        dtobj.sAjaxSource = ajaxurl;
        dtobj.sServerMethod = "POST";
        dtobj.fnServerParams = function (aoData) {
            aoData.push(
                {'name': 'action', 'value': 'arf_retrieve_mailster_config_data'},
            );
        };
        dtobj.fnPreDrawCallback = function () {
            jQuery("#arf_full_width_loader").show();
        };
        dtobj.fnDrawCallback = function (oSettings) {
            jQuery(".arf_loader_icon_wrapper").hide();
            
            if (jQuery.isFunction(jQuery().tooltipster)) {
                jQuery('#arf_authorize_forms .arfhelptip').tipso('destroy');
                if (jQuery.isFunction(jQuery().tipso)) {
                    jQuery('#arf_authorize_forms .arfhelptip').tipso({
                        position: 'top',
                        width: 'auto',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });
                }
            }
        };
        dtobj.aoColumnDefs = [
            {"bSortable": false, "aTargets": [0, 5]},
            {"sClass": "cbox","aTargets":[0]}, 
            {"sClass": "","aTargets":[1]}, 
            {"sClass": "","aTargets":[2]}, 
            {"sClass": "","aTargets":[3]}, 
            {"sClass": "","aTargets":[4]}, 
            {"sClass": "arf_action_cell","aTargets":[5]} 
        ];
    } else {
        dtobj.aoColumnDefs = [
            {"bSortable": false, "aTargets": [0, 5]},
            {"sClass": "cbox","aTargets":[0]}, 
            {"sClass": "","aTargets":[1]}, 
            {"sClass": "","aTargets":[2]}, 
            {"sClass": "","aTargets":[3]}, 
            {"sClass": "","aTargets":[4]}, 
            {"sClass": "arf_action_cell","aTargets":[5]} 
        ];
    }
    if(__ARF_DB_VERSION > 4.1){
        dtobj.language = {
            "searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
            "search":"",
        };
    }
    jQuery('#arf_mymail_forms #example').dataTable(dtobj);
}


function arf_delete_bulk_mailster_form(is_delete){
    if( is_delete ){
        var str = jQuery('#arf_mymail_forms').serialize();
        jQuery.ajax({
            type: "POST",
            url: ajaxurl,
            dataType : 'json',
            data: "action=arf_mymail_form_bulk_act&" + str,
            beforeSend: function() {
                jQuery(".arf_loader_icon_wrapper").show();
            },
            success: function(msg) {
                jQuery(".arf_loader_icon_wrapper").hide();
                if ( 0 < msg.errors.length ) {
                    jQuery( '#error_msg_text' ).html( msg.errors[0] );
                    error_msg();
                }else{

                    jQuery( "#success_msg_text" ).html( msg.message );
                    success_msg();

                    var ProductTable = jQuery( "#arf_mymail_forms #example" ).DataTable();
                    if(__ARF_DB_VERSION < 4.2){
                        ProductTable.fnClearTable();
                        ProductTable.fnDestroy();
                    } else{
                        ProductTable.clear();
                        ProductTable.destroy();
                    }

                    var ProductTableNew = jQuery( '#arf_mymail_forms #example' );

                    var msg_for_blank_table = __NO_FORM_FOUND_MSG;
                    var dtobj = {
                        "oLanguage": {
                            "sProcessing": "",
                            "sEmptyTable": jQuery( '#list_order_msg_for_blank_table' ).val(),
                            "sZeroRecords": jQuery( '#list_order_msg_for_blank_table' ).val(),
                        },
                        "sDom": '<"H"lfr>t<"footer"ip>',
                        "sPaginationType": "four_button",
                        "bJQueryUI": true,
                        "bPaginate": true,
                        "bAutoWidth": false,
                        "language":{
                            "searchPlaceholder": __SEARCH_MSG,
                            "search":"",
                        },
                        "ordering": true,
                        "order":[[1,'desc']],
                        "oColVis": {
                            "aiExclude": [0, 5]
                        },
                    }; 
                    if(__ARF_DB_VERSION > 4.1){
                        dtobj.language = {
                            "searchPlaceholder":__ARF_SEARCH_PLACEHOLDER,
                            "search":"",
                        };
                    }

                    if( __ARF_DB_VERSION > 5.0 ){
                        dtobj.bProcessing = true;
                        dtobj.bServerSide = true;
                        dtobj.sAjaxSource = ajaxurl;
                        dtobj.sServerMethod = "POST";
                        dtobj.fnServerParams = function (aoData) {
                            aoData.push(
                                {'name': 'action', 'value': 'arf_retrieve_mailster_config_data'},
                            );
                        };
                        dtobj.fnPreDrawCallback = function () {
                            jQuery("#arf_full_width_loader").show();
                        };
                        dtobj.fnDrawCallback = function (oSettings) {
                            jQuery(".arf_loader_icon_wrapper").hide();
                            
                            if (jQuery.isFunction(jQuery().tooltipster)) {
                                jQuery('#arf_authorize_forms .arfhelptip').tipso('destroy');
                                if (jQuery.isFunction(jQuery().tipso)) {
                                    jQuery('#arf_authorize_forms .arfhelptip').tipso({
                                        position: 'top',
                                        width: 'auto',
                                        maxWidth: '400',
                                        useTitle: true,
                                        background: '#444444',
                                        color: '#ffffff'
                                    });
                                }
                            }
                        };
                        dtobj.aoColumnDefs = [
                            {"bSortable": false, "aTargets": [0, 5]},
                            {"sClass": "cbox","aTargets":[0]}, 
                            {"sClass": "","aTargets":[1]}, 
                            {"sClass": "","aTargets":[2]}, 
                            {"sClass": "","aTargets":[3]}, 
                            {"sClass": "","aTargets":[4]}, 
                            {"sClass": "arf_action_cell","aTargets":[5]} 
                        ];
                        ProductTableNew.dataTable(dtobj);
                    } else {
                        dtobj.aoColumnDefs = [
                            {"bSortable": false, "aTargets": [0, 5]},
                            {"sClass": "cbox","aTargets":[0]}, 
                            {"sClass": "","aTargets":[1]}, 
                            {"sClass": "","aTargets":[2]}, 
                            {"sClass": "","aTargets":[3]}, 
                            {"sClass": "","aTargets":[4]}, 
                            {"sClass": "arf_action_cell","aTargets":[5]} 
                        ];
                        ProductTableNew.dataTable(dtobj);

                        if(msg.gridData.length > 0){
                            ProductTableNew.fnAddData( msg.gridData );
                        }
                    }   
                }   
                   
                jQuery('#arf_mymail_forms .arfhelptip').tipso('destroy');
                if (jQuery.isFunction(jQuery().tipso)) {
                    jQuery('#arf_mymail_forms .arfhelptip').tipso({
                        position: 'top',
                        width: 'auto',
                        maxWidth: '400',
                        useTitle: true,
                        background: '#444444',
                        color: '#ffffff'
                    });
                }
                
            },
            error: function(msg){
                jQuery( ".arf_loader_icon_wrapper" ).hide();
            }
        });
    }
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
}

jQuery(document).on('click', '.arf_bulk_delete_transaction_close_btn', function() {
    jQuery('.arf_modal_overlay.arfactive').removeClass('arfactive');
});

jQuery(document).on('change','input[type="radio"][name="arf_mymail_list_selection"]',function(){
    var list_selection = this.value;

    if( 'manual' == list_selection ){
        jQuery('#arf_mlstr_manual_list_selection_wrapper').removeClass('arf_mailster_hidden_section');
        jQuery('#arf_mlstr_user_list_selection_wrapper').addClass('arf_mailster_hidden_section');
    } else {
        jQuery('#arf_mlstr_user_list_selection_wrapper').removeClass('arf_mailster_hidden_section');
        jQuery('#arf_mlstr_manual_list_selection_wrapper').addClass('arf_mailster_hidden_section');
    }
});

jQuery(document).on('change','#arf_mymail_front_list-all',function(){
    var checked = this.checked;

    if( checked ){
        jQuery('input[type="checkbox"][name="arf_mymailfrontlist_checkbox[]"]').removeAttr('checked');
    }

});

jQuery(document).on('change','input[name="arf_mymailfrontlist_checkbox[]"]',function(){
    var total_checked = jQuery('input[name="arf_mymailfrontlist_checkbox[]"]:checked').length;

    if( total_checked > 0 ){
        jQuery("#arf_mymail_front_list-all").removeAttr('checked');
    }
});

function is_mailster_condition() {
    if (jQuery('#arf_mailster_condition').is(':checked')) {
        jQuery('#conditional_logic_div_mailster').show();
    } else {
        jQuery('#conditional_logic_div_mailster').hide();
    }
}


function arf_add_new_law_mailster() {
    jQuery('#conditional_logic_if_cond_mailster').next('dl').children('dt').removeClass('arf_disable_selectbox');
    jQuery('#conditional_logic_div_mailster').find('dl').removeClass('arf_disabled');
    jQuery('#conditional_logic_if_cond_mailster').attr('disable', false);
    jQuery('.bulk_add').attr('disabled', true);
    var form_id = jQuery('#form_id').val();
    var metas = [];
    jQuery('input[name^="rule_array_mailster"]').each(function() {
        metas.push(this.value);
    });
    if (metas.length > 0) {
        var maxValueInArray = Math.max.apply(Math, metas);
        var next_meta_id = parseInt(maxValueInArray) + parseInt(1);
    } else {
        var next_meta_id = 1;
    }
    if (form_id == '' || form_id == 'undefined') {
        form_id = '0';
    }
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=add_new_rule_mailster&form_id=" + form_id + "&next_rule_id=" + next_meta_id,
        success: function(msg) {
            jQuery('#arf_new_law_mailster').hide();
            jQuery('#conditional_logic_if_cond_mailster').attr('disabled', false);
            
            try {
                jQuery('#conditional_logic_if_cond_mailster').parents('.sltstandard').first().tipso('destroy');
            } catch (e) {}
            jQuery('#logic_rules_div_mailster').show();
            jQuery('#logic_rules_div_mailster').append('<div id="arf_cl_rule_mailster_' + next_meta_id + '" class="cl_rules arf_basic_mymail_lists">' + msg + '</div>');
            jQuery('.bulk_add').attr('disabled', false);
            
            arf_arforms_form_change();
        }
    });
}

function delete_rule_mailster(field) {
    if (jQuery('.logic_rules_div .cl_rules').length > 1) {
        jQuery(field).parents('.cl_rules').first().remove();
    } else {
        jQuery(field).parents('.cl_rules').first().remove();
        jQuery('#conditional_logic_if_cond_mailster').attr('disabled', true);
        jQuery('#conditional_logic_if_cond_mailster').next('dl').children('dt').addClass('arf_disable_selectbox');
        jQuery('#conditional_logic_div_mailster').find('dl').addClass('arf_disabled');
        jQuery('#arf_new_law_mailster').show();
        if (typeof(__ARFADDRULE) != 'undefined') {
            var atitle = __ARFADDRULE;
        } else {
            var atitle = 'Please add one or more rules';
        }
        jQuery('#conditional_logic_if_cond_mailster').parents('.sltstandard').first().tipso({
            position: 'top',
            width: 'auto',
            maxWidth: '400',
            useTitle: true,
            background: '#444444',
            color: '#ffffff'
        });
    }
}