<?php

function template_editor_view()
{

    global $wpdb, $MdlDb, $arfform, $arf_version;
    $forms_arr = [];
    $message   = '';
    $error     = '';

    if( version_compare( $arf_version, '4.3', '<' ) ){

        $forms = $wpdb->get_results('SELECT id,name FROM ' . $MdlDb->forms . ' WHERE is_template != 1 ORDER BY name', ARRAY_A);

    }else{

        $forms = $arfform->arf_select_db_data( true, '', $MdlDb->forms, 'id,name', 'WHERE is_template != %d', array(1), '', 'ORDER BY name', '', false, false, 'ARRAY_A');
    }

    foreach ( $forms as $form ) {
        $entry_arr              = [];
        $entry_arr['form_id']   = $form['id'];
        $entry_arr['form_name'] = stripslashes_deep(strip_tags($form['name']));

        if( version_compare( $arf_version, '4.3', '<' ) ){

            $form_entry  = $wpdb->get_row($wpdb->prepare('SELECT count(form_id) entry_cnt,form_id,created_date FROM ' . $MdlDb->entries . ' WHERE form_id=%d GROUP BY form_id', $form['id']), ARRAY_A);

        }else{

            $form_entry = $arfform->arf_select_db_data( true, '', $MdlDb->entries, 'count(form_id) entry_cnt,form_id,created_date', 'WHERE form_id = %d', array($form['id']), 'GROUP BY form_id', '', '', false, true, 'ARRAY_A');
        }

        $entry_arr['entry_cnt'] = empty($form_entry['entry_cnt']) ? 0 : $form_entry['entry_cnt'];

        array_push($forms_arr, $entry_arr);
    }

    global $arf_templates, $arformspdfcreator;

    if( version_compare( $arf_version, '4.3', '<' ) ){

        $templates = $wpdb->get_results('SELECT * FROM ' . $arformspdfcreator->db_pdf_creator, ARRAY_A);

    }else{

        $templates =  $arfform->arf_select_db_data( true, '', $arformspdfcreator->db_pdf_creator, '*', '', array(), '', '', '', false, false, 'ARRAY_A');

    }

    $val = '<svg width="18px" height="18px">
                <path id="arfcheckbox_unchecked" d="M15.643,17.617H3.499c-1.34,0-2.427-1.087-2.427-2.429V3.045  c0-1.341,1.087-2.428,2.427-2.428h12.144c1.342,0,2.429,1.087,2.429,2.428v12.143C18.072,16.53,16.984,17.617,15.643,17.617z   M16.182,2.477H2.961v13.221h13.221V2.477z"></path>                                <path id="arfcheckbox_checked" d="M15.645,17.62H3.501c-1.34,0-2.427-1.087-2.427-2.429V3.048  c0-1.341,1.087-2.428,2.427-2.428h12.144c1.342,0,2.429,1.087,2.429,2.428v12.143C18.074,16.533,16.986,17.62,15.645,17.62z   M16.184,2.48H2.963v13.221h13.221V2.48z M5.851,7.15l2.716,2.717l5.145-5.145l1.718,1.717l-5.146,5.145l0.007,0.007l-1.717,1.717  l-0.007-0.008l-0.006,0.008l-1.718-1.717l0.007-0.007L4.134,8.868L5.851,7.15z"></path></svg>';

    define('ARF_PDF_FONT_CHECKBOX', $val);
    ?>
<div class="arf_loader_icon_wrapper arf_pdfcreator_loader" id="arf_full_width_loader">
    <div class="arf_loader_icon_box">
        <div class="arf-spinner arf-skeleton arf-grid-loader"></div>
    </div>
</div>

<div class="wrap arfforms_page">
    <div class="top_bar">
        <span class="h2"><?php esc_html_e('Manage PDF Template', 'ARForms-Pdfcreator'); ?></span>
    </div>

    <input type="hidden" id="arf_pdf_accordion_tab_height" />

    <div class="metabox-holder">
        <input type="hidden" value="<?php echo wp_create_nonce( 'arfpdfcreator_editor_nonce' ); ?>" id="arf_pdf_editor_nonce" />
        <form action="" method="post" name="arf_pdfcreator_form_data" id="arf_pdfcreator_form_data">
        <div class="inside">
            
            <div id="success_message" class="arf_success_message" id="pdf_creator_success_msg_div">
                <div class="message_descripiton">
                    <div id="pdf_creator_success_msg"></div>
                    <div class="message_svg_icon">
                        <svg height="14px" stroke-width="14px">
                            <path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411l1.616,1.613L6.392,14.407H6.075z"></path></svg>
                    </div>
                </div>
                
            </div>
                                  
            <div id="error_message" class="arf_error_message">
                <div class="message_descripiton">
                    <div id="pdf_creator_err_msg"></div>
                    <div class="message_svg_icon">
                        <svg height="14px" stroke-width="14px"><path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path></svg>
                    </div>
                </div>
            </div>

            <div id="pdf_warning_message" class="arf_warning_message">
                <div class="message_descripiton">
                    <div id="pdf_creator_warning_msg"></div>
                    <div class="message_svg_icon">
                            <svg height="14px" stroke-width="14px"><path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path></svg>
                    </div>
                </div>
            </div>


            <div class="frm_settings_form">
                <div class="arf_clear_both"></div>
                <div class="arf_pdf_modal_body">

                    <div class="arf_pdfcreator_title"><?php esc_html_e('Template Settings', 'ARForms-Pdfcreator'); ?></div>

                    <div class="arf_pdf_template_selection_div">

                        <div class="arf_pdfcreator_row_wrapper">
                            <div class="arf_pdfcreator_row_left_cell"><?php esc_html_e('Select Form', 'ARForms-Pdfcreator'); ?></div>
                            <div class="arf_pdfcreator_row_right_cell">
                                <div class="sltstandard arf_pdf_dropdown_wrapper">

                                    <input id="arf_form_selector" name="arf_form_selector" value="" type="hidden" >
                                    <dl class="arf_selectbox" data-name="arf_form_selector" data-id="arf_form_selector" id="arf_form_selector_dropdown">
                                        <dt><span><?php esc_html_e('Select Form', 'ARForms-Pdfcreator'); ?></span>
                                            <input value="" class="arf_autocomplete" type="text">
                                        <svg viewBox="0 0 2000 1000" width="15px" height="15px">
                                        <g fill="#000">
                                        <path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
                                        </g>
                                        </svg></dt>
                                        <dd>
                                            <ul class="field_dropdown_list_menu arf_pdf_dropdown_list" data-id="arf_form_selector">                
                                                <li class="arf_selectbox_option" data-value="0" data-label="Select Form"><?php esc_html_e('Select Form', 'ARForms-Pdfcreator'); ?></li>
                                                <?php
                                                if (! empty($forms_arr) && count($forms_arr) > 0 ) {
                                                    foreach ( $forms_arr as $form ) {
                                                        echo '<li class="arf_selectbox_option" data-value="' . $form['form_id'] . '" data-label="' . $form['form_name'] . '">' . $form['form_name'] . ' [ID:' . $form['form_id'] . ']</li>';
                                                    }
                                                }
                                                ?>
                                            </ul>
                                        </dd>
                                    </dl>
                                </div>
                            </div>
                        </div>

                        <div class="arf_pdfcreator_row_wrapper">
                            <div class="arf_pdfcreator_row_left_cell"><?php esc_html_e('Select Template', 'ARForms-Pdfcreator'); ?></div>
                            <div class="arf_pdfcreator_row_right_cell">
                                <div class="sltstandard arf_pdf_dropdown_wrapper">
                                    <input id="pdf_template_selector" name="pdf_template_selector" value="0" type="hidden">
                                    <dl class="arf_selectbox" data-name="pdf_template_selector" data-id="pdf_template_selector" id="pdf_template_selector_dropdown">
                                        <dt><span><?php esc_html_e('Select Template', 'ARForms-Pdfcreator'); ?></span>
                                            <input value="" class="arf_autocomplete" type="text">
                                        <svg viewBox="0 0 2000 1000" width="15px" height="15px">
                                        <g fill="#000">
                                        <path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
                                        </g>
                                        </svg>
                                        </dt>
                                        <dd>
                                            <ul class="field_dropdown_menu field_dropdown_list_menu arf_pdf_dropdown_list"  data-id="pdf_template_selector">
                                                <li class="arf_selectbox_option" data-value="0" data-label="Select Template"><?php esc_html_e('Select Template', 'ARForms-Pdfcreator'); ?></li>
                                                <?php

                                                if (! empty($templates) ) {
                                                    foreach ( $templates as $template ) {
                                                        echo '<li class="arf_selectbox_option" data-value="' . $template['id'] . '" data-label="' . $template['template_name'] . '">' . $template['template_name'] . '</li>';
                                                    }
                                                }
                                                ?>
                                                  
                                            </ul>
                                        </dd>
                                    </dl>
                                </div>
                            </div>
                        </div>

                        <div class="arf_pdfcreator_row_wrapper">
                            <div class="arf_pdfcreator_row_left_cell"><?php esc_html_e('Select PDF Size', 'ARForms-Pdfcreator'); ?></div>
                            <div class="arf_pdfcreator_row_right_cell">
                                <div class="sltstandard arf_pdf_dropdown_wrapper">
                                    <input id="arf_pdf_template_size" name="pdf_settings[arf_pdf_template_size]" value="A4" type="hidden" >
                                    <dl class="arf_selectbox" data-name="arf_template_size" data-id="arf_template_size" id="pdf_template_size_dropdown">
                                        <dt><span>A4 (210 x 297mm)</span>
                                            <input value="" class="arf_autocomplete" type="text">
                                        <svg viewBox="0 0 2000 1000" width="15px" height="15px">
                                        <g fill="#000">
                                        <path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
                                        </g>
                                        </svg></dt>
                                        <dd>
                                            <ul class="field_dropdown_list_menu arf_pdf_dropdown_list" data-id="arf_pdf_template_size"> 
                                                <ol class="arp_selectbox_group_label"><?php echo addslashes(esc_html__('Default Size', 'ARForms-Pdfcreator')); ?></ol>               
                                                <li class="arf_selectbox_option" data-value="A4" data-label="A4 (210 x 297mm)">A4 (210 x 297mm)</li>
                                                <li class="arf_selectbox_option" data-value="letter" data-label="Letter (8.5 x 11in)">Letter (8.5 x 11in)</li>
                                                <li class="arf_selectbox_option" data-value="legal" data-label="Legal (8.5 x 14in)">Legal (8.5 x 14in)</li>
                                                <li class="arf_selectbox_option" data-value="ledger" data-label="Ledger/Tabloid (11 x 17in)">Ledger/Tabloid (11 x 17in)</li>
                                                <li class="arf_selectbox_option" data-value="executive" data-label="Executive (7 x 10in)">Executive (7 x 10in)</li>
                                                <ol class="arp_selectbox_group_label"><?php echo stripslashes(esc_html__('"A" Sizes', 'ARForms-Pdfcreator')); ?></ol>
                                                <li class="arf_selectbox_option" data-value="A0" data-label="A0 (841 x 1189mm)">A0 (841 x 1189mm)</li>
                                                <li class="arf_selectbox_option" data-value="A1" data-label="A1 (594 x 841mm)">A1 (594 x 841mm)</li>
                                                <li class="arf_selectbox_option" data-value="A2" data-label="A2 (420 x 594mm)">A2 (420 x 594mm)</li>
                                                <li class="arf_selectbox_option" data-value="A3" data-label="A3 (297 x 420mm)">A3 (297 x 420mm)</li>
                                                <li class="arf_selectbox_option" data-value="A5" data-label="A5 (210 x 297mm)">A5 (210 x 297mm)</li>
                                                <li class="arf_selectbox_option" data-value="A6" data-label="A6 (105 x 148mm)">A6 (105 x 148mm)</li>
                                                <li class="arf_selectbox_option" data-value="A7" data-label="A7 (74 x 105mm)">A7 (74 x 105mm)</li>
                                                <li class="arf_selectbox_option" data-value="A8" data-label="A8 (52 x 74mm)">A8 (52 x 74mm)</li>
                                                <li class="arf_selectbox_option" data-value="A9" data-label="A9 (37 x 52mm)">A9 (37 x 52mm)</li>
                                                <li class="arf_selectbox_option" data-value="A10" data-label="A10 (26 x 37mm)">A10 (26 x 37mm)</li>
                                                <ol class="arp_selectbox_group_label"><?php echo stripslashes(esc_html__('"B" Sizes', 'ARForms-Pdfcreator')); ?></ol>
                                                <li class="arf_selectbox_option" data-value="B0" data-label="B0 (1414 x 1000mm)">B0 (1414 x 1000mm)</li>
                                                <li class="arf_selectbox_option" data-value="B1" data-label="B1 (1000 x 707mm)">B1 (1000 x 707mm)</li>
                                                <li class="arf_selectbox_option" data-value="B2" data-label="B2 (707 x 500mm)">B2 (707 x 500mm)</li>
                                                <li class="arf_selectbox_option" data-value="B3" data-label="B3 (500 x 353mm)">B3 (500 x 353mm)</li>
                                                <li class="arf_selectbox_option" data-value="B4" data-label="B4 (353 x 250mm)">B4 (353 x 250mm)</li>
                                                <li class="arf_selectbox_option" data-value="B5" data-label="B5 (250 x 176mm)">B5 (250 x 176mm)</li>
                                                <li class="arf_selectbox_option" data-value="B6" data-label="B6 (176 x 125mm)">B6 (176 x 125mm)</li>
                                                <li class="arf_selectbox_option" data-value="B7" data-label="B7 (125 x 88mm)">B7 (125 x 88mm)</li>
                                                <li class="arf_selectbox_option" data-value="B8" data-label="B8 (88 x 62mm)">B8 (88 x 62mm)</li>
                                                <li class="arf_selectbox_option" data-value="B9" data-label="B9 (62 x 44mm)">B9 (62 x 44mm)</li>
                                                <li class="arf_selectbox_option" data-value="B10" data-label="B10 (44 x 31mm)">B10 (44 x 31mm)</li>
                                                <ol class="arp_selectbox_group_label"><?php echo stripslashes(esc_html__('"C" Sizes', 'ARForms-Pdfcreator')); ?></ol>
                                                <li class="arf_selectbox_option" data-value="C0" data-label="C0 (1297 x 917mm)">C0 (1297 x 917mm)</li>
                                                <li class="arf_selectbox_option" data-value="C1" data-label="C1 (917 x 648mm)">C1 (917 x 648mm)</li>
                                                <li class="arf_selectbox_option" data-value="C2" data-label="C2 (648 x 458mm)">C2 (648 x 458mm)</li>
                                                <li class="arf_selectbox_option" data-value="C3" data-label="C3 (458 x 324mm)">C3 (458 x 324mm)</li>
                                                <li class="arf_selectbox_option" data-value="C4" data-label="C4 (324 x 229mm)">C4 (324 x 229mm)</li>
                                                <li class="arf_selectbox_option" data-value="C5" data-label="C5 (229 x 162mm)">C5 (229 x 162mm)</li>
                                                <li class="arf_selectbox_option" data-value="C6" data-label="C6 (162 x 114mm)">C6 (162 x 114mm)</li>
                                                <li class="arf_selectbox_option" data-value="C7" data-label="C7 (114 x 81mm)">C7 (114 x 81mm)</li>
                                                <li class="arf_selectbox_option" data-value="C8" data-label="C8 (81 x 57mm)">C8 (81 x 57mm)</li>
                                                <li class="arf_selectbox_option" data-value="C9" data-label="C9 (57 x 40mm)">C9 (57 x 40mm)</li>
                                                <li class="arf_selectbox_option" data-value="C10" data-label="C10 (40 x 28mm)">C10 (40 x 28mm)</li>
                                                <ol class="arp_selectbox_group_label"><?php echo stripslashes(esc_html__('"RA" and "SRA" Sizes', 'ARForms-Pdfcreator')); ?></ol>
                                                <li class="arf_selectbox_option" data-value="RA0" data-label="RA0 (860 x 1220mm)">RA0 (860 x 1220mm)</li>
                                                <li class="arf_selectbox_option" data-value="RA1" data-label="RA1 (610 x 860mm)">RA1 (610 x 860mm)</li>
                                                <li class="arf_selectbox_option" data-value="RA2" data-label="RA2 (430 x 610mm)">RA2 (430 x 610mm)</li>
                                                <li class="arf_selectbox_option" data-value="RA3" data-label="RA3 (305 x 430mm)">RA3 (305 x 430mm)</li>
                                                <li class="arf_selectbox_option" data-value="RA4" data-label="RA4 (215 x 305mm)">RA4 (215 x 305mm)</li>
                                                <li class="arf_selectbox_option" data-value="SRA0" data-label="SRA0 (900 x 1280mm)">SRA0 (900 x 1280mm)</li>
                                                <li class="arf_selectbox_option" data-value="SRA1" data-label="SRA1 (640 x 900mm)">SRA1 (640 x 900mm)</li>
                                                <li class="arf_selectbox_option" data-value="SRA2" data-label="SRA2 (450 x 640mm)">SRA2 (450 x 640mm)</li>
                                                <li class="arf_selectbox_option" data-value="SRA3" data-label="SRA3 (320 x 450mm)">SRA3 (320 x 450mm)</li>
                                                <li class="arf_selectbox_option" data-value="SRA4" data-label="SRA4 (225 x 320mm)">SRA4 (225 x 320mm)</li>                                                    
                                            </ul>
                                        </dd>
                                    </dl>
                                </div>
                            </div>
                        </div>

                        <div class="arf_pdfcreator_row_wrapper">
                            <div class="arf_pdfcreator_row_left_cell"><?php esc_html_e('Select PDF Orientation', 'ARForms-Pdfcreator'); ?></div>
                            <div class="arf_pdfcreator_row_right_cell">
                                <div class="sltstandard arf_pdf_dropdown_wrapper">
                                    <input id="arf_pdf_template_orientation" name="pdf_settings[arf_pdf_template_orientation]" value="portrait" type="hidden">
                                    <dl class="arf_selectbox" data-name="arf_pdf_orientation" data-id="arf_pdf_orientation" id="arf_pdf_orientation_dropdown">
                                        <dt><span><?php esc_html_e('Portrait', 'ARForms-Pdfcreator'); ?></span>
                                            <input value="" class="arf_autocomplete" type="text">
                                        <svg viewBox="0 0 2000 1000" width="15px" height="15px">
                                        <g fill="#000">
                                        <path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
                                        </g>
                                        </svg>
                                        </dt>
                                        <dd>
                                            <ul class="field_dropdown_menu field_dropdown_list_menu arf_pdf_dropdown_list"  data-id="arf_pdf_template_orientation">
                                                <li class="arf_selectbox_option" data-value="portrait" data-label="Portrait"><?php esc_html_e('Portrait', 'ARForms-Pdfcreator'); ?></li>
                                                <li class="arf_selectbox_option" data-value="landscape" data-label="Landscape"><?php esc_html_e('Landscape', 'ARForms-Pdfcreator'); ?></li>
                                            </ul>
                                        </dd>
                                    </dl>
                                </div>
                            </div>
                        </div>

                        <div class="arf_pdfcreator_row_wrapper">
                            <div class="arf_pdfcreator_row_left_cell"><?php esc_html_e('Select PDF Font Family', 'ARForms-Pdfcreator'); ?></div>
                            <div class="arf_pdfcreator_row_right_cell">
                                <div class="sltstandard arf_pdf_dropdown_wrapper">
                                    <input id="arf_pdf_template_font" name="pdf_settings[arf_pdf_template_font]" value="arf_arial" type="hidden">
                                    <dl class="arf_selectbox" data-name="arf_pdf_template_font" data-id="arf_pdf_template_font" id="pdf_template_font_dropdown">
                                        <dt><span>Arial</span>
                                            <input value="" class="arf_autocomplete" type="text">
                                        <svg viewBox="0 0 2000 1000" width="15px" height="15px">
                                        <g fill="#000">
                                        <path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"></path>
                                        </g>
                                        </svg>
                                        </dt>
                                        <dd>
                                            <ul class="field_dropdown_menu field_dropdown_list_menu arf_pdf_dropdown_list"  data-id="arf_pdf_template_font">
                                                
                                                
                                                <?php
                                                    $font_list = $arformspdfcreator->arforms_pdf_get_default_fonts_arr();

                                                    $output = '';
                                                if (! empty($font_list) ) {
                                                    $li_content = '';
                                                    $ol_content = '<ol class="arp_selectbox_group_label">' . addslashes(esc_html__('Default Fonts', 'ARForms-Pdfcreator')) . '</ol>';
                                                    foreach ( $font_list as $fontkey => $font_val ) {
                                                        foreach ( $font_val as $key => $value ) {

                                                            $li_content .= '<li class="arf_selectbox_option" data-value="' . $fontkey . '" data-label="' . $key . '">' . $key . '</li>';

                                                        }
                                                    }
                                                    $output = $ol_content . $li_content;
                                                }
                                                    echo $output;

                                                    $font_list = $arformspdfcreator->arforms_pdf_get_fonts_arr();

                                                    $output = '';
                                                if (! empty($font_list) ) {
                                                    $li_content = '';
                                                    $ol_content = '<ol class="arp_selectbox_group_label">' . addslashes(esc_html__('Other Fonts', 'ARForms-Pdfcreator')) . '</ol>';
                                                    foreach ( $font_list as $fontkey => $font_val ) {
                                                        foreach ( $font_val as $key => $value ) {

                                                            $li_content .= '<li class="arf_selectbox_option" data-value="' . $fontkey . '" data-label="' . $key . '">' . $key . '</li>';

                                                        }
                                                    }
                                                    $output = $ol_content . $li_content;
                                                }
                                                    echo $output;
                                                ?>
                                            </ul>
                                        </dd>
                                    </dl>
                                    <div class="arf_pdf_import_font_link_wrapper"><a class="arf_pdf_import_fonts_link"><?php esc_html_e('Import Additional Fonts', 'ARForms-Pdfcreator'); ?></a></div>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="arf_pdfcreator_section_seperator"></div>

                    <div class="arf_pdfcreator_title"><?php esc_html_e('Header Settings', 'ARForms-Pdfcreator'); ?></div>

                    <div class="arf_pdf_template_selection_div arf_pdf_header_selection">
                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                            <?php esc_html_e('Left Header', 'ARForms-Pdfcreator'); ?>
                            </div>
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_header_left" id="arf_pdfcreator_editor_header_left"></textarea>
                            </div>
                            
                        </div>
                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                            <?php esc_html_e('Center Header', 'ARForms-Pdfcreator'); ?>
                            </div>
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_header_center" id="arf_pdfcreator_editor_header_center"></textarea>
                            </div>
                        </div>
                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                            <?php esc_html_e('Right Header', 'ARForms-Pdfcreator'); ?>
                            </div>
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_header_right" id="arf_pdfcreator_editor_header_right"></textarea>
                            </div>
                        </div>
                        <div class="pdf_header_note_div"><?php esc_html_e('Note: Please enter only static content OR shortcode OR Graphics.', 'ARForms-Pdfcreator'); ?></div>
                    </div>

                    <div class="arf_pdfcreator_section_seperator"></div>

                    <div class="arf_pdfcreator_title"><?php esc_html_e('PDF Content Editor', 'ARForms-Pdfcreator'); ?></div>

                    <div class="arf_pdf_template_selection_div arf_pdf_header_selection">
                        <?php
                        $content   = '';
                        $editor_id = 'arf_pdfcreator_editor';
                        $settings  = array(
                                'buttons' => 'strong,em,link,block,del,ins,img,ul,ol,li,code,close,fullscreen',
                        );
                        wp_editor(
                            $content,
                            $editor_id,
                            array(
                                    'tinymce'       => false,
                                    'quicktags'     => $settings,
                                    'textarea_rows' => 20,
                                    'media_buttons' => false,
                                )
                        );
                        ?>
                    </div>

                    <div class="arf_pdfcreator_section_seperator"></div>

                    <div class="arf_pdfcreator_title"><?php esc_html_e('Footer Settings', 'ARForms-Pdfcreator'); ?></div>

                    <div class="arf_pdf_template_selection_div arf_pdf_header_selection">
                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                                <?php esc_html_e('Left Footer', 'ARForms-Pdfcreator'); ?>
                            </div>
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_footer_left" id="arf_pdfcreator_editor_footer_left"></textarea>
                            </div>    
                        </div>

                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                                <?php esc_html_e('Center Footer', 'ARForms-Pdfcreator'); ?>
                            </div>
                            
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_footer_center" id="arf_pdfcreator_editor_footer_center"></textarea>
                            </div>     
                        </div>

                        <div class="editor_header_container">
                            <div class="arf_editor_label">
                                <?php esc_html_e('Right Footer', 'ARForms-Pdfcreator'); ?>
                            </div>
                            
                            <div>
                                <textarea class="arf_pdf_textarea" rows="6" cols="32" name="arf_pdfcreator_editor_footer_right" id="arf_pdfcreator_editor_footer_right"></textarea>
                            </div>
                        </div>
                        <div class="pdf_header_note_div"><?php esc_html_e('Note: Please enter only static content OR shortcode OR Graphics.', 'ARForms-Pdfcreator'); ?></div>
                    </div>

                    <div class="arf_pdfcreator_section_seperator nobackground"></div>

                    <div class="arf_pdfcreator_save_container">

                        <button class="rounded_button arf_btn_dark_blue general_submit_button arf_pdfcreator_save_button" type="submit" id="pdfcreator_form_data" value="update_pdfcreator_data" name="pdfcreator_form_data"> <?php esc_html_e('Save Changes', 'ARForms-Pdfcreator'); ?> </button>

                        <button class="rounded_button general_submit_button arf_pdfcreator_cancel_button" type="button" id="cancel_editing_template" name="cancel_editing_template" ><?php esc_html_e('Cancel Editing', 'ARForms-Pdfcreator'); ?></button>
                        
                        <button class="rounded_button arf_btn_dark_blue arf_pdf_saveas_label arf_pdfcreator_saveas_button" type="button"><?php esc_html_e('Save as template', 'ARForms-Pdfcreator'); ?></button>

                        <button id="delete_pdf_template" class="rounded_button pdf_template_delete_icon arf_pdf_template_delete_buttons " type="button"><?php esc_html_e('Delete Template', 'ARForms-Pdfcreator'); ?></button>

                    </div>

                    <div class="arf_pdf_form_field_viewer" id="arf_pdf_form_field_viewer">
                       <div class="arf_pdf_accordion_tabs">
                            <div class="arf_form_style_tab_accordion">
                                <dl class="arf_pdf_form_field_accordion arf_pdfcreator_right_panel_accordion">
                                    <dd>
                                        <a href="javascript:void(0)" data-target="arf_accordion_tab_color_options"><?php echo addslashes(esc_html__('Form Fields', 'ARForms-Pdfcreator')); ?></a>
                                        <div class="arf_accordion_container">
                                            
                                        </div>
                                    </dd>
                                </dl>
                            
                                <dl class="arf_pdf_extrafield_accordion arf_pdfcreator_right_panel_accordion">
                                    <dd>
                                        <a href="javascript:void(0)" data-target="arf_accordion_tab_color_options"><?php echo addslashes(esc_html__('Advanced Fields', 'ARForms-Pdfcreator')); ?></a>
                                        <div class="arf_accordion_container">
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_browser" data-value="Browser" data-label="Browser" onclick="
                                            arfaddcodefornewfield('Browser')"><?php echo addslashes(esc_html__('Browser', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_ipaddress" data-value="IPAddress" data-label="IP Address" onclick="arfaddcodefornewfield('IPAddress')"><?php echo addslashes(esc_html__('IP Address', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_pageurl" data-value="PageURL" data-label="Page URL" onclick="arfaddcodefornewfield('PageURL')"><?php echo esc_html__('Page URL', 'ARForms-Pdfcreator'); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_referrerurl" data-value="ReferrerURL" data-label="Referrer URL" onclick="arfaddcodefornewfield('ReferrerURL')"><?php echo addslashes(esc_html__('Referrer URL', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_country" data-value="Country" data-label="Country" onclick="arfaddcodefornewfield('Country')"><?php echo addslashes(esc_html__('Country', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_entrydate" data-value="EntryCreationDate" data-label="Entry Creation Date" onclick="arfaddcodefornewfield('EntryCreationDate')"><?php echo esc_html__('Entry Creation Date', 'ARForms-Pdfcreator'); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_getlabel" data-value="GetEntryID" data-label="GetEntryID" onclick="arfaddcodefornewfield('GetEntryID')"><?php echo esc_html__('Entry ID', 'ARForms-Pdfcreator'); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_formtitle" data-value="FormTitle" data-label="Form Title" onclick="arfaddcodefornewfield('FormTitle');"><?php echo esc_html__('Form Title', 'ARForms-Pdfcreator'); ?></div>
                                        </div>
                                    </dd>
                                </dl>

                                <dl class="arf_pdf_userdetail_accordion arf_pdfcreator_right_panel_accordion">
                                    <dd>
                                        <a href="javascript:void(0)" data-target="arf_accordion_tab_color_options"><?php echo addslashes(esc_html__('Current User Detail', 'ARForms-Pdfcreator')); ?></a>
                                        <div class="arf_accordion_container">
                                            <div class="arf_pdfcreator_note"><?php echo esc_html__('Note', 'ARForms-Pdfcreator') . ': ' . esc_html__('The following shortcode will be replaced with the detail of the user who has submitted the form. If form is submitted by anonymous (non-logged in) user then this shortcode will replaced with blank value.', 'ARForms-Pdfcreator'); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_browser" data-value="Browser" data-label="Browser" onclick="
                                            arfaddcodefornewfield('UserID')"><?php echo addslashes(esc_html__('User ID', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_ipaddress" data-value="IPAddress" data-label="IP Address" onclick="arfaddcodefornewfield('UserEmail')"><?php echo addslashes(esc_html__('User Email', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_pageurl" data-value="PageURL" data-label="Page URL" onclick="arfaddcodefornewfield('UserName')"><?php echo esc_html__('User Name', 'ARForms-Pdfcreator'); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_referrerurl" data-value="ReferrerURL" data-label="Referrer URL" onclick="arfaddcodefornewfield('UserDisplayName')"><?php echo addslashes(esc_html__('User Display Name', 'ARForms-Pdfcreator')); ?></div>
                                            
                                        </div>
                                    </dd>
                                </dl>
                            
                                <dl class="arf_pdf_shortcode_accordion arf_pdfcreator_right_panel_accordion">
                                    <dd>
                                        <a href="javascript:void(0)" data-target="arf_accordion_tab_color_options"><?php echo addslashes(esc_html__('Conditional Shortcode', 'ARForms-Pdfcreator')); ?></a>
                                        <div class="arf_accordion_container">
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_if" data-value="IF" data-label="IF" onclick="arfaddcodefornewfield('IF')"><?php echo addslashes(esc_html__('IF', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_pdf_button extra_fields" id="arf_pdf_loop" data-value="LOOP" data-label="LOOP" onclick="arfaddcodefornewfield('LOOP')"><?php echo addslashes(esc_html__('LOOP', 'ARForms-Pdfcreator')); ?></div>
                                            
                                        </div>
                                    </dd>
                                </dl>

                                <dl class="arf_pdf_other_option_accordion arf_pdfcreator_right_panel_accordion active">
                                    <dd>
                                        <a href="javascript:void(0)" data-target="arf_accordion_tab_color_options"><?php echo addslashes(esc_html__('Other Options', 'ARForms-Pdfcreator')); ?></a>
                                        <div class="arf_accordion_container active">

                                            <label class="arf_js_switch_label arf_pdf_no_margin">
                                                <span><?php esc_html_e('Enable Page No', 'ARForms-Pdfcreator'); ?>:</span>
                                            </label>
                                            <div class="arf_js_switch_wrapper arf_pdf_float_right">
                                                <input type="checkbox" class="js-switch" id="pdf_pgno" name="pdf_settings[arf_pdf_pgno]" value="1" checked="checked" />
                                                <span class="arf_js_switch"></span>
                                            </div>

                                            <div id="pdf_header_img_container">
                                                <label class="pdf_header_img_label arf_pdf_upload_logo_label"><?php esc_html_e('Upload Logo', 'ARForms-Pdfcreator'); ?></label>
                                                <div class="pdf_header_img_div">
                                                    <div class="arf_form_style_file_upload_icon">
                                                        <svg width="16" height="18" viewBox="0 0 18 20" fill="#ffffff"><path xmlns="http://www.w3.org/2000/svg" d="M15.906,18.599h-1h-12h-1h-1v-7h2v5h12v-5h2v7H15.906z M13.157,7.279L9.906,4.028v8.571c0,0.552-0.448,1-1,1c-0.553,0-1-0.448-1-1v-8.54l-3.22,3.22c-0.403,0.403-1.058,0.403-1.46,0 c-0.403-0.403-0.403-1.057,0-1.46l4.932-4.932c0.211-0.211,0.488-0.306,0.764-0.296c0.275-0.01,0.553,0.085,0.764,0.296 l4.932,4.932c0.403,0.403,0.403,1.057,0,1.46S13.561,7.682,13.157,7.279z"></path>
                                                        </svg>
                                                    </div>
                                                    <input type="file" name="pdf_header_img" id="pdf_header_img" data-val="form_bg" class="original">
                                                </div>
                                                <input type="hidden" name="pdf_header_img_name" id="pdf_header_img_name" value="">
                                                <p class="pdf_header_img_err_msg"></p>
                                            </div>

                                            <div class="pdf_header_img_preview">
                                                
                                            </div>

                                            <div class="pdf_header_img_label"><?php echo addslashes(esc_html__('Logo Position:', 'ARForms-Pdfcreator')); ?></div>
                                            <div class="arf_accordion_content_container arf_pdf_logo_align_wrapper arf_align_right arf_right">
                                                <div class="arf_toggle_button_group arf_three_button_group arf_toggle_pdf_log_alignment">
                                                    <label class="arf_toggle_btn" id="pdf_header_img_align_left"><input class="visuallyhidden" type="radio" name="pdf_header_img_align" value="left"><?php esc_html_e('Left', 'ARForms-Pdfcreator'); ?></label>
                                                    <label class="arf_toggle_btn arf_success" id="pdf_header_img_align_center"><input class="visuallyhidden" type="radio" name="pdf_header_img_align" value="center" checked="checked"><?php esc_html_e('Center', 'ARForms-Pdfcreator'); ?></label>
                                                    <label class="arf_toggle_btn" id="pdf_header_img_align_right"><input class="visuallyhidden" type="radio" name="pdf_header_img_align" value="right"><?php esc_html_e('Right', 'ARForms-Pdfcreator'); ?></label>
                                                </div>
                                            </div>
                                            
                                        </div>
                                    </dd>


                                </dl>
                            </div>
                       </div>
                    </div>

                </div>
            </div>
        </div>


        <div class="documentation_link arf_clear_both" align="right">
            <a href="<?php echo esc_url(ARF_PDFCREATOR_URL . '/documentation/index.html'); ?>" target="_blank" class="arlinks arf_pdf_doc_link"><?php esc_html_e('Documentation', 'ARForms-Pdfcreator'); ?>        
            </a>|<a href="https://helpdesk.arpluginshop.com/submit-a-ticket/" target="_blank" class="arlinks arf_pdf_support_link">
    <?php esc_html_e('Support', 'ARForms-Pdfcreator'); ?>        
            </a>
        </div>

        <div class="arf_modal_overlay" id="arf_modal_overlay_template">
            <div id="arf_pdf_template_popup" class="arf_popup_container">
                <div class="arf_popup_container_header"> <?php esc_html_e('Save Template', 'ARForms-Pdfcreator'); ?>
                    <div class="arfpopupclosebutton arfmodalclosebutton" data-dismiss="arfmodal" data-id="arf_optin_popup_button">
                        <svg width="30px" height="30px" viewBox="1 0 20 20"><g id="preview"><path fill-rule="evenodd" clip-rule="evenodd" fill="#262944" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path></g></svg>
                    </div>
                </div>
                <div class="arf_option_model_popup_container">
                    <div class="arf_pdf_template_column">
                        <label class="arf_pdf_template_label_full"> <?php esc_html_e('Template Name', 'ARForms-Pdfcreator'); ?></label>
                        <input type="text" name="arf_pdf_template_name" id="arf_pdf_template_name" class="txtstandardnew arf_large_input_box" >    
                        <div class="arf_pdf_blank_template_err"> 
                        </div>
                    </div>
                </div>
                <div class="arf_popup_container_footer">
                    <button type="submit" class="rounded_button arf_btn_dark_blue" value="save_pdfcreator_data" name="arf_pdf_save_template" id="arf_pdf_save_template"> <?php esc_html_e('Save', 'ARForms-Pdfcreator'); ?> </button>
                    <button type="button" class="rounded_button arf_pd_modal_close_btn" id="arf_pdf_close_modal"> <?php esc_html_e('Cancel', 'ARForms-Pdfcreator'); ?> </button>
                </div>
            </div>
        </div>
        </form>
        <div class="arf_modal_overlay" id="arf_modal_overlay_extrafonts">
            <form action="" method="post" name="pdf_extra_fonts_form" id="pdf_extra_fonts_form" enctype="multipart/form-data">
            <div id="arf_pdf_extrafonts_popup" class="arf_popup_container" >
                <div class="arf_popup_container_header"> <?php esc_html_e('Import Fonts', 'ARForms-Pdfcreator'); ?>
                    <div class="arfpopupclosebutton arfmodalclosebutton" data-dismiss="arfmodal" data-id="arf_optin_popup_button">
                        <svg width="30px" height="30px" viewBox="1 0 20 20"><g id="preview"><path fill-rule="evenodd" clip-rule="evenodd" fill="#262944" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path></g></svg>
                    </div>
                </div>
                
                <div class="arf_option_model_popup_container arf_import_font_modal_wrapper">
                    <div class="arf_pdf_font_list_heading"> <?php esc_html_e('Please Select Fonts to import', 'ARForms-Pdfcreator'); ?> </div>
                    <div class="arf_pdf_font_list_empty_err"><?php esc_html_e('Please select fonts.', 'ARForms-Pdfcreator'); ?></div>
                    <div class="arf_pdf_font_list_container">
                        <?php
                        $font_arr = $arformspdfcreator->arforms_pdf_get_fonts_arr();
                        $font_lang = $arformspdfcreator->arforms_pdf_fonts_category();
                        if (! empty($font_arr) ) {
                            foreach ( $font_arr as $fontkey => $font_val ) {
                                foreach ( $font_val as $key => $value ) {

                                    ?>
                                    <div class="arf_custom_checkbox_div arf_pdf_font_checkbox_wrapper" >
                                        <div class="arf_custom_checkbox_wrapper">
                                            <input type="checkbox" value="<?php echo esc_html( $key ); ?>" id="<?php echo esc_html( $fontkey ); ?>" name="<?php echo 'arf_pdf_extra_fonts[' . $fontkey . ']'; ?>">
                                            <?php echo ARF_PDF_FONT_CHECKBOX; ?>
                                        </div>
                                        <span><label class="arf_pdfcreator_font_family_label" for="<?php echo esc_html( $fontkey ); ?>"><?php echo esc_html( $key ).' ('.esc_html( $font_lang[ $fontkey ] ).')'; ?></label></span>
                                    </div>
                                    <?php
                                }
                            }
                        }
                        ?>

                        
                    </div>
                </div>
                <div class="arf_popup_container_footer">
                   
                    <div class="font_progress_wraper arf_pdf_display_none">
                        <div class="progress-bar blue stripes">
                            <span id="font_progress"></span>
                        </div>
                        <span class="font_import_note"><?php esc_html_e('Please do not refresh or close this window while importing the fonts.', 'ARForms-Pdfcreator') ?></span>
                    </div>
                    
                    <div class="font_import_button_wraper">
                        <input type="submit" class="rounded_button arf_btn_dark_blue" value="Import" name="important_extra_fonts" id="important_extra_fonts_button">
                        <span class="arf_pdf_import_loader"></span>
                    </div>
                    
                    
                    
                </div>
            </div>
            </form>
        </div>

        <div class="arf_modal_overlay" id="arf_modal_overlay_template_delete">
            <div id="arf_pdf_template_popup_delete" class="arf_popup_container">
                <div class="arf_popup_container_header"> <?php esc_html_e('Delete Template', 'ARForms-Pdfcreator'); ?>
                    <div class="arfpopupclosebutton arfmodalclosebutton" data-dismiss="arfmodal" data-id="arf_optin_popup_button">
                        <svg width="30px" height="30px" viewBox="1 0 20 20"><g id="preview"><path fill-rule="evenodd" clip-rule="evenodd" fill="#262944" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path></g></svg>
                    </div>
                </div>
                
                <div class="arf_option_model_popup_container arf_delete_msg_wrapper">
                    <div class="arf_delete_msg_wrapper_line">
                        <?php esc_html_e('Are you sure you want to delete this Template?', 'ARForms-Pdfcreator'); ?>
                    </div>
                </div>
                
                <div class="arf_popup_container_footer">
                    <button type="button" class="rounded_button arf_btn_dark_blue" name="arf_pdf_save_template" id="arf_pdf_delete_template"> <?php esc_html_e('Delete', 'ARForms-Pdfcreator'); ?> </button>
                    <button type="button" class="rounded_button" id="arf_pdf_close_delete_modal arf_pdf_delete_modal_cancel_button"> <?php esc_html_e('Cancel', 'ARForms-Pdfcreator'); ?> </button>
                </div>
            </div>
        </div>
    </div>
    
</div>

    <?php
}
?>