<?php $arf_sms_configuration = get_option( 'arf_sms_configuration' ); ?>
<div class="wrap arf_setting_page">
	<div class="top_bar">
	<span class="h2"><?php esc_html_e( 'SMS Settings', 'ARForms-SMS' ); ?></span>
	</div>
	<div id="success_message" class="arf_success_message">
		<div class="message_descripiton">
			<div class="arformssms_success_msg_text"></div>
			<div class="message_svg_icon">
				<svg height="14px" stroke-width="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411l1.616,1.613L6.392,14.407H6.075z"></path>
				</svg>
			</div>
		</div>
	</div>
	<div id="error_message" class="arf_error_message">
		<div class="message_descripiton">
			<div class="arformssms_error_msg_text"></div>
			<div class="message_svg_icon">
				<svg height="14px" stroke-width="14px">
					<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
				</svg>
			</div>
		</div>
	</div>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<?php $nonce_field = wp_create_nonce( 'arforms_sms' ); ?>
			<input type="hidden" id="arfsms_nonce_field" value="<?php echo esc_html( $nonce_field ); ?>" />
			<input type="hidden" id="arfsms_ajaxurl" value="<?php echo admin_url( 'admin-ajax.php' ); ?>" />
			<form name="frm_sms_settings_form" method="post" enctype="multipart/form-data" class="frm_sms_settings_form" id="frm_sms_settings_form" onsubmit="return arformssms_save_settings();" >
				<div class="arf_clear_both"></div>
				<div id="autoresponder_settings" class="arf_sms_settings_wrapper">
					<table class="form-table">
						<?php 
						global $arformssms;
						
						$smsgateway_list = $arformssms->arf_sms_gateways_list();
						foreach ($smsgateway_list as $smsgatewaykey => $smsgatewayval) { 
							?>
								<tr class="arfmainformfield" valign="top">
									<td class="lbltitle titleclass" colspan="2">
										<?php echo $smsgatewayval['gatewaylabel'] ?>&nbsp;
									</td>
								</tr>
								<tr>
									<td></td>
								</tr>
								<?php
								if (isset($smsgatewayval['header'])) {
									foreach ($smsgatewayval['header'] as $Key => $smsgatewayfields) { 
										$field_name = $smsgatewayfields['slug'];?>
										<tr class="arfmainformfield" valign="top">
											<td class="tdclass arf_sms_api_label"  width="18%">
												<label class="lblsubtitle"><?php echo $smsgatewayval['name']." ".$smsgatewayfields['label']; ?></label>
											</td>
											<td>
												<input type="<?php echo $smsgatewayfields['type']; ?>" name="arf_sms_configuration[arf_sms_gateways_settings][<?php echo $smsgatewaykey; ?>][header][<?php echo $Key; ?>]" class="txtmodal1" id="<?php echo $smsgatewayfields['id']; ?>" size="42" value="<?php echo isset( $arf_sms_configuration['arf_sms_gateways_settings'][$smsgatewaykey]['header'][$Key] ) ? esc_html( $arf_sms_configuration['arf_sms_gateways_settings'][$smsgatewaykey]['header'][$Key] ) : ''; ?>" />
											</td>
										</tr>
										<?php	
									}	
								} 

								if (isset($smsgatewayval['options'])) {
									foreach ($smsgatewayval['options'] as $Key => $smsgatewayoptions) { 
										$field_name = $smsgatewayoptions['slug'];
										$value = isset($arf_sms_configuration['arf_sms_gateways_settings'][$smsgatewaykey][$field_name]) ? $arf_sms_configuration['arf_sms_gateways_settings'][$smsgatewaykey][$field_name] : '';
										$default_val = isset($smsgatewayoptions['value']) ? $smsgatewayoptions['value'] : '';
										if (isset($smsgatewayoptions['type']) && $smsgatewayoptions['type'] != 'hidden') {
											?>
											<tr class="arfmainformfield" valign="top">
												<td class="tdclass arf_sms_api_label"  width="18%">
													<label class="lblsubtitle"><?php echo $smsgatewayval['name'] ." ".$smsgatewayoptions['label']; ?></label>
												</td>
												<td>
													<input type="<?php echo $smsgatewayoptions['type']; ?>" name="arf_sms_configuration[arf_sms_gateways_settings][<?php echo $smsgatewaykey; ?>][<?php echo $field_name ?>]" class="txtmodal1" id="<?php echo $smsgatewayoptions['id']; ?>" size="42" value="<?php echo $value ; ?>" />
												</td>
											</tr>
										<?php	
										}
										if (isset($smsgatewayoptions['type']) && $smsgatewayoptions['type'] == 'hidden') { ?>
											<input type="hidden" name="arf_sms_configuration[arf_sms_gateways_settings][<?php echo $smsgatewaykey; ?>][<?php echo $field_name; ?>]" value="<?php echo (isset($value) && $value != '') ? $value : $default_val  ?>">
										<?php
										}
									}	
								} ?>
								
								<tr class="arfmainformfield" valign="top">
										<td colspan="2"><div class="dotted_line"></div></td>
								</tr>
							<?php 
						} ?>
						<tr class="arfmainformfield" valign="top">
							<td class="lbltitle titleclass" colspan="2">
								<?php esc_html_e( 'Other SMS Settings', 'ARForms-SMS' ); ?>&nbsp;
							</td>
						</tr>
						<tr class="arfmainformfield" valign="top">
							<td class="tdclass arf_sms_api_label"  width="18%">
								<label class="lblsubtitle"><?php esc_html_e( 'URL', 'ARForms-SMS' ); ?></label>
							</td>
							<td>
								<input type="text" name="arf_sms_configuration[other_sms_url]" class="txtmodal1" size="42" value="<?php echo isset( $arf_sms_configuration['other_sms_url'] ) ? $arf_sms_configuration['other_sms_url'] : ''; ?>" />
							</td>
						</tr>
						<tr class="arfmainformfield" valign="top">
							<td class="tdclass arf_sms_api_label"  width="18%">
								<label class="lblsubtitle"><?php esc_html_e( 'Request Type', 'ARForms-SMS' ); ?></label>
							</td>
							<td>
								<div class="arf_radio_wrapper">
									<div class="arf_custom_radio_div">
										<div class="arf_custom_radio_wrapper">
											<input type="radio" name="arf_sms_configuration[other_request_type]" id="arfother_sms_get" class="txtmodal1 arfothersmsrequesttype arf_custom_radio" value="get" <?php isset($arf_sms_configuration['other_request_type']) ? checked($arf_sms_configuration['other_request_type'], 'get') : ''; ?> />
			                                <svg width="18px" height="18px">
			                                <?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
			                                <?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
			                                </svg>
		                               	</div>
		                            </div>
	                                <span> 
		                                <label id="arfother_sms_get" for="arfother_sms_get"><?php echo esc_html__('GET', 'ARForms-SMS'); ?></label>
		                            </span>
		                        </div>
		                        <div class="arf_radio_wrapper">
		                            <div class="arf_custom_radio_div">
		                                <div class="arf_custom_radio_wrapper">
			                                <input type="radio" name="arf_sms_configuration[other_request_type]" id="arfother_sms_post" class="txtmodal1 arfothersmsrequesttype arf_custom_radio" value="post" <?php isset($arf_sms_configuration['other_request_type']) ? checked($arf_sms_configuration['other_request_type'], 'post') : '' ; ?> />
			                                <svg width="18px" height="18px">
			                                <?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
			                                <?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
			                                </svg>
			                            </div>
			                        </div>
	                                <span>
		                                <label id="arfother_sms_post" for="arfother_sms_post"><?php echo esc_html__('POST', 'ARForms-SMS'); ?></label>
		                            </span>
		                        </div>
							</td>
						</tr>
						<tr class="arfmainformfield" valign="top">
							<th class="arf-form-table-label"></th>
		                    <td class="arf-form-table-content">
		                        <div class="arf_parameter_field_input_wrapper_header">
		                            <span class="arf_parameter_field_input_wrapper_header_label"><?php echo addslashes(esc_html__('Parameter Name','ARForms-SMS')); ?></span>
		                            <span class="arf_parameter_field_input_wrapper_header_value"><?php echo addslashes(esc_html__('Parameter Value','ARForms-SMS')); ?></span>
		                        </div>
		                        <div class="arf_parameters_fields_input_wrapper arf_sms_large_input_fields">
		                        	<?php
		                        		$arfother_sms_parameters = isset($arf_sms_configuration['arf_sms_parameters']) ? $arf_sms_configuration['arf_sms_parameters'] : array();
		                        		$total_sms_parameters = count($arfother_sms_parameters);
		                        		if (!empty($arfother_sms_parameters)) {
			                        		foreach ($arfother_sms_parameters as $paramkey => $parameters) { 
			                        			?>

			                        			<div class='arf_parameters_field_input_container' id='arf_parameter_field_input_container_<?php echo $paramkey; ?>'>
				                        		
						                            <label class='arf_parameter_field_input_label' for='arf_parameter_field_input_<?php echo $paramkey; ?>'>
						                            	<input type='text' class='arf_large_input_box arf_parameter_field_label_input' name="arf_sms_configuration[arf_sms_parameters][<?php echo $paramkey; ?>][parameter_name]" value='<?php echo isset($parameters['parameter_name']) ? $parameters['parameter_name'] : ''; ?>' data-field-id='' id='arf_parameter_field_input_label_<?php echo $paramkey; ?>' />
						                            </label>
						                            <input type='text' name='arf_sms_configuration[arf_sms_parameters][<?php echo $paramkey; ?>][parameter_value]' class='arf_large_input_box' id='arf_parameter_field_input_<?php echo $paramkey; ?>' value='<?php echo isset($parameters['parameter_value']) ? $parameters['parameter_value'] : ''; ?>' />
						                            
						                            <div class='arf_parameter_field_input_action_button'>
						                                <span class="arf_add_parameter_field" id="arf_add_parameter_field">
						                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.134,20.362c-5.521,0-9.996-4.476-9.996-9.996 c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.13,15.887,16.654,20.362,11.134,20.362z M11.133,2.314c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.185,5.919,15.579,2.314,11.133,2.314z M12.146,14.341h-2v-3h-3v-2h3V6.372h2v2.969h3v2h-3V14.341z"/></g></svg>
						                                </span>
						                                <span class="arf_remove_parameter_field" id="arf_remove_parameter_field" data-id="<?php echo $paramkey; ?>">
						                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.12,20.389c-5.521,0-9.996-4.476-9.996-9.996c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.116,15.913,16.64,20.389,11.12,20.389zM11.119,2.341c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.17,5.945,15.565,2.341,11.119,2.341z M12.131,11.367h3v-2h-3h-2h-3v2h3H12.131z"/></g></svg>
						                                </span>
					                           		</div>
					                           	</div>
			                        		<?php } ?>
			                        			<input type="hidden" name="arf_sms_configuration[arf_total_sms_parameters]" id="arf_total_sms_parameters" value="<?php echo isset($total_sms_parameters) ? $total_sms_parameters : 1; ?>">
			                        		<?php 
			                        	}else{ ?>
				                        	<div class='arf_parameters_field_input_container' id='arf_parameter_field_input_container_0'>
				                        		
					                            <label class='arf_parameter_field_input_label' for='arf_parameter_field_input_0'>
					                            	<input type='text' class='arf_large_input_box arf_parameter_field_label_input' name="arf_sms_configuration[arf_sms_parameters][0][parameter_name]" value='' data-field-id='' id='arf_parameter_field_input_label_0' />
					                            </label>
					                            <input type='text' name='arf_sms_configuration[arf_sms_parameters][0][parameter_value]' class='arf_large_input_box' id='arf_parameter_field_input_0' value='' />
					                            <div class='arf_parameter_field_input_action_button'>
					                                <span class="arf_add_parameter_field" id="arf_add_parameter_field">
					                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.134,20.362c-5.521,0-9.996-4.476-9.996-9.996 c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.13,15.887,16.654,20.362,11.134,20.362z M11.133,2.314c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.185,5.919,15.579,2.314,11.133,2.314z M12.146,14.341h-2v-3h-3v-2h3V6.372h2v2.969h3v2h-3V14.341z"/></g></svg>
					                                </span>
					                                <span class="arf_remove_parameter_field" id="arf_remove_parameter_field" data-id="0">
					                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.12,20.389c-5.521,0-9.996-4.476-9.996-9.996c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.116,15.913,16.64,20.389,11.12,20.389zM11.119,2.341c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.17,5.945,15.565,2.341,11.119,2.341z M12.131,11.367h3v-2h-3h-2h-3v2h3H12.131z"/></g></svg>
					                                </span>
				                           		</div>
				                           	</div>
				                           	<input type="hidden" name="arf_sms_configuration[arf_total_sms_parameters]" id="arf_total_sms_parameters" value="1">
				                        <?php }
		                        	?>
		                        </div>
		                    </td>
						</tr>

						<tr class="arfmainformfield" valign="top">
		                    <td class="tdclass" id="arf_enable_log_switch_lbl" colspan="">
								<?php esc_html_e( 'Header Parameters', 'ARForms-SMS' ); ?>
							</td>
		                    <td class="tdclass">
		                        <div class="arf_enable_header_param">
		                        	<span class="arf_js_switch_wrapper">
		                        		<input type="checkbox" class="js-switch" name="arf_sms_configuration[arf_sms_enable_header_parameter]" id="arf_sms_enable_header_parameter" value="1" <?php isset($arf_sms_configuration['arf_sms_enable_header_parameter']) ? checked($arf_sms_configuration['arf_sms_enable_header_parameter'], '1') : ''; ?> />
										<span class="arf_js_switch"></span>
									</span>
		                        </div>
		                    </td>
		                </tr>
		                
		                <tr class="arfmainformfield arf_sms_header_parameter_main_wrapper <?php echo (!empty($arf_sms_configuration['arf_sms_enable_header_parameter']) && $arf_sms_configuration['arf_sms_enable_header_parameter'] == 1) ? '':'hidden_section';?>" valign="top">
							<th class="arf-form-table-label"></th>
		                    <td class="arf-form-table-content">
		                        <div class="arf_parameter_field_input_wrapper_header">
		                            <span class="arf_parameter_field_input_wrapper_header_label"><?php echo addslashes(esc_html__('Parameter Name','ARForms-SMS')); ?></span>
		                            <span class="arf_parameter_field_input_wrapper_header_value"><?php echo addslashes(esc_html__('Parameter Value','ARForms-SMS')); ?></span>
		                        </div>
		                        <div class="arf_header_parameters_fields_input_wrapper arf_sms_large_input_fields">
		                        	<?php
		                        		$arfother_sms_header_parameters = isset($arf_sms_configuration['arf_sms_header_parameters']) ? $arf_sms_configuration['arf_sms_header_parameters'] : array();
		                        		$total_sms_header_parameters = count($arfother_sms_header_parameters);
		                        		if (!empty($arfother_sms_header_parameters)) {
			                        		foreach ($arfother_sms_header_parameters as $paramkey => $parameters) { 
			                        			?>

			                        			<div class='arf_header_parameters_field_input_container' id='arf_header_parameter_field_input_container_<?php echo $paramkey; ?>'>
				                        			
						                            <label class='arf_parameter_field_input_label' for='arf_header_parameter_field_input_<?php echo $paramkey; ?>'>
						                            	<input type='text' class='arf_large_input_box arf_parameter_field_label_input' name="arf_sms_configuration[arf_sms_header_parameters][<?php echo $paramkey; ?>][header_parameter_name]" value='<?php echo isset($parameters['header_parameter_name']) ? $parameters['header_parameter_name'] : ''; ?>' data-field-id='' id='arf_header_parameter_field_input_label_<?php echo $paramkey; ?>' />
						                            </label>
						                            <input type='text' name='arf_sms_configuration[arf_sms_header_parameters][<?php echo $paramkey; ?>][header_parameter_value]' class='arf_large_input_box' id='arf_parameter_field_input_<?php echo $paramkey; ?>' value='<?php echo isset($parameters['header_parameter_value']) ? $parameters['header_parameter_value'] : ''; ?>' />
						                            
						                            <div class='arf_parameter_field_input_action_button'>
						                                <span class="arf_add_header_parameter_field" id="arf_add_header_parameter_field">
						                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.134,20.362c-5.521,0-9.996-4.476-9.996-9.996 c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.13,15.887,16.654,20.362,11.134,20.362z M11.133,2.314c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.185,5.919,15.579,2.314,11.133,2.314z M12.146,14.341h-2v-3h-3v-2h3V6.372h2v2.969h3v2h-3V14.341z"/></g></svg>
						                                </span>
						                                <span class="arf_remove_header_parameter_field" id="arf_remove_header_parameter_field" data-id="<?php echo $paramkey; ?>">
						                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.12,20.389c-5.521,0-9.996-4.476-9.996-9.996c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.116,15.913,16.64,20.389,11.12,20.389zM11.119,2.341c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.17,5.945,15.565,2.341,11.119,2.341z M12.131,11.367h3v-2h-3h-2h-3v2h3H12.131z"/></g></svg>
						                                </span>
					                           		</div>
					                           	</div>
			                        		<?php } ?>
			                        			<input type="hidden" name="arf_sms_configuration[arf_total_sms_header_parameters]" id="arf_total_sms_header_parameters" value="<?php echo isset($total_sms_header_parameters) ? $total_sms_header_parameters : 1; ?>">
			                        		<?php 
			                        	}else{ ?>
				                        	<div class='arf_header_parameters_field_input_container' id='arf_header_parameter_field_input_container_0'>
				                        		
					                            <label class='arf_parameter_field_input_label' for='arf_header_parameter_field_input_0'>
					                            	<input type='text' class='arf_large_input_box arf_parameter_field_label_input' name="arf_sms_configuration[arf_sms_header_parameters][0][header_parameter_name]" value='' data-field-id='' id='arf_header_parameter_field_input_label_0' />
					                            </label>
					                            <input type='text' name='arf_sms_configuration[arf_sms_header_parameters][0][header_parameter_value]' class='arf_large_input_box' id='arf_parameter_field_input_0' value='' />
					                            <div class='arf_parameter_field_input_action_button'>
					                                <span class="arf_add_header_parameter_field" id="arf_add_header_parameter_field">
					                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.134,20.362c-5.521,0-9.996-4.476-9.996-9.996 c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.13,15.887,16.654,20.362,11.134,20.362z M11.133,2.314c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.185,5.919,15.579,2.314,11.133,2.314z M12.146,14.341h-2v-3h-3v-2h3V6.372h2v2.969h3v2h-3V14.341z"/></g></svg>
					                                </span>
					                                <span class="arf_remove_header_parameter_field" id="arf_remove_header_parameter_field" data-id="0">
					                                	<svg viewBox="0 -4 32 32"><g id="email"><path fill-rule="evenodd" clip-rule="evenodd" fill="#3f74e7" d="M11.12,20.389c-5.521,0-9.996-4.476-9.996-9.996c0-5.521,4.476-9.997,9.996-9.997s9.996,4.476,9.996,9.997C21.116,15.913,16.64,20.389,11.12,20.389zM11.119,2.341c-4.446,0-8.051,3.604-8.051,8.051c0,4.447,3.604,8.052,8.051,8.052s8.052-3.604,8.052-8.052C19.17,5.945,15.565,2.341,11.119,2.341z M12.131,11.367h3v-2h-3h-2h-3v2h3H12.131z"/></g></svg>
					                                </span>
				                           		</div>
				                           	</div>
				                           	<input type="hidden" name="arf_sms_configuration[arf_total_sms_header_parameters]" id="arf_total_sms_header_parameters" value="1">
				                        <?php }
		                        	?>
		                        </div>
		                    </td>
						</tr>

						<tr class="arfmainformfield" valign="top">
								<td colspan="2"><div class="dotted_line"></div></td>
						</tr>
						<tr class="arfmainformfield" valign="top">
							<td class="lbltitle titleclass" id="arf_enable_log_switch_lbl" colspan="">
								<?php esc_html_e( 'Enable Debug Mode', 'ARForms-SMS' ); ?>&nbsp;
							</td>
		                    <td class="arf-form-table-content">
		                        <div class="arf_enable_log_switch_wrap">
		                        	<span class="arf_js_switch_wrapper">
		                        		<input type="checkbox" class="js-switch" name="arf_sms_configuration[arf_sms_enable_log]" id="arf_sms_enable_log" value="1" <?php isset($arf_sms_configuration['arf_sms_enable_log']) ? checked($arf_sms_configuration['arf_sms_enable_log'], '1') : ''; ?> />
										<span class="arf_js_switch"></span>
									</span>
		                        </div>
		                        <span class="arf_info_text"><br><?php esc_html_e("Logs will be stored at location:", 'ARForms-SMS'); echo "<code>". ARF_SMS_DIR . '/log/arf_sms_log.txt </code>' ; ?></span>
		                    </td>
		                </tr>
					</table>
				</div>
				<br />
				<p class="submit">
					<button class="rounded_button arf_btn_dark_blue arf_save_sms_setting_button" type="submit" ><?php esc_html_e( 'Save Changes', 'ARForms-SMS' ); ?></button>&nbsp;&nbsp;&nbsp;
					<span class="arf_sms_loader"></span>
				</p>
				<br />
			</form>
			<div class="documentation_link" align="right">
				<a target="_blank" href="<?php echo esc_url( ARF_SMS_URL . '/documentation/index.html' ); ?>" class="arlinks"><?php esc_html_e( 'SMS Documentation', 'ARForms-SMS' ); ?></a>
			</div>
		</div>
	</div>
</div>
