<?php

global $newarformssms_version,$wpdb, $arformssms;

if ( version_compare( $newarformssms_version, '1.2', '<' ) ) {
	$args = array(
		'role' => 'administrator',
		'fields' => 'id',
	);
	$users = get_users( $args );
	if ( count( $users ) > 0 ) {
		foreach ( $users as $key => $user_id ) {
			$userObj = new WP_User( $user_id );
			$authorizenetcapabilities = array(
				'arfsmsconfiguration' => esc_html__( 'Configure SMS Forms', 'ARForms-SMS' ),
			);
			$arfroles = $authorizenetcapabilities;

			foreach ( $arfroles as $arfrole => $arfroledescription ) {
				$userObj->add_cap( $arfrole );
			}
			unset( $arfrole );
			unset( $arfroles );
			unset( $arfroledescription );
		}
	}
}

if( version_compare( $newarformssms_version, '1.6', '<') ){
	$arf_sms_settings = get_option('arf_sms_configuration');

	$arf_sms_gateways_list = $arformssms->arf_sms_gateways_list();

	/* Old Values */
	$twilio_account_sid = !empty( $arf_sms_settings['twilio_account_sid'] ) ? $arf_sms_settings['twilio_account_sid'] : '';
	$twilio_auth_token = !empty( $arf_sms_settings['twilio_auth_token'] ) ? $arf_sms_settings['twilio_auth_token'] : '';
	$twilio_from_number = !empty( $arf_sms_settings['twilio_from_number'] ) ? $arf_sms_settings['twilio_from_number'] : '';

	$nexmo_api_key = !empty( $arf_sms_settings['nexmo_api_key'] ) ? $arf_sms_settings['nexmo_api_key'] : '';
	$nexmo_api_secret = !empty( $arf_sms_settings['nexmo_api_secret'] ) ? $arf_sms_settings['nexmo_api_secret'] : '';
	$nexmo_from_name = !empty( $arf_sms_settings['nexmo_from_name'] ) ? $arf_sms_settings['nexmo_from_name'] : '';

	$clickatell_api_id = !empty( $arf_sms_settings['clickatell_api_id'] ) ? $arf_sms_settings['clickatell_api_id'] : '';
	$clickatell_from_name = !empty( $arf_sms_settings['clickatell_from_name'] ) ? $arf_sms_settings['clickatell_from_name'] : '';

	$smsglobal_api_username = !empty( $arf_sms_settings['smsglobal_api_username'] ) ? $arf_sms_settings['smsglobal_api_username'] : '';
	$smsglobal_api_password = !empty( $arf_sms_settings['smsglobal_api_password'] ) ? $arf_sms_settings['smsglobal_api_password'] : '';
	$smsglobal_api_id =	!empty( $arf_sms_settings['smsglobal_api_id'] ) ? $arf_sms_settings['smsglobal_api_id'] : '';
	/* Old Values */

	$new_arf_sms_settings = array();

	foreach( $arf_sms_gateways_list as $gatewayKey => $gatewayVal ){
		if( !isset( $new_arf_sms_settings['arf_sms_gateways_settings'] ) ){
			$new_arf_sms_settings['arf_sms_gateways_settings'] = array();
		}
		if( 'arf_clickatell' == $gatewayKey ){
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['apiKey'] = $clickatell_api_id;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['from'] = $clickatell_from_name;
		} else if( 'arf_nexmo' == $gatewayKey ){
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['format'] = 'json';
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['api_key'] = $nexmo_api_key;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['api_secret'] = $nexmo_api_secret;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['from'] = $nexmo_from_name;
		} else if( 'arf_smsglobal' == $gatewayKey ){
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['action'] = 'sendsms';
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['user'] = $smsglobal_api_username;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['password'] = $smsglobal_api_password;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['from'] = $smsglobal_api_id;
		} else if( 'arf_twilio' == $gatewayKey ){
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['header']['account_sid'] = $twilio_account_sid;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['header']['auth_token'] = $twilio_auth_token;
			$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey]['From'] = $twilio_from_number;
		} else {
			switch( $gatewayKey ){
				case 'arf_redoxygen':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'AccountID' => '',
						'Email' => '',
						'Password' => ''
					);
				break;
				case 'arf_1s2u':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => ''
					);
				break;
				case 'arf_experttexting':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => '',
						'api_key' => '',
						'from' => ''
					);
				break;
				case 'arf_bearsms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'u' => '',
						'p' => '',
						'from' => ''
					);
				break;
				case 'arf_spirius':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'User' => '',
						'Pass' => '',
						'From' => ''
					);
				break;
				case 'arf_d7sms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => '',
						'from' => ''
					);
				break;
				case 'arf_eztexting':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'format' => 'json',
						'User' => '',
						'Password' => ''
					);
				break;
				case 'arf_ringcaptcha':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'app_key' => '',
						'api_key' => ''
					);
				break;
				case 'arf_bulksms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => ''
					);
				break;
				case 'arf_exotel':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'api_key' => '',
						'api_token' => '',
						'subdomain' => '',
						'account_sid' => '',
						'from' => ''
					);
				break;
				case 'arf_text_local':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'apiKey' => '',
						'sender' => ''
					);
				break;
				case 'arf_msg91':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'authkey' => '',
						'sender' => ''
					);
				break;
				case 'arf_textbelt':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'key' => ''
					);
				break;
				case 'arf_vianett':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => ''
					);
				break;
				case 'arf_textmarketer':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => '',
						'orig' => ''
					);
				break;
				case 'arf_swiftsmsgateway';
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'account_key' => ''
					);
				break;
				case 'arf_msgclub':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'AUTH_KEY' => '',
						'senderId' => ''
					);
				break;
				case 'arf_easysendsms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => '',
						'from' => ''
					);
				break;
				case 'arf_cheapglobalsms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'sub_account' => '',
						'sub_account_pass' => '',
						'sender_id' => ''
					);
				break;
				case 'arf_messente':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'username' => '',
						'password' => '',
						'from' => ''
					);
				break;
				case 'arf_messagebird':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'originator' => ''
					);
				break;
				case 'arf_telnyx':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => '',
						),
						'from' => ''
					);
				break;
				case 'arf_routee':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => '',
						),
						'from' => ''
					);
				break;
				case 'arf_wavecell':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => '',
						),
						'sub_account' => '',
						'source' => ''
					);
				break;
				case 'arf_engagespark':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'orgId' => '',
						'from' => ''
					);
				break;
				case 'arf_smsgatewaycenter':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'userId' => '',
						'password' => '',
						'sendMethod' => 'simpleMsg',
						'senderId' => '',
						'msgType' => 'text'
					);
				break;
				case 'arf_smsapi':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'from' => ''
					);
				break;
				case 'arf_fast2sms':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'sender_id' => '',
						'route' => 'p',
						'language' => 'unicode'
					);
				break;
				case 'arf_alcodes':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'is_otp' => '',
						'sender_id' => ''
					);
				break;
				case 'arf_movile':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'authenticationtoken' => '',
							'username' => ''
						)
					);
				break;
				case 'arf_telerivet':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => ''
						),
						'project_id' => ''
					);
				break;
				case 'arf_clicksend':
					$new_arf_sms_settings['arf_sms_gateways_settings'][$gatewayKey] = array(
						'header' => array(
							'account_sid' => '',
							'auth_token' => ''
						)
					);
				break;
			}
		}
	}

	$new_arf_sms_settings['other_sms_url'] = '';
	$new_arf_sms_settings['arf_sms_parameters'] = array(
		array(
			'parameter_name' => '',
			'parameter_value' => ''
		)
	);
	$new_arf_sms_settings['arf_total_sms_parameters'] = 1;
	$new_arf_sms_settings['arf_sms_enable_log'] = 0;

	update_option( 'arf_sms_configuration', $new_arf_sms_settings );


}
update_option( 'arf_sms_show_whats_new_popup', true );

update_option( 'arformssms_version', '1.8' );
global $newarformssms_version;
$newarformssms_version = '1.8';
